report 72107 PurchaseInvoiceDCR
{
    Caption = 'Purchase - Invoice';
    PreviewMode = PrintLayout;
    UsageCategory = None;

    dataset
    {
        dataitem(InvHdr; "Purch. Inv. Header")
        {
            DataItemTableView = sorting("No.");
            RequestFilterFields = "No.", "Buy-from Vendor No.", "No. Printed";
            RequestFilterHeading = 'Posted Purchase Invoice';

            column(BuyFromVendorNo; "Buy-from Vendor No.") { }
            column(CompanyAddr1; wgCompanyAddr[1]) { }
            column(CompanyAddr2; wgCompanyAddr[2]) { }
            column(CompanyAddr3; wgCompanyAddr[3]) { }
            column(CompanyAddr4; wgCompanyAddr[4]) { }
            column(CompanyAddr5; wgCompanyAddr[5]) { }
            column(CompanyAddr6; wgCompanyAddr[6]) { }
            column(CompanyBankAccNo; wgRecCompanyInfo."Bank Account No.") { }
            column(CompanyBankBranchNo; wgRecCompanyInfo."Bank Branch No.") { }
            column(CompanyBankName; wgRecCompanyInfo."Bank Name") { }
            column(CompanyCity; wgRecCompanyInfo.City) { }
            column(CompanyEMail; wgRecCompanyInfo."E-Mail") { }
            column(CompanyFaxNo; wgRecCompanyInfo."Fax No.") { }
            column(CompanyGiroNo; wgRecCompanyInfo."Giro No.") { }
            column(CompanyHomePage; wgRecCompanyInfo."Home Page") { }
            column(CompanyIBAN; wgRecCompanyInfo.IBAN) { }
            column(CompanyPhoneNo; wgRecCompanyInfo."Phone No.") { }
            column(CompanyPicture; wgRecCompanyInfo.Picture) { }
            column(CompanyRegistrationNo; wgRecCompanyInfo."Registration No.") { }
            column(CompanySWIFT; wgRecCompanyInfo."SWIFT Code") { }
            column(CompanyVATRegNo; wgRecCompanyInfo."VAT Registration No.") { }
            column(DocumentDate; "Document Date") { }
            column(DocumentDateText; Format("Document Date", 0, wgDateFormatHdr)) { }
            column(DocumentNo; "No.") { }
            column(DueDate; "Due Date") { }
            column(DueDateText; Format("Due Date", 0, wgDateFormatHdr)) { }
            column(HideLineDiscount; wgHideLineDiscount) { }
            column(LanguageCode; "Language Code") { }
            column(lblAllowInvDisc; Trl('AllowInvDisc')) { }
            column(lblAmount; Trl('Amount')) { }
            column(lblBankAccNo; Trl('BankAccNo')) { }
            column(lblBankBranchNo; Trl('BankBranchNo')) { }
            column(lblBankName; Trl('BankName')) { }
            column(lblBuyFromVendorNo; Trl('BuyFromVendorNo')) { }
            column(lblCompanyRegistrationNo; Trl('CompanyRegistrationNo')) { }
            column(lblDescription; Trl('Description')) { }
            column(lblDirectUnitCost; Trl('DirectUnitCost')) { }
            column(lblDocumentDate; Trl('DocumentDate')) { }
            column(lblDueDate; Trl('DueDate')) { }
            column(lblEmail; Trl('Email')) { }
            column(lblExternalDocumentNo; Trl('ExternalDocumentNo')) { }
            column(lblFaxNo; Trl('FaxNo')) { }
            column(lblFreeText1; Trl('FreeText1')) { }
            column(lblFreeText2; Trl('FreeText2')) { }
            column(lblFreeText3; Trl('FreeText3')) { }
            column(lblFreeText4; Trl('FreeText4')) { }
            column(lblGiroNo; Trl('GiroNo')) { }
            column(lblGLAccountNo; Trl('GLAccountNo')) { }
            column(lblHeaderDimensions; Trl('HeaderDimensions')) { }
            column(lblHomePage; Trl('HomePage')) { }
            column(lblIBAN; Trl('IBAN')) { }
            column(lblInvDiscAmount; Trl('InvDiscAmount')) { }
            column(lblInvDiscBaseAmount; Trl('InvDiscBaseAmount')) { }
            column(lblInvoiceDate; Trl('InvoiceDate')) { }
            column(lblInvoiceNo; Trl('InvoiceNo')) { }
            column(lblLineAmount; Trl('LineAmount')) { }
            column(lblLineDimensions; Trl('LineDimensions')) { }
            column(lblLineDiscountPerc; Trl('LineDiscountPerc')) { }
            column(lblNo; Trl('No')) { }
            column(lblOrderNo; Trl('OrderNo')) { }
            column(lblPageOf; Trl('Page{0}of{1}')) { }
            column(lblPaymentDiscountVAT; Trl('PaymentDiscountVAT')) { }
            column(lblPaymentTerms; Trl('PaymentTerms')) { }
            column(lblPayToAddress; Trl('PayToVendorAddress')) { }
            column(lblPayToVendorNo; Trl('PayToVendorNo')) { }
            column(lblPhoneNo; Trl('PhoneNo')) { }
            column(lblPostingDate; Trl('PostingDate')) { }
            column(lblPricesInclVAT; Trl('PricesInclVAT')) { }
            column(lblPurchPerson; Trl('PurchPerson')) { }
            column(lblQuantity; Trl('Quantity')) { }
            column(lblReceiptDate; Trl('ReceiptDate')) { }
            column(lblShipmentMethod; Trl('ShipmentMethod')) { }
            column(lblShipToAddress; Trl('ShipToAddress')) { }
            column(lblSubtotal; Trl('Subtotal')) { }
            column(lblSWIFT; Trl('SWIFT')) { }
            column(lblTotal; Trl('Total')) { }
            column(lblTotalTransFooter; Trl('TotalTransFooter')) { }
            column(lblTotalTransHeader; Trl('TotalTransHeader')) { }
            column(lblUOM; Trl('UOM')) { }
            column(lblVATAmount; Trl('VATAmount')) { }
            column(lblVATAmountSpecification; Trl('VATAmountSpecification')) { }
            column(lblVATBase; Trl('VATBase')) { }
            column(lblVATClause; Trl('VATClause')) { }
            column(lblVATIdentifier; Trl('VATIdentifier')) { }
            column(lblVATPerc; Trl('VATPerc')) { }
            column(lblVATRegistrationNo; Trl('VATRegistrationNo')) { }
            column(lblVendorInvoiceNo; Trl('VendorInvoiceNo')) { }
            column(lblYourReference; Trl('YourReference')) { }
            column(OrderNo; "Order No.") { }
            column(PaymentTermsDesc; wgRecPaymentTerms.Description) { }
            column(PayToAddr1; wgPayToVendAddr[1]) { }
            column(PayToAddr2; wgPayToVendAddr[2]) { }
            column(PayToAddr3; wgPayToVendAddr[3]) { }
            column(PayToAddr4; wgPayToVendAddr[4]) { }
            column(PayToAddr5; wgPayToVendAddr[5]) { }
            column(PayToAddr6; wgPayToVendAddr[6]) { }
            column(PayToAddr7; wgPayToVendAddr[7]) { }
            column(PayToAddr8; wgPayToVendAddr[8]) { }
            column(PayToVendorNo; "Pay-to Vendor No.") { }
            column(PostingDate; "Posting Date") { }
            column(PostingDateText; Format("Posting Date", 0, wgDateFormatHdr)) { }
            column(PrepaymentInvoice; "Prepayment Invoice") { }
            column(PrepaymentOrderNo; "Prepayment Order No.") { }
            column(PricesInclVAT; "Prices Including VAT") { }
            column(PricesInclVATYesNo; Format("Prices Including VAT")) { }
            column(SalesPurchPersonName; wgRecSalesPurchPerson.Name) { }
            column(ShipmentMethodDesc; wgRecShipmentMethod.Description) { }
            column(ShipToAddr1; wgShipToAddr[1]) { }
            column(ShipToAddr2; wgShipToAddr[2]) { }
            column(ShipToAddr3; wgShipToAddr[3]) { }
            column(ShipToAddr4; wgShipToAddr[4]) { }
            column(ShipToAddr5; wgShipToAddr[5]) { }
            column(ShipToAddr6; wgShipToAddr[6]) { }
            column(ShipToAddr7; wgShipToAddr[7]) { }
            column(ShipToAddr8; wgShipToAddr[8]) { }
            column(TodayText; Format(Today(), 0, wgDateFormatHdr)) { }
            column(TotalExclVATText; wgTotalExclVATText) { }
            column(TotalInclVATText; wgTotalInclVATText) { }
            column(TotalText; wgTotalText) { }
            column(VALExchRate; wgVALExchRate) { }
            column(VALSpecLCYHeader; wgVALSpecLCYHeader) { }
            column(VATBaseDiscPerc; "VAT Base Discount %")
            {
                AutoFormatType = 1;
            }
            column(VATRegNo; "VAT Registration No.") { }
            column(VendorInvoiceNo; "Vendor Invoice No.") { }
            column(YourReference; "Your Reference") { }

            dataitem(CopyLoop; "Integer")
            {
                DataItemTableView = sorting(Number);

                column(OutputNo; wgOutputNo) { }
                column(PurchInvoiceTitle; StrSubstNo(wlFncDocumentCaption(), wgCopyText)) { }

                dataitem(HdrComment; "Purch. Comment Line")
                {
                    DataItemLink = "No." = Field("No.");
                    DataItemLinkReference = InvHdr;
                    DataItemTableView = sorting("Document Type", "No.", "Document Line No.", "Line No.") where("Document Type" = const("Posted Invoice"), "Document Line No." = const(0));

                    column(Comment_2; Comment) { }

                    trigger OnPreDataItem()
                    begin
                        if not wgShowInternalInfo then
                            CurrReport.Break();
                    end;
                }
                dataitem(HeaderDim; "Dimension Set Entry")
                {
                    DataItemLink = "Dimension Set ID" = Field("Dimension Set ID");
                    DataItemLinkReference = InvHdr;
                    DataItemTableView = sorting("Dimension Set ID", "Dimension Code");

                    column(DimText; wgDimText) { }

                    trigger OnAfterGetRecord()
                    begin
                        wgCduwDCR_ReportFunctions.wgFncGetDimText(HeaderDim, wgDimText);
                    end;

                    trigger OnPreDataItem()
                    begin
                        if not wgShowInternalInfo then
                            CurrReport.Break();
                    end;
                }
                dataitem(InvLine; "Purch. Inv. Line")
                {
                    DataItemTableView = sorting("Document No.", "Line No.");
                    UseTemporary = true;

                    column(Amount; Amount)
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(AmountInclVAT; "Amount Including VAT")
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(Description; Description) { }
                    column(DirectUnitCost; "Direct Unit Cost")
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 2;
                    }
                    column(InvDiscAmount; -"Inv. Discount Amount")
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(LineAmount; "Line Amount")
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(LineDiscPerc; "Line Discount %") { }
                    column(No_2; "No.") { }
                    column(Quantity; Quantity) { }
                    column(Type; Format(Type)) { }
                    column(TypeNo; Type.AsInteger()) { }
                    column(UOM; wgCduwDCR_TranslationMgt.wgFncGetUnitOfMeaseTrl("Unit of Measure Code")) { }
                    column(VATIdentifier; "VAT Identifier") { }

                    dataitem(LineComment; "Purch. Comment Line")
                    {
                        DataItemLink = "No." = Field("Document No."), "Document Line No." = Field("Line No.");
                        DataItemTableView = sorting("Document Type", "No.", "Document Line No.", "Line No.") where("Document Type" = const("Posted Invoice"));

                        column(Comment; Comment) { }

                        trigger OnPreDataItem()
                        begin
                            if not wgShowInternalInfo then
                                CurrReport.Break();
                        end;
                    }
                    dataitem(LineDim; "Dimension Set Entry")
                    {
                        DataItemLink = "Dimension Set ID" = Field("Dimension Set ID");
                        DataItemTableView = sorting("Dimension Set ID", "Dimension Code");

                        column(DimText_2; wgDimText) { }

                        trigger OnAfterGetRecord()
                        begin
                            wgCduwDCR_ReportFunctions.wgFncGetDimText(LineDim, wgDimText);
                        end;

                        trigger OnPreDataItem()
                        begin
                            if not wgShowInternalInfo then
                                CurrReport.Break();
                        end;
                    }

                    trigger OnAfterGetRecord()
                    begin
                        if not InvHdr."Prices Including VAT" and
                           (InvLine."VAT Calculation Type" = InvLine."VAT Calculation Type"::"Full VAT")
                        then
                            InvLine."Line Amount" := 0;

                        if (InvLine.Type = InvLine.Type::"G/L Account") and (not wgShowInternalInfo) then
                            InvLine."No." := '';
                    end;

                    trigger OnPreDataItem()
                    var
                        wlMoreLines: Boolean;
                    begin
                        Reset();
                        wlMoreLines := InvLine.Find('+');
                        while wlMoreLines and (InvLine.Description = '') and (InvLine."Description 2" = '') and
                              (InvLine."No." = '') and (InvLine.Quantity = 0) and
                              (InvLine.Amount = 0)
                        do
                            wlMoreLines := InvLine.Next(-1) <> 0;
                        if not wlMoreLines then
                            CurrReport.Break();
                        InvLine.SetRange("Line No.", 0, InvLine."Line No.");
                    end;
                }
                dataitem(VATAmtLine; "VAT Amount Line")
                {
                    DataItemTableView = sorting("VAT Identifier", "VAT Calculation Type", "Tax Group Code", "Use Tax", Positive);
                    UseTemporary = true;

                    column(InvDiscAmount_2; "Invoice Discount Amount")
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(InvDiscBaseAmount; "Inv. Disc. Base Amount")
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(LineAmount_2; "Line Amount")
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(VATAmount; "VAT Amount")
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(VATBase; "VAT Base")
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(VATIdentifier_2; "VAT Identifier") { }
                    column(VATPerc; "VAT %")
                    {
                        DecimalPlaces = 0 : 5;
                    }

                    trigger OnPreDataItem()
                    begin
                        if wgTotVATAmount = 0 then
                            CurrReport.Break();

                        Reset();
                    end;
                }
                dataitem(VATClause; "VAT Amount Line")
                {
                    DataItemTableView = sorting("VAT Identifier", "VAT Calculation Type", "Tax Group Code", "Use Tax", Positive);
                    UseTemporary = true;
                    column(Description2; wgRecVATClause."Description 2") { }

                    column(Description_4; wgRecVATClause.Description) { }
                    column(VATAmount_4; "VAT Amount") { }
                    column(VATClauseCode; "VAT Clause Code") { }
                    column(VATIdentifier_4; "VAT Identifier") { }

                    trigger OnAfterGetRecord()
                    begin
                        if "VAT Clause Code" = '' then
                            CurrReport.Skip();
                        if wgRecVATClause.Code <> "VAT Clause Code" then
                            if not wgRecVATClause.Get("VAT Clause Code") then
                                CurrReport.Skip();

                        wgRecVATClause.TranslateDescription(InvHdr."Language Code");
                    end;

                    trigger OnPreDataItem()
                    begin
                        Copy(VATAmtLine, true); //Set VATClause to VATAmtLine
                        Reset();
                    end;
                }
                dataitem(VATAmtLineLCY; "VAT Amount Line")
                {
                    DataItemTableView = sorting("VAT Identifier", "VAT Calculation Type", "Tax Group Code", "Use Tax", Positive);
                    UseTemporary = true;
                    column(VALVATAmountLCY; wgVALVATAmountLCY)
                    {
                        AutoFormatType = 1;
                    }

                    column(VALVATBaseLCY; wgVALVATBaseLCY)
                    {
                        AutoFormatType = 1;
                    }
                    column(VATIdentifier_3; "VAT Identifier") { }
                    column(VATPerc_2; "VAT %")
                    {
                        DecimalPlaces = 0 : 5;
                    }

                    trigger OnAfterGetRecord()
                    begin
                        wgVALVATBaseLCY :=
                          VATAmtLine.GetBaseLCY(
                            InvHdr."Posting Date", InvHdr."Currency Code", InvHdr."Currency Factor");
                        wgVALVATAmountLCY :=
                          VATAmtLine.GetAmountLCY(
                            InvHdr."Posting Date", InvHdr."Currency Code", InvHdr."Currency Factor");

                        wgTotVALVATBaseLCY += wgVALVATBaseLCY;
                        wgTotVALVATAmountLCY += wgVALVATAmountLCY;
                    end;

                    trigger OnPreDataItem()
                    begin
                        if not wgShowVATLCY then
                            CurrReport.Break();

                        Copy(VATAmtLine, true); //Set VATAmtLineLCY to VATAmtLine
                        Reset();
                    end;
                }
                dataitem(Total; "Integer")
                {
                    DataItemTableView = sorting(Number) where(Number = const(1));

                    column(MonolithicVAT; wgMonolithicVAT) { }
                    column(NoOfVATAmtLines; wgNoOfVATAmountLines) { }
                    column(TotAmount; wgTotAmount)
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(TotInvDiscAmount; wgTotInvDiscAmount) { }
                    column(TotInvDiscBaseAmount; wgTotInvDiscBaseAmount) { }
                    column(TotLineAmount; wgTotLineAmount) { }
                    column(TotPaymentDiscOnVAT; wgTotPaymentDiscOnVAT)
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(TotVALVATAmountLCY; wgTotVALVATAmountLCY) { }
                    column(TotVALVATBaseLCY; wgTotVALVATBaseLCY) { }
                    column(TotVATAmount; wgTotVATAmount)
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(VATAmtText; wgVATAmountText) { }

                    trigger OnAfterGetRecord()
                    begin
                        wgNoOfVATAmountLines := VATAmtLine.Count();
                        wgMonolithicVAT := wgCduwDCR_ReportFunctions.wgFncIsMonolithicVAT(VATAmtLine);
                        if wgMonolithicVAT then
                            wgVATAmountText := CopyStr(StrSubstNo(Trl('TotalVATAmount%1Perc'), VATAmtLine."VAT %"), 1, 30)
                        else
                            wgVATAmountText := CopyStr(Trl('TotalVATAmount'), 1, 30);
                    end;
                }

                trigger OnAfterGetRecord()
                begin
                    if Number > 1 then begin
                        wgCopyText := CopyStr(Trl('Copy'), 1, MaxStrLen(wgCopyText));
                        wgOutputNo += 1;
                    end;

                    wgTotVALVATBaseLCY := 0;
                    wgTotVALVATAmountLCY := 0;
                end;

                trigger OnPostDataItem()
                begin
                    if not CurrReport.Preview() then
                        Codeunit.Run(Codeunit::"Purch. Inv.-Printed", InvHdr);
                end;

                trigger OnPreDataItem()
                begin
                    wgNoOfLoops := Abs(wgNoOfCopies) + 1;
                    wgCopyText := '';
                    SetRange(Number, 1, wgNoOfLoops);
                    wgOutputNo := 1;
                end;
            }

            trigger OnAfterGetRecord()
            var
                wlRecRef: RecordRef;
            begin
                CurrReport.Language := wgCduLanguage.GetLanguageIdOrDefault("Language Code");
                wgCduwDCR_TranslationMgt.wgFncSetLanguageCode("Language Code");

                wlFncFormatAddressFields(InvHdr);
                wlFncFormatDocumentFields(InvHdr);

                if wgLogInteraction then
                    if not CurrReport.Preview() then
                        wgCduSegManagement.LogDocument(
                          14, "No.", 0, 0, Database::Vendor, "Buy-from Vendor No.", "Purchaser Code", '', "Posting Description", '');

                //Get Invoice Lines
                InvLine.Reset();
                InvLine.DeleteAll();
                VATAmtLine.Reset();
                VATAmtLine.DeleteAll();
                wlFncGetPurchInvoiceLines(InvHdr, InvLine);

                //Get VAT Amount Lines
                InvLine.CalcVATAmountLines(InvHdr, VATAmtLine);
                wgTotInvDiscAmount := VATAmtLine.GetTotalInvDiscAmount();
                wgTotInvDiscBaseAmount := VATAmtLine.GetTotalInvDiscBaseAmount(InvHdr."Prices Including VAT", InvHdr."Currency Code");
                wgTotLineAmount := VATAmtLine.GetTotalLineAmount(InvHdr."Prices Including VAT", InvHdr."Currency Code");
                wgTotVATAmount := VATAmtLine.GetTotalVATAmount();
                wgTotPaymentDiscOnVAT := -(wgTotLineAmount - wgTotInvDiscAmount - VATAmtLine.GetTotalAmountInclVAT());
                wgTotAmount := VATAmtLine.GetTotalVATBase();

                //Prepare VAT Amount Lines LCY
                if (not wgRecGLSetup."Print VAT specification in LCY") or
                   (InvHdr."Currency Code" = '') or
                   (VATAmtLine.GetTotalVATAmount() = 0)
                then begin
                    wgShowVATLCY := false;
                    wgVALSpecLCYHeader := '';
                    wgVALExchRate := '';
                end
                else begin
                    wgShowVATLCY := true;
                    if wgRecGLSetup."LCY Code" = '' then
                        wgVALSpecLCYHeader := Trl('VATAmtSpecIn') + ' ' + Trl('LocalCurrency')
                    else
                        wgVALSpecLCYHeader := Trl('VATAmtSpecIn') + ' ' + Format(wgRecGLSetup."LCY Code");
                    wgRecCurrExchRate.FindCurrency(InvHdr."Posting Date", InvHdr."Currency Code", 1);
                    wgVALExchRate := CopyStr(StrSubstNo(Trl('ExchangeRate%1/%2'), wgRecCurrExchRate."Relational Exch. Rate Amount", wgRecCurrExchRate."Exchange Rate Amount"), 1, 50);
                end;

                //Set HideLineDiscount
                wlRecRef.GetTable(InvHdr);
                wgHideLineDiscount := wgCduwDCR_ReportFunctions.wgFncHideLineDiscount(wlRecRef);
            end;
        }
    }

    requestpage
    {
        SaveValues = true;

        layout
        {
            area(content)
            {
                group(Options)
                {
                    Caption = 'Options';
                    field(NoOfCopies; wgNoOfCopies)
                    {
                        ApplicationArea = All;
                        Caption = 'No. of Copies';
                    }
                    field(ShowInternalInfo; wgShowInternalInfo)
                    {
                        ApplicationArea = All;
                        Caption = 'Show Internal Information';
                    }
                    field(LogInteraction; wgLogInteraction)
                    {
                        ApplicationArea = All;
                        Caption = 'Log Interaction';
                        Enabled = wgLogInteractionEnable;
                    }
                }
            }
        }

        trigger OnInit()
        begin
            wgLogInteractionEnable := true;
        end;

        trigger OnOpenPage()
        begin
            wgLogInteraction := wgCduSegManagement.FindInteractTmplCode(14) <> '';

            wgLogInteractionEnable := wgLogInteraction;

            wgNoOfCopies := 0;
        end;
    }

    trigger OnInitReport()
    begin
        wgRecGLSetup.Get();

        wgRecSalesSetup.Get();

        wgRecCompanyInfo.Get();

        if wgRecSalesSetup."Logo Position on Documents" <> wgRecSalesSetup."Logo Position on Documents"::"No Logo" then
            wgRecCompanyInfo.CalcFields(Picture);
    end;

    trigger OnPreReport()
    begin
        wlFncInitReportSettings();
        if not CurrReport.UseRequestPage() then
            wgNoOfCopies := 0;
    end;

    var
        wgRecCompanyInfo: Record "Company Information";
        wgRecCurrExchRate: Record "Currency Exchange Rate";
        wgRecGLSetup: Record "General Ledger Setup";
        wgRecPaymentTerms: Record "Payment Terms";
        wgRecSalesSetup: Record "Sales & Receivables Setup";
        wgRecSalesPurchPerson: Record "Salesperson/Purchaser";
        wgRecShipmentMethod: Record "Shipment Method";
        wgRecVATClause: Record "VAT Clause";
        wgCduFormatAddr: Codeunit "Format Address";
        wgCduFormatDoc: Codeunit "Format Document";
        wgCduLanguage: Codeunit Language;
        wgCduSegManagement: Codeunit SegManagement;
        wgCduwDCR_ReportFunctions: Codeunit wDCR_ReportFunctions;
        wgCduwDCR_TranslationMgt: Codeunit wDCR_TranslationMgt;
        wgHideLineDiscount: Boolean;
        wgLogInteraction: Boolean;
        [InDataSet]
        wgLogInteractionEnable: Boolean;
        wgMonolithicVAT: Boolean;
        wgShowInternalInfo: Boolean;
        wgShowVATLCY: Boolean;
        wgTotAmount: Decimal;
        wgTotInvDiscAmount: Decimal;
        wgTotInvDiscBaseAmount: Decimal;
        wgTotLineAmount: Decimal;
        wgTotPaymentDiscOnVAT: Decimal;
        wgTotVALVATAmountLCY: Decimal;
        wgTotVALVATBaseLCY: Decimal;
        wgTotVATAmount: Decimal;
        wgVALVATAmountLCY: Decimal;
        wgVALVATBaseLCY: Decimal;
        wgDateFormatHdr: Integer;
        wgNoOfCopies: Integer;
        wgNoOfLoops: Integer;
        wgNoOfVATAmountLines: Integer;
        wgOutputNo: Integer;
        wgReportId: Integer;
        wgCompanyInfoFaxNo: Text;
        wgCompanyInfoPhoneNo: Text;
        wgCopyText: Text[30];
        wgVATAmountText: Text[30];
        wgTotalExclVATText: Text[50];
        wgTotalInclVATText: Text[50];
        wgTotalText: Text[50];
        wgVALExchRate: Text[50];
        wgVALSpecLCYHeader: Text[80];
        wgCompanyAddr: array[8] of Text[100];
        wgPayToVendAddr: array[8] of Text[100];
        wgShipToAddr: array[8] of Text[100];
        wgDimText: Text[120];

    procedure InitializeRequest(pNewNoOfCopies: Integer; pNewShowInternalInfo: Boolean; pNewLogInteraction: Boolean)
    begin
        wgNoOfCopies := pNewNoOfCopies;
        wgShowInternalInfo := pNewShowInternalInfo;
        wgLogInteraction := pNewLogInteraction;
    end;

    local procedure Trl(pLblName: Text[50]): Text
    begin
        exit(wgCduwDCR_TranslationMgt.wgFncTranslate(pLblName));
    end;

    local procedure wlFncDocumentCaption(): Text[250]
    begin
        if InvHdr."Prepayment Invoice" then
            exit(CopyStr(Trl('PurchPrepaymentInvoice%1'), 1, 250));
        exit(CopyStr(Trl('PurchInvoice%1'), 1, 250));
    end;

    local procedure wlFncFormatAddressFields(var vRecPurchInvHeader: Record "Purch. Inv. Header")
    var
        wlRecRespCenter: Record "Responsibility Center";
    begin
        wgCduFormatAddr.GetCompanyAddr(vRecPurchInvHeader."Responsibility Center", wlRecRespCenter, wgRecCompanyInfo, wgCompanyAddr);
        wgCompanyInfoPhoneNo := wgRecCompanyInfo."Phone No.";
        wgCompanyInfoFaxNo := wgRecCompanyInfo."Fax No.";
        wgCduFormatAddr.PurchInvPayTo(wgPayToVendAddr, vRecPurchInvHeader);
        wgCduFormatAddr.PurchInvShipTo(wgShipToAddr, vRecPurchInvHeader);
    end;

    local procedure wlFncFormatDocumentFields(pRecPurchInvHeader: Record "Purch. Inv. Header")
    var
        wlCurrencyCode: Code[10];
        wlPurchPersonText: Text[50];
    begin
        wlCurrencyCode := pRecPurchInvHeader."Currency Code";
        if wlCurrencyCode = '' then begin
            wgRecGLSetup.TestField("LCY Code");
            wlCurrencyCode := wgRecGLSetup."LCY Code";
        end;
        wgTotalText := CopyStr(StrSubstNo(Trl('Total%1'), wlCurrencyCode), 1, MaxStrLen(wgTotalText));
        wgTotalInclVATText := CopyStr(StrSubstNo(Trl('Total%1InclVAT'), wlCurrencyCode), 1, MaxStrLen(wgTotalInclVATText));
        wgTotalExclVATText := CopyStr(StrSubstNo(Trl('Total%1ExclVAT'), wlCurrencyCode), 1, MaxStrLen(wgTotalExclVATText));
        wgCduFormatDoc.SetPurchaser(wgRecSalesPurchPerson, pRecPurchInvHeader."Purchaser Code", wlPurchPersonText);
        wgCduFormatDoc.SetPaymentTerms(wgRecPaymentTerms, pRecPurchInvHeader."Payment Terms Code", pRecPurchInvHeader."Language Code");
        wgCduFormatDoc.SetShipmentMethod(wgRecShipmentMethod, pRecPurchInvHeader."Shipment Method Code", pRecPurchInvHeader."Language Code");
    end;

    local procedure wlFncGetPurchInvoiceLines(var vRecPurchInvHeader: Record "Purch. Inv. Header"; var vRecPurchInvLine: Record "Purch. Inv. Line")
    var
        wlRecPurchInvLine: Record "Purch. Inv. Line";
    begin
        wlRecPurchInvLine.SetRange("Document No.", vRecPurchInvHeader."No.");
        if wlRecPurchInvLine.FindSet() then
            repeat
                vRecPurchInvLine := wlRecPurchInvLine;
                vRecPurchInvLine.Insert();
            until wlRecPurchInvLine.Next() = 0;
    end;

    local procedure wlFncInitReportSettings()
    var
        wlCduTemplateReportHelperDCR: Codeunit TemplateReportHelperDCR;
    begin
        if wgReportId = 0 then
            Evaluate(wgReportId, (DelChr(CurrReport.ObjectId(false), '=', DelChr(CurrReport.ObjectId(false), '=', '1234567890'))));
        wgCduwDCR_TranslationMgt.wgFncSetReportId(wgReportId);
        wgDateFormatHdr := wlCduTemplateReportHelperDCR.wgFncGetHeaderDateFormat(wgReportId);
    end;
}
