report 72140 PurchaseRetOrderDCR
{
    Caption = 'Purchase - Return Order';
    PreviewMode = PrintLayout;
    UsageCategory = None;

    dataset
    {
        dataitem(PurchHdr; "Purchase Header")
        {
            DataItemTableView = sorting("Document Type", "No.") where("Document Type" = const("Return Order"));
            RequestFilterFields = "No.", "Buy-from Vendor No.", "No. Printed";
            RequestFilterHeading = 'Purchase Return Order';

            column(BuyFromAddr1; wgBuyFromAddr[1]) { }
            column(BuyFromAddr2; wgBuyFromAddr[2]) { }
            column(BuyFromAddr3; wgBuyFromAddr[3]) { }
            column(BuyFromAddr4; wgBuyFromAddr[4]) { }
            column(BuyFromAddr5; wgBuyFromAddr[5]) { }
            column(BuyFromAddr6; wgBuyFromAddr[6]) { }
            column(BuyFromAddr7; wgBuyFromAddr[7]) { }
            column(BuyFromAddr8; wgBuyFromAddr[8]) { }
            column(BuyFromVendorNo; "Buy-from Vendor No.") { }
            column(CompanyAddr1; wgCompanyAddr[1]) { }
            column(CompanyAddr2; wgCompanyAddr[2]) { }
            column(CompanyAddr3; wgCompanyAddr[3]) { }
            column(CompanyAddr4; wgCompanyAddr[4]) { }
            column(CompanyAddr5; wgCompanyAddr[5]) { }
            column(CompanyAddr6; wgCompanyAddr[6]) { }
            column(CompanyBankAccNo; wgRecCompanyInfo."Bank Account No.") { }
            column(CompanyBankBranchNo; wgRecCompanyInfo."Bank Branch No.") { }
            column(CompanyBankName; wgRecCompanyInfo."Bank Name") { }
            column(CompanyCity; wgRecCompanyInfo.City) { }
            column(CompanyEMail; wgRecCompanyInfo."E-Mail") { }
            column(CompanyFaxNo; wgRecCompanyInfo."Fax No.") { }
            column(CompanyGiroNo; wgRecCompanyInfo."Giro No.") { }
            column(CompanyHomePage; wgRecCompanyInfo."Home Page") { }
            column(CompanyIBAN; wgRecCompanyInfo.IBAN) { }
            column(CompanyPhoneNo; wgRecCompanyInfo."Phone No.") { }
            column(CompanyPicture; wgRecCompanyInfo.Picture) { }
            column(CompanyRegistrationNo; wgRecCompanyInfo."Registration No.") { }
            column(CompanySWIFT; wgRecCompanyInfo."SWIFT Code") { }
            column(CompanyVATRegNo; wgRecCompanyInfo."VAT Registration No.") { }
            column(DocumentDate; "Document Date") { }
            column(DocumentDateText; Format("Document Date", 0, wgDateFormatHdr)) { }
            column(DocumentNo; "No.") { }
            column(DueDate; "Due Date") { }
            column(DueDateText; Format("Due Date", 0, wgDateFormatHdr)) { }
            column(HideLineDiscount; wgHideLineDiscount) { }
            column(LanguageCode; "Language Code") { }
            column(lblAllowInvDisc; Trl('AllowInvDisc')) { }
            column(lblAmount; Trl('Amount')) { }
            column(lblBankAccNo; Trl('BankAccNo')) { }
            column(lblBankBranchNo; Trl('BankBranchNo')) { }
            column(lblBankName; Trl('BankName')) { }
            column(lblBuyFromAddress; Trl('BuyFromAddress')) { }
            column(lblBuyFromVendorNo; Trl('BuyFromVendorNo')) { }
            column(lblCompanyRegistrationNo; Trl('CompanyRegistrationNo')) { }
            column(lblDescription; Trl('Description')) { }
            column(lblDirectUnitCost; Trl('DirectUnitCost')) { }
            column(lblDocumentDate; Trl('DocumentDate')) { }
            column(lblDueDate; Trl('DueDate')) { }
            column(lblEmail; Trl('Email')) { }
            column(lblExpectedReceiptDate; Trl('ExpectedReceiptDate')) { }
            column(lblFaxNo; Trl('FaxNo')) { }
            column(lblFreeText1; Trl('FreeText1')) { }
            column(lblFreeText2; Trl('FreeText2')) { }
            column(lblFreeText3; Trl('FreeText3')) { }
            column(lblFreeText4; Trl('FreeText4')) { }
            column(lblGiroNo; Trl('GiroNo')) { }
            column(lblGLAccountNo; Trl('GLAccountNo')) { }
            column(lblHeaderDimensions; Trl('HeaderDimensions')) { }
            column(lblHomePage; Trl('HomePage')) { }
            column(lblIBAN; Trl('IBAN')) { }
            column(lblInvDiscAmount; Trl('InvDiscAmount')) { }
            column(lblInvDiscBaseAmount; Trl('InvDiscBaseAmount')) { }
            column(lblInvoiceDate; Trl('InvoiceDate')) { }
            column(lblInvoiceNo; Trl('InvoiceNo')) { }
            column(lblLineAmount; Trl('LineAmount')) { }
            column(lblLineDimensions; Trl('LineDimensions')) { }
            column(lblLineDiscountPerc; Trl('LineDiscountPerc')) { }
            column(lblLotNo; Trl('LotNo')) { }
            column(lblNo; Trl('No')) { }
            column(lblPageOf; Trl('Page{0}of{1}')) { }
            column(lblPaymentDiscountVAT; Trl('PaymentDiscountVAT')) { }
            column(lblPaymentTerms; Trl('PaymentTerms')) { }
            column(lblPayToAddress; Trl('PayToVendorAddress')) { }
            column(lblPayToVendorNo; Trl('PayToVendorNo')) { }
            column(lblPhoneNo; Trl('PhoneNo')) { }
            column(lblPostingDate; Trl('PostingDate')) { }
            column(lblPrepaymentPayementTerms; Trl('PrepaymentPaymentTerms')) { }
            column(lblPrepaymentSpecification; Trl('PrepaymentSpecification')) { }
            column(lblPrepaymentVATSpecification; Trl('PrepaymentVATSpecification')) { }
            column(lblPricesInclVAT; Trl('PricesInclVAT')) { }
            column(lblPromisedReceiptDate; Trl('PromisedReceiptDate')) { }
            column(lblPurchPerson; Trl('PurchPerson')) { }
            column(lblQuantity; Trl('Quantity')) { }
            column(lblRequestedReceiptDate; Trl('RequestedReceiptDate')) { }
            column(lblReturnOrderNo; Trl('ReturnOrderNo')) { }
            column(lblSerialNo; Trl('SerialNo')) { }
            column(lblShipmentMethod; Trl('ShipmentMethod')) { }
            column(lblShipToAddress; Trl('ShipToAddress')) { }
            column(lblSubtotal; Trl('Subtotal')) { }
            column(lblSWIFT; Trl('SWIFT')) { }
            column(lblTotal; Trl('Total')) { }
            column(lblTotalTransFooter; Trl('TotalTransFooter')) { }
            column(lblTotalTransHeader; Trl('TotalTransHeader')) { }
            column(lblUOM; Trl('UOM')) { }
            column(lblVATAmount; Trl('VATAmount')) { }
            column(lblVATAmountSpecification; Trl('VATAmountSpecification')) { }
            column(lblVATBase; Trl('VATBase')) { }
            column(lblVATIdentifier; Trl('VATIdentifier')) { }
            column(lblVATPerc; Trl('VATPerc')) { }
            column(lblVATRegistrationNo; Trl('VATRegistrationNo')) { }
            column(lblYourReference; Trl('YourReference')) { }
            column(PaymentTermsDesc; wgRecPaymentTerms.Description) { }
            column(PayToAddr1; wgPayToVendAddr[1]) { }
            column(PayToAddr2; wgPayToVendAddr[2]) { }
            column(PayToAddr3; wgPayToVendAddr[3]) { }
            column(PayToAddr4; wgPayToVendAddr[4]) { }
            column(PayToAddr5; wgPayToVendAddr[5]) { }
            column(PayToAddr6; wgPayToVendAddr[6]) { }
            column(PayToAddr7; wgPayToVendAddr[7]) { }
            column(PayToAddr8; wgPayToVendAddr[8]) { }
            column(PayToVendorNo; "Pay-to Vendor No.") { }
            column(PostingDate; "Posting Date") { }
            column(PostingDateText; Format("Posting Date", 0, wgDateFormatHdr)) { }
            column(PrepmtPaymentTermsDesc; wgRecPrepmtPaymentTerms.Description) { }
            column(PricesInclVAT; "Prices Including VAT") { }
            column(PricesInclVATYesNo; Format("Prices Including VAT")) { }
            column(SalesPurchPersonName; wgRecSalesPurchPerson.Name) { }
            column(SelltoCustNo; "Sell-to Customer No.") { }
            column(ShipmentMethodDesc; wgRecShipmentMethod.Description) { }
            column(ShipToAddr1; wgShipToAddr[1]) { }
            column(ShipToAddr2; wgShipToAddr[2]) { }
            column(ShipToAddr3; wgShipToAddr[3]) { }
            column(ShipToAddr4; wgShipToAddr[4]) { }
            column(ShipToAddr5; wgShipToAddr[5]) { }
            column(ShipToAddr6; wgShipToAddr[6]) { }
            column(ShipToAddr7; wgShipToAddr[7]) { }
            column(ShipToAddr8; wgShipToAddr[8]) { }
            column(TodayText; Format(Today(), 0, wgDateFormatHdr)) { }
            column(TotalExclVATText; wgTotalExclVATText) { }
            column(TotalInclVATText; wgTotalInclVATText) { }
            column(TotalText; wgTotalText) { }
            column(VALExchRate; wgVALExchRate) { }
            column(VALSpecLCYHeader; wgVALSpecLCYHeader) { }
            column(VATBaseDiscPerc; "VAT Base Discount %")
            {
                AutoFormatType = 1;
            }
            column(VATRegNo; "VAT Registration No.") { }
            column(YourReference; "Your Reference") { }

            dataitem(CopyLoop; "Integer")
            {
                DataItemTableView = sorting(Number);

                column(OutputNo; wgOutputNo) { }
                column(PurchReturnOrderTitle; StrSubstNo(Trl('PurchReturnOrder%1'), wgCopyText)) { }

                dataitem(HdrComment; "Purch. Comment Line")
                {
                    DataItemLink = "Document Type" = Field("Document Type"), "No." = Field("No.");
                    DataItemLinkReference = PurchHdr;
                    DataItemTableView = sorting("Document Type", "No.", "Document Line No.", "Line No.") where("Document Line No." = const(0));

                    column(Comment_2; Comment) { }

                    trigger OnPreDataItem()
                    begin
                        if not wgShowInternalInfo then
                            CurrReport.Break();
                    end;
                }
                dataitem(HeaderDim; "Dimension Set Entry")
                {
                    DataItemLink = "Dimension Set ID" = Field("Dimension Set ID");
                    DataItemLinkReference = PurchHdr;
                    DataItemTableView = sorting("Dimension Set ID", "Dimension Code");

                    column(DimText; wgDimText) { }

                    trigger OnAfterGetRecord()
                    begin
                        wgCduwDCR_ReportFunctions.wgFncGetDimText(HeaderDim, wgDimText);
                    end;

                    trigger OnPreDataItem()
                    begin
                        if not wgShowInternalInfo then
                            CurrReport.Break();
                    end;
                }
                dataitem(PurchLine; "Purchase Line")
                {
                    DataItemTableView = sorting("Document Type", "Document No.", "Line No.");
                    UseTemporary = true;

                    column(Amount; Amount)
                    {
                        AutoFormatExpression = "Currency Code";
                        AutoFormatType = 1;
                    }
                    column(AmountInclVAT; "Amount Including VAT")
                    {
                        AutoFormatExpression = "Currency Code";
                        AutoFormatType = 1;
                    }
                    column(Description; Description) { }
                    column(DirectUnitCost; "Direct Unit Cost")
                    {
                        AutoFormatExpression = "Currency Code";
                        AutoFormatType = 2;
                    }
                    column(ExpectedReceiptDate; "Expected Receipt Date") { }
                    column(InvDiscAmount; -"Inv. Discount Amount")
                    {
                        AutoFormatExpression = "Currency Code";
                        AutoFormatType = 1;
                    }
                    column(LineAmount; "Line Amount")
                    {
                        AutoFormatExpression = "Currency Code";
                        AutoFormatType = 1;
                    }
                    column(LineDiscPerc; "Line Discount %") { }
                    column(No_2; "No.") { }
                    column(PromisedReceiptDate; "Promised Receipt Date") { }
                    column(Quantity; Quantity) { }
                    column(RequestedReceiptDate; "Requested Receipt Date") { }
                    column(Type; Format(Type)) { }
                    column(TypeNo; Type.AsInteger()) { }
                    column(UOM; wgCduwDCR_TranslationMgt.wgFncGetUnitOfMeaseTrl("Unit of Measure Code")) { }
                    column(VATIdentifier; "VAT Identifier") { }

                    dataitem(LineComment; "Sales Comment Line")
                    {
                        DataItemLink = "Document Type" = Field("Document Type"), "No." = Field("Document No."), "Document Line No." = Field("Line No.");
                        DataItemTableView = sorting("Document Type", "No.", "Document Line No.", "Line No.");
                        column(Comment; Comment) { }

                        trigger OnPreDataItem()
                        begin
                            if not wgShowInternalInfo then
                                CurrReport.Break();
                        end;
                    }
                    dataitem(LineDim; "Dimension Set Entry")
                    {
                        DataItemLink = "Dimension Set ID" = Field("Dimension Set ID");
                        DataItemTableView = sorting("Dimension Set ID", "Dimension Code");

                        column(DimText_2; wgDimText) { }

                        trigger OnAfterGetRecord()
                        begin
                            wgCduwDCR_ReportFunctions.wgFncGetDimText(LineDim, wgDimText);
                        end;

                        trigger OnPreDataItem()
                        begin
                            if not wgShowInternalInfo then
                                CurrReport.Break();
                        end;
                    }
                    dataitem(TrackingSpec; "Tracking Specification")
                    {
                        DataItemTableView = sorting("Entry No.");
                        UseTemporary = true;

                        column(LotNo; "Lot No.") { }
                        column(Quantity_4; "Quantity (Base)") { }
                        column(SerialNo; "Serial No.") { }

                        trigger OnPreDataItem()
                        begin
                            if not wgShowLotSN then
                                CurrReport.Break();
                            Reset();
                            SetRange("Source Ref. No.", PurchLine."Line No.");
                        end;
                    }

                    trigger OnAfterGetRecord()
                    begin
                        if not PurchHdr."Prices Including VAT" and
                           (PurchLine."VAT Calculation Type" = PurchLine."VAT Calculation Type"::"Full VAT")
                        then
                            PurchLine."Line Amount" := 0;

                        if (PurchLine.Type = PurchLine.Type::"G/L Account") and (not wgShowInternalInfo) then
                            PurchLine."No." := '';
                    end;

                    trigger OnPreDataItem()
                    var
                        wlMoreLines: Boolean;
                    begin
                        Reset();
                        wlMoreLines := PurchLine.Find('+');
                        while wlMoreLines and (PurchLine.Description = '') and (PurchLine."Description 2" = '') and
                              (PurchLine."No." = '') and (PurchLine.Quantity = 0) and
                              (PurchLine.Amount = 0)
                        do
                            wlMoreLines := PurchLine.Next(-1) <> 0;
                        if not wlMoreLines then
                            CurrReport.Break();
                        PurchLine.SetRange("Line No.", 0, PurchLine."Line No.");
                    end;
                }
                dataitem(VATAmtLine; "VAT Amount Line")
                {
                    DataItemTableView = sorting("VAT Identifier", "VAT Calculation Type", "Tax Group Code", "Use Tax", Positive);
                    UseTemporary = true;

                    column(InvDiscAmount_2; "Invoice Discount Amount")
                    {
                        AutoFormatExpression = PurchHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(InvDiscBaseAmount; "Inv. Disc. Base Amount")
                    {
                        AutoFormatExpression = PurchHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(LineAmount_2; "Line Amount")
                    {
                        AutoFormatExpression = PurchHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(VATAmount; "VAT Amount")
                    {
                        AutoFormatExpression = PurchHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(VATBase; "VAT Base")
                    {
                        AutoFormatExpression = PurchHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(VATIdentifier_2; "VAT Identifier") { }
                    column(VATPerc; "VAT %")
                    {
                        DecimalPlaces = 0 : 5;
                    }

                    trigger OnPreDataItem()
                    begin
                        if wgTotVATAmount = 0 then
                            CurrReport.Break();

                        Reset();
                    end;
                }
                dataitem(VATAmtLineLCY; "VAT Amount Line")
                {
                    DataItemTableView = sorting("VAT Identifier", "VAT Calculation Type", "Tax Group Code", "Use Tax", Positive);
                    UseTemporary = true;
                    column(VALVATAmountLCY; wgVALVATAmountLCY)
                    {
                        AutoFormatType = 1;
                    }

                    column(VALVATBaseLCY; wgVALVATBaseLCY)
                    {
                        AutoFormatType = 1;
                    }
                    column(VATIdentifier_3; "VAT Identifier") { }
                    column(VATPerc_2; "VAT %")
                    {
                        DecimalPlaces = 0 : 5;
                    }

                    trigger OnAfterGetRecord()
                    begin
                        wgVALVATBaseLCY :=
                          VATAmtLine.GetBaseLCY(
                            PurchHdr."Posting Date", PurchHdr."Currency Code", PurchHdr."Currency Factor");
                        wgVALVATAmountLCY :=
                          VATAmtLine.GetAmountLCY(
                            PurchHdr."Posting Date", PurchHdr."Currency Code", PurchHdr."Currency Factor");

                        wgTotVALVATBaseLCY += wgVALVATBaseLCY;
                        wgTotVALVATAmountLCY += wgVALVATAmountLCY;
                    end;

                    trigger OnPreDataItem()
                    begin
                        if not wgShowVATLCY then
                            CurrReport.Break();

                        VATAmtLineLCY.Copy(VATAmtLine, true); //Set VATAmtLineLCY to VATAmtLine
                        Reset();
                    end;
                }
                dataitem(Total; "Integer")
                {
                    DataItemTableView = sorting(Number) where(Number = const(1));

                    column(MonolithicVAT; wgMonolithicVAT) { }
                    column(NoOfVATAmtLines; wgNoOfVATAmountLines) { }
                    column(TotAmount; wgTotAmount)
                    {
                        AutoFormatExpression = PurchHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(TotInvDiscAmount; wgTotInvDiscAmount) { }
                    column(TotInvDiscBaseAmount; wgTotInvDiscBaseAmount) { }
                    column(TotLineAmount; wgTotLineAmount) { }
                    column(TotPaymentDiscOnVAT; wgTotPaymentDiscOnVAT)
                    {
                        AutoFormatExpression = PurchHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(TotVALVATAmountLCY; wgTotVALVATAmountLCY) { }
                    column(TotVALVATBaseLCY; wgTotVALVATBaseLCY) { }
                    column(TotVATAmount; wgTotVATAmount)
                    {
                        AutoFormatExpression = PurchHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(VATAmtText; wgVATAmountText) { }

                    trigger OnAfterGetRecord()
                    begin
                        wgNoOfVATAmountLines := VATAmtLine.Count();
                        wgMonolithicVAT := wgCduwDCR_ReportFunctions.wgFncIsMonolithicVAT(VATAmtLine);
                        if wgMonolithicVAT then
                            wgVATAmountText := CopyStr(StrSubstNo(Trl('TotalVATAmount%1Perc'), VATAmtLine."VAT %"), 1, 30)
                        else
                            wgVATAmountText := CopyStr(Trl('TotalVATAmount'), 1, 30);
                    end;
                }

                trigger OnAfterGetRecord()
                begin
                    if Number > 1 then begin
                        wgCopyText := CopyStr(Trl('Copy'), 1, MaxStrLen(wgCopyText));
                        wgOutputNo += 1;
                    end;

                    wgTotVALVATBaseLCY := 0;
                    wgTotVALVATAmountLCY := 0;
                end;

                trigger OnPostDataItem()
                begin
                    if not CurrReport.Preview() then
                        Codeunit.Run(Codeunit::"Purch.Header-Printed", PurchHdr);
                end;

                trigger OnPreDataItem()
                begin
                    wgNoOfLoops := Abs(wgNoOfCopies) + 1;
                    wgCopyText := '';
                    SetRange(Number, 1, wgNoOfLoops);
                    wgOutputNo := 1;
                end;
            }

            trigger OnAfterGetRecord()
            var
                wlCduPurchPost: Codeunit "Purch.-Post";
                wlRecRef: RecordRef;
            begin
                CurrReport.Language := wgCduLanguage.GetLanguageIdOrDefault("Language Code");
                wgCduwDCR_TranslationMgt.wgFncSetLanguageCode("Language Code");

                wlFncFormatAddressFields(PurchHdr);
                wlFncFormatDocumentFields(PurchHdr);

                if not CurrReport.Preview() then begin
                    if wgArchiveDocument then
                        wgCduArchiveManagement.StorePurchDocument(PurchHdr, wgLogInteraction);

                    if wgLogInteraction then begin
                        CalcFields("No. of Archived Versions");
                        wgCduSegManagement.LogDocument(
                          22, "No.", "Doc. No. Occurrence", "No. of Archived Versions", Database::Vendor, "Buy-from Vendor No.",
                          "Purchaser Code", '', "Posting Description", '');
                    end;
                end;

                //Get Purchase Lines
                Clear(wlCduPurchPost);
                PurchLine.Reset();
                PurchLine.DeleteAll();
                VATAmtLine.Reset();
                VATAmtLine.DeleteAll();
                wlCduPurchPost.GetPurchLines(PurchHdr, PurchLine, 0);  //0 = General

                //Get VAT Amount Lines
                PurchLine.CalcVATAmountLines(0, PurchHdr, PurchLine, VATAmtLine); //0 = General
                PurchLine.UpdateVATOnLines(0, PurchHdr, PurchLine, VATAmtLine);   //0 = General

                wgTotInvDiscAmount := VATAmtLine.GetTotalInvDiscAmount();
                wgTotInvDiscBaseAmount := VATAmtLine.GetTotalInvDiscBaseAmount(PurchHdr."Prices Including VAT", PurchHdr."Currency Code");
                wgTotLineAmount := VATAmtLine.GetTotalLineAmount(PurchHdr."Prices Including VAT", PurchHdr."Currency Code");
                wgTotVATAmount := VATAmtLine.GetTotalVATAmount();
                wgTotPaymentDiscOnVAT := -(wgTotLineAmount - wgTotInvDiscAmount - VATAmtLine.GetTotalAmountInclVAT());
                wgTotAmount := VATAmtLine.GetTotalVATBase();

                //Prepare VAT Amount Lines LCY
                if (not wgRecGLSetup."Print VAT specification in LCY") or
                   (PurchHdr."Currency Code" = '') or
                   (VATAmtLine.GetTotalVATAmount() = 0)
                then begin
                    wgShowVATLCY := false;
                    wgVALSpecLCYHeader := '';
                    wgVALExchRate := '';
                end
                else begin
                    wgShowVATLCY := true;
                    if wgRecGLSetup."LCY Code" = '' then
                        wgVALSpecLCYHeader := Trl('VATAmtSpecIn') + ' ' + Trl('LocalCurrency')
                    else
                        wgVALSpecLCYHeader := Trl('VATAmtSpecIn') + ' ' + Format(wgRecGLSetup."LCY Code");
                    wgRecCurrExchRate.FindCurrency(PurchHdr."Posting Date", PurchHdr."Currency Code", 1);
                    wgVALExchRate := CopyStr(StrSubstNo(Trl('ExchangeRate%1/%2'), wgRecCurrExchRate."Relational Exch. Rate Amount", wgRecCurrExchRate."Exchange Rate Amount"), 1, 50);
                end;

                //Get Item Tracking
                TrackingSpec.Reset();
                TrackingSpec.DeleteAll();
                if wgShowLotSN then begin
                    wgCduItemTrackingDocMgt.SetRetrieveAsmItemTracking(false);
                    wgCduItemTrackingDocMgt.RetrieveDocumentItemTracking(TrackingSpec, PurchHdr."No.",
                        Database::"Purchase Header", PurchHdr."Document Type");
                end;

                //Set HideLineDiscount
                wlRecRef.GetTable(PurchHdr);
                wgHideLineDiscount := wgCduwDCR_ReportFunctions.wgFncHideLineDiscount(wlRecRef);
            end;
        }
    }

    requestpage
    {
        SaveValues = true;

        layout
        {
            area(content)
            {
                group(Options)
                {
                    Caption = 'Options';
                    field(NoOfCopies; wgNoOfCopies)
                    {
                        ApplicationArea = All;
                        Caption = 'No. of Copies';
                    }
                    field(ShowInternalInfo; wgShowInternalInfo)
                    {
                        ApplicationArea = All;
                        Caption = 'Show Internal Information';
                    }
                    field(ShowLotSN; wgShowLotSN)
                    {
                        ApplicationArea = All;
                        Caption = 'Show Serial/Lot Number';
                        Visible = false;
                    }
                    field(ArchiveDocument; wgArchiveDocument)
                    {
                        ApplicationArea = All;
                        Caption = 'Archive Document';

                        trigger OnValidate()
                        begin
                            if not wgArchiveDocument then
                                wgLogInteraction := false;
                        end;
                    }
                    field(LogInteraction; wgLogInteraction)
                    {
                        ApplicationArea = All;
                        Caption = 'Log Interaction';
                        Enabled = wgLogInteractionEnable;

                        trigger OnValidate()
                        begin
                            if wgLogInteraction then
                                wgArchiveDocument := wgArchiveDocumentEnable;
                        end;
                    }
                }
            }
        }

        trigger OnInit()
        begin
            wgLogInteractionEnable := true;
        end;

        trigger OnOpenPage()
        begin
            wgArchiveDocument := wgRecPurchSetup."Archive Orders";
            wgLogInteraction := wgCduSegManagement.FindInteractTmplCode(22) <> '';

            wgLogInteractionEnable := wgLogInteraction;

            wgNoOfCopies := 0;
        end;
    }

    trigger OnInitReport()
    begin
        wgRecGLSetup.Get();

        wgRecPurchSetup.Get();

        wgRecCompanyInfo.Get();
        wgRecCompanyInfo.CalcFields(Picture);
    end;

    trigger OnPreReport()
    begin
        wlFncInitReportSettings();
        if not CurrReport.UseRequestPage() then
            wgNoOfCopies := 0;
    end;

    var
        wgRecCompanyInfo: Record "Company Information";
        wgRecCurrExchRate: Record "Currency Exchange Rate";
        wgRecGLSetup: Record "General Ledger Setup";
        wgRecPaymentTerms: Record "Payment Terms";
        wgRecPrepmtPaymentTerms: Record "Payment Terms";
        wgRecPurchSetup: Record "Purchases & Payables Setup";
        wgRecSalesPurchPerson: Record "Salesperson/Purchaser";
        wgRecShipmentMethod: Record "Shipment Method";
        wgCduArchiveManagement: Codeunit ArchiveManagement;
        wgCduFormatAddr: Codeunit "Format Address";
        wgCduFormatDoc: Codeunit "Format Document";
        wgCduItemTrackingDocMgt: Codeunit "Item Tracking Doc. Management";
        wgCduLanguage: Codeunit Language;
        wgCduSegManagement: Codeunit SegManagement;
        wgCduwDCR_ReportFunctions: Codeunit wDCR_ReportFunctions;
        wgCduwDCR_TranslationMgt: Codeunit wDCR_TranslationMgt;
        wgArchiveDocument: Boolean;
        [InDataSet]
        wgArchiveDocumentEnable: Boolean;
        wgHideLineDiscount: Boolean;
        wgLogInteraction: Boolean;
        [InDataSet]
        wgLogInteractionEnable: Boolean;
        wgMonolithicVAT: Boolean;
        wgShowInternalInfo: Boolean;
        wgShowLotSN: Boolean;
        wgShowVATLCY: Boolean;
        wgTotAmount: Decimal;
        wgTotInvDiscAmount: Decimal;
        wgTotInvDiscBaseAmount: Decimal;
        wgTotLineAmount: Decimal;
        wgTotPaymentDiscOnVAT: Decimal;
        wgTotVALVATAmountLCY: Decimal;
        wgTotVALVATBaseLCY: Decimal;
        wgTotVATAmount: Decimal;
        wgVALVATAmountLCY: Decimal;
        wgVALVATBaseLCY: Decimal;
        wgDateFormatHdr: Integer;
        wgNoOfCopies: Integer;
        wgNoOfLoops: Integer;
        wgNoOfVATAmountLines: Integer;
        wgOutputNo: Integer;
        wgReportId: Integer;
        wgCompanyInfoFaxNo: Text;
        wgCompanyInfoPhoneNo: Text;
        wgCopyText: Text[30];
        wgVATAmountText: Text[30];
        wgTotalExclVATText: Text[50];
        wgTotalInclVATText: Text[50];
        wgTotalText: Text[50];
        wgVALExchRate: Text[50];
        wgVALSpecLCYHeader: Text[80];
        wgBuyFromAddr: array[8] of Text[100];
        wgCompanyAddr: array[8] of Text[100];
        wgPayToVendAddr: array[8] of Text[100];
        wgShipToAddr: array[8] of Text[100];
        wgDimText: Text[120];

    procedure InitializeRequest(pNoOfCopiesFrom: Integer; pShowInternalInfoFrom: Boolean; pArchiveDocumentFrom: Boolean; pLogInteractionFrom: Boolean)
    begin
        wgNoOfCopies := pNoOfCopiesFrom;
        wgShowInternalInfo := pShowInternalInfoFrom;
        wgArchiveDocument := pArchiveDocumentFrom;
        wgLogInteraction := pLogInteractionFrom;
    end;

    local procedure Trl(pLblName: Text[50]): Text
    begin
        exit(wgCduwDCR_TranslationMgt.wgFncTranslate(pLblName));
    end;

    local procedure wlFncFormatAddressFields(var vRecPurchHeader: Record "Purchase Header")
    var
        wlRecRespCenter: Record "Responsibility Center";
    begin
        wgCduFormatAddr.GetCompanyAddr(vRecPurchHeader."Responsibility Center", wlRecRespCenter, wgRecCompanyInfo, wgCompanyAddr);
        wgCompanyInfoPhoneNo := wgRecCompanyInfo."Phone No.";
        wgCompanyInfoFaxNo := wgRecCompanyInfo."Fax No.";
        wgCduFormatAddr.PurchHeaderPayTo(wgPayToVendAddr, vRecPurchHeader);
        wgCduFormatAddr.PurchHeaderShipTo(wgShipToAddr, vRecPurchHeader);
        wgCduFormatAddr.PurchHeaderBuyFrom(wgBuyFromAddr, vRecPurchHeader);
    end;

    local procedure wlFncFormatDocumentFields(pRecPurchHeader: Record "Purchase Header")
    var
        wlCurrencyCode: Code[10];
        wlPurchPersonText: Text[50];
    begin
        wlCurrencyCode := pRecPurchHeader."Currency Code";
        if wlCurrencyCode = '' then begin
            wgRecGLSetup.TestField("LCY Code");
            wlCurrencyCode := wgRecGLSetup."LCY Code";
        end;
        wgTotalText := CopyStr(StrSubstNo(Trl('Total%1'), wlCurrencyCode), 1, MaxStrLen(wgTotalText));
        wgTotalInclVATText := CopyStr(StrSubstNo(Trl('Total%1InclVAT'), wlCurrencyCode), 1, MaxStrLen(wgTotalInclVATText));
        wgTotalExclVATText := CopyStr(StrSubstNo(Trl('Total%1ExclVAT'), wlCurrencyCode), 1, MaxStrLen(wgTotalExclVATText));
        wgCduFormatDoc.SetPurchaser(wgRecSalesPurchPerson, pRecPurchHeader."Purchaser Code", wlPurchPersonText);
        wgCduFormatDoc.SetPaymentTerms(wgRecPaymentTerms, pRecPurchHeader."Payment Terms Code", pRecPurchHeader."Language Code");
        wgCduFormatDoc.SetPaymentTerms(wgRecPrepmtPaymentTerms, pRecPurchHeader."Prepmt. Payment Terms Code", pRecPurchHeader."Language Code");
        wgCduFormatDoc.SetShipmentMethod(wgRecShipmentMethod, pRecPurchHeader."Shipment Method Code", pRecPurchHeader."Language Code");
    end;

    local procedure wlFncInitReportSettings()
    var
        wlCduTemplateReportHelperDCR: Codeunit TemplateReportHelperDCR;
    begin
        if wgReportId = 0 then
            Evaluate(wgReportId, (DelChr(CurrReport.ObjectId(false), '=', DelChr(CurrReport.ObjectId(false), '=', '1234567890'))));
        wgCduwDCR_TranslationMgt.wgFncSetReportId(wgReportId);
        wgDateFormatHdr := wlCduTemplateReportHelperDCR.wgFncGetHeaderDateFormat(wgReportId);
    end;
}
