report 72101 SalesOrderConfDCR
{
    Caption = 'Sales - Order Confirmation';
    PreviewMode = PrintLayout;
    UsageCategory = None;

    dataset
    {
        dataitem(SalesHdr; "Sales Header")
        {
            DataItemTableView = sorting("Document Type", "No.") where("Document Type" = const(Order));
            RequestFilterFields = "No.", "Sell-to Customer No.", "No. Printed";
            RequestFilterHeading = 'Sales Order';

            column(BilltoCustNo; "Bill-to Customer No.") { }
            column(CompanyAddr1; wgCompanyAddr[1]) { }
            column(CompanyAddr2; wgCompanyAddr[2]) { }
            column(CompanyAddr3; wgCompanyAddr[3]) { }
            column(CompanyAddr4; wgCompanyAddr[4]) { }
            column(CompanyAddr5; wgCompanyAddr[5]) { }
            column(CompanyAddr6; wgCompanyAddr[6]) { }
            column(CompanyBankAccNo; wgRecCompanyInfo."Bank Account No.") { }
            column(CompanyBankBranchNo; wgRecCompanyInfo."Bank Branch No.") { }
            column(CompanyBankName; wgRecCompanyInfo."Bank Name") { }
            column(CompanyCity; wgRecCompanyInfo.City) { }
            column(CompanyEMail; wgRecCompanyInfo."E-Mail") { }
            column(CompanyFaxNo; wgRecCompanyInfo."Fax No.") { }
            column(CompanyGiroNo; wgRecCompanyInfo."Giro No.") { }
            column(CompanyHomePage; wgRecCompanyInfo."Home Page") { }
            column(CompanyIBAN; wgRecCompanyInfo.IBAN) { }
            column(CompanyPhoneNo; wgRecCompanyInfo."Phone No.") { }
            column(CompanyPicture; wgRecCompanyInfo.Picture) { }
            column(CompanyRegistrationNo; wgRecCompanyInfo."Registration No.") { }
            column(CompanySWIFT; wgRecCompanyInfo."SWIFT Code") { }
            column(CompanyVATRegNo; wgRecCompanyInfo."VAT Registration No.") { }
            column(CustAddr1; wgCustAddr[1]) { }
            column(CustAddr2; wgCustAddr[2]) { }
            column(CustAddr3; wgCustAddr[3]) { }
            column(CustAddr4; wgCustAddr[4]) { }
            column(CustAddr5; wgCustAddr[5]) { }
            column(CustAddr6; wgCustAddr[6]) { }
            column(CustAddr7; wgCustAddr[7]) { }
            column(CustAddr8; wgCustAddr[8]) { }
            column(DocumentDate; "Document Date") { }
            column(DocumentDateText; Format("Document Date", 0, wgDateFormatHdr)) { }
            column(DocumentNo; "No.") { }
            column(DocumentType; Format("Document Type")) { }
            column(DueDate; "Due Date") { }
            column(DueDateText; Format("Due Date", 0, wgDateFormatHdr)) { }
            column(ExternalDocumentNo; "External Document No.") { }
            column(HideLineDiscount; wgHideLineDiscount) { }
            column(LanguageCode; "Language Code") { }
            column(lblAllowInvDisc; Trl('AllowInvDisc')) { }
            column(lblAmount; Trl('Amount')) { }
            column(lblAmountInclVAT; Trl('AmountInclVAT')) { }
            column(lblAttachedToLineNo; Trl('AttachedToLineNo')) { }
            column(lblBankAccNo; Trl('BankAccNo')) { }
            column(lblBankBranchNo; Trl('BankBranchNo')) { }
            column(lblBankName; Trl('BankName')) { }
            column(lblBillToAddress; Trl('BillToAddress')) { }
            column(lblBillToCustomerNo; Trl('BillToCustomerNo')) { }
            column(lblCompanyRegistrationNo; Trl('CompanyRegistrationNo')) { }
            column(lblCrossReferenceNo; Trl('CrossReferenceNo')) { }
            column(lblDescription; Trl('Description')) { }
            column(lblDocumentDate; Trl('DocumentDate')) { }
            column(lblDocumentNo; Trl('DocumentNo')) { }
            column(lblDocumentType; Trl('DocumentType')) { }
            column(lblDueDate; Trl('DueDate')) { }
            column(lblEmail; Trl('Email')) { }
            column(lblExternalDocumentNo; Trl('ExternalDocumentNo')) { }
            column(lblFaxNo; Trl('FaxNo')) { }
            column(lblFreeText1; Trl('FreeText1')) { }
            column(lblFreeText2; Trl('FreeText2')) { }
            column(lblFreeText3; Trl('FreeText3')) { }
            column(lblFreeText4; Trl('FreeText4')) { }
            column(lblGiroNo; Trl('GiroNo')) { }
            column(lblGLAccountNo; Trl('GLAccountNo')) { }
            column(lblGrossWeight; Trl('GrossWeight')) { }
            column(lblHeaderDimensions; Trl('HeaderDimensions')) { }
            column(lblHomePage; Trl('HomePage')) { }
            column(lblIBAN; Trl('IBAN')) { }
            column(lblInvDiscAmount; Trl('InvDiscAmount')) { }
            column(lblInvDiscBaseAmount; Trl('InvDiscBaseAmount')) { }
            column(lblInvoiceDate; Trl('InvoiceDate')) { }
            column(lblInvoiceNo; Trl('InvoiceNo')) { }
            column(lblLineAmount; Trl('LineAmount')) { }
            column(lblLineDimensions; Trl('LineDimensions')) { }
            column(lblLineDiscountAmount; Trl('LineDiscountAmount')) { }
            column(lblLineDiscountPerc; Trl('LineDiscountPerc')) { }
            column(lblLineNo; Trl('LineNo')) { }
            column(lblLocationCode; Trl('LocationCode')) { }
            column(lblLotNo; Trl('LotNo')) { }
            column(lblNetWeight; Trl('NetWeight')) { }
            column(lblNo; Trl('No')) { }
            column(lblOrderDate; Trl('OrderDate')) { }
            column(lblOrderNo; Trl('OrderNo')) { }
            column(lblOutstandingQtyBase; Trl('OutstandingQtyBase')) { }
            column(lblOutstandingQuantity; Trl('OutstandingQuantity')) { }
            column(lblPageOf; Trl('Page{0}of{1}')) { }
            column(lblPaymentDiscountVAT; Trl('PaymentDiscountVAT')) { }
            column(lblPaymentMethod; Trl('PaymentMethod')) { }
            column(lblPaymentTerms; Trl('PaymentTerms')) { }
            column(lblPhoneNo; Trl('PhoneNo')) { }
            column(lblPostingDate; Trl('PostingDate')) { }
            column(lblPricesInclVAT; Trl('PricesInclVAT')) { }
            column(lblQtyInvoicedBase; Trl('QtyInvoicedBase')) { }
            column(lblQtyPerUOM; Trl('QtyPerUOM')) { }
            column(lblQtyToInvoiceBase; Trl('QtyToInvoiceBase')) { }
            column(lblQuantity; Trl('Quantity')) { }
            column(lblQuantityBase; Trl('QuantityBase')) { }
            column(lblQuantityInvoiced; Trl('QuantityInvoiced')) { }
            column(lblReservedQtyBase; Trl('ReservedQtyBase')) { }
            column(lblSalesPerson; Trl('SalesPerson')) { }
            column(lblSellToCustomerNo; Trl('SellToCustomerNo')) { }
            column(lblSerialNo; Trl('SerialNo')) { }
            column(lblShipment; Trl('Shipment')) { }
            column(lblShipmentDate; Trl('ShipmentDate')) { }
            column(lblShipmentMethod; Trl('ShipmentMethod')) { }
            column(lblShippingAgent; Trl('ShippingAgent')) { }
            column(lblShipToAddress; Trl('ShipToAddress')) { }
            column(lblSubtotal; Trl('Subtotal')) { }
            column(lblSWIFT; Trl('SWIFT')) { }
            column(lblTotal; Trl('Total')) { }
            column(lblTotalTransFooter; Trl('TotalTransFooter')) { }
            column(lblTotalTransHeader; Trl('TotalTransHeader')) { }
            column(lblType; Trl('Type')) { }
            column(lblUnitCost; Trl('UnitCost')) { }
            column(lblUnitCostLCY; Trl('UnitCostLCY')) { }
            column(lblUnitPrice; Trl('UnitPrice')) { }
            column(lblUnitsPerParcel; Trl('UnitsPerParcel')) { }
            column(lblUOM; Trl('UOM')) { }
            column(lblVATAmount; Trl('VATAmount')) { }
            column(lblVATAmountSpecification; Trl('VATAmountSpecification')) { }
            column(lblVATBase; Trl('VATBase')) { }
            column(lblVATClause; Trl('VATClause')) { }
            column(lblVATIdentifier; Trl('VATIdentifier')) { }
            column(lblVATPerc; Trl('VATPerc')) { }
            column(lblVATRegistrationNo; Trl('VATRegistrationNo')) { }
            column(lblWorkDescription; Trl('WorkDescription')) { }
            column(lblYourReference; Trl('YourReference')) { }
            column(LocationCity; wgRecLocation.City) { }
            column(LocationCode; "Location Code") { }
            column(LocationName; wgRecLocation.Name) { }
            column(PaymentMethodDesc; wgRecPaymentMethod.Description) { }
            column(PaymentTermsDesc; wgRecPaymentTerms.Description) { }
            column(PostingDate; "Posting Date") { }
            column(PostingDateText; Format("Posting Date", 0, wgDateFormatHdr)) { }
            column(PricesInclVAT; "Prices Including VAT") { }
            column(PricesInclVATYesNo; Format("Prices Including VAT")) { }
            column(SalesPurchPersonName; wgRecSalesPurchPerson.Name) { }
            column(SelltoCustNo; "Sell-to Customer No.") { }
            column(SelltoPhoneNo; "Sell-to Phone No.") { }
            column(ShipmentMethodDesc; wgRecShipmentMethod.Description) { }
            column(ShippingAgentCode; "Shipping Agent Code") { }
            column(ShippingAgentName; wgRecShippingAgent.Name) { }
            column(ShipToAddr1; wgShipToAddr[1]) { }
            column(ShipToAddr2; wgShipToAddr[2]) { }
            column(ShipToAddr3; wgShipToAddr[3]) { }
            column(ShipToAddr4; wgShipToAddr[4]) { }
            column(ShipToAddr5; wgShipToAddr[5]) { }
            column(ShipToAddr6; wgShipToAddr[6]) { }
            column(ShipToAddr7; wgShipToAddr[7]) { }
            column(ShipToAddr8; wgShipToAddr[8]) { }
            column(ShipToAddrSet; wgShowShippingAddr) { }
            column(TodayText; Format(Today(), 0, wgDateFormatHdr)) { }
            column(TotalExclVATText; wgTotalExclVATText) { }
            column(TotalInclVATText; wgTotalInclVATText) { }
            column(TotalText; wgTotalText) { }
            column(VALExchRate; wgVALExchRate) { }
            column(VALSpecLCYHeader; wgVALSpecLCYHeader) { }
            column(VATBaseDiscPerc; "VAT Base Discount %")
            {
                AutoFormatType = 1;
            }
            column(VATRegNo; "VAT Registration No.") { }
            column(WorkDescription; "Work Description") { }
            column(YourReference; "Your Reference") { }

            dataitem(CopyLoop; "Integer")
            {
                DataItemTableView = sorting(Number);

                column(OutputNo; wgOutputNo) { }
                column(SalesOrderConfirmationTitle; StrSubstNo(Trl('SalesOrderConfirmation%1'), wgCopyText)) { }

                dataitem(HdrComment; "Sales Comment Line")
                {
                    DataItemLink = "Document Type" = Field("Document Type"), "No." = Field("No.");
                    DataItemLinkReference = SalesHdr;
                    DataItemTableView = sorting("Document Type", "No.", "Document Line No.", "Line No.") where("Document Line No." = const(0));

                    column(Comment_2; Comment) { }

                    trigger OnPreDataItem()
                    begin
                        if not wgShowInternalInfo then
                            CurrReport.Break();
                    end;
                }
                dataitem(HeaderDim; "Dimension Set Entry")
                {
                    DataItemLink = "Dimension Set ID" = Field("Dimension Set ID");
                    DataItemLinkReference = SalesHdr;
                    DataItemTableView = sorting("Dimension Set ID", "Dimension Code");

                    column(DimText; wgDimText) { }

                    trigger OnAfterGetRecord()
                    begin
                        wgCduwDCR_ReportFunctions.wgFncGetDimText(HeaderDim, wgDimText);
                    end;

                    trigger OnPreDataItem()
                    begin
                        if not wgShowInternalInfo then
                            CurrReport.Break();
                    end;
                }
                dataitem(SalesLine; "Sales Line")
                {
                    DataItemTableView = sorting("Document Type", "Document No.", "Line No.");
                    UseTemporary = true;

                    column(Amount; Amount)
                    {
                        AutoFormatExpression = "Currency Code";
                        AutoFormatType = 1;
                    }
                    column(AmountInclVAT; "Amount Including VAT")
                    {
                        AutoFormatExpression = "Currency Code";
                        AutoFormatType = 1;
                    }
                    column(AttachedToLineNo; "Attached to Line No.") { }
                    column(CrossReferenceNo; "Cross-Reference No.") { }
                    column(Description; Description) { }
                    column(Description2; "Description 2") { }
                    column(GrossWeight; "Gross Weight") { }
                    column(InvDiscAmount; -"Inv. Discount Amount")
                    {
                        AutoFormatExpression = "Currency Code";
                        AutoFormatType = 1;
                    }
                    column(LineAmount; "Line Amount")
                    {
                        AutoFormatExpression = "Currency Code";
                        AutoFormatType = 1;
                    }
                    column(LineDiscountAmount; "Line Discount Amount") { }
                    column(LineDiscPerc; "Line Discount %") { }
                    column(NetWeight; "Net Weight") { }
                    column(No_2; "No.") { }
                    column(OutstandingQtyBase; "Outstanding Qty. (Base)") { }
                    column(OutstandingQuantity; "Outstanding Quantity") { }

                    column(PlannedDeliveryDate; "Planned Delivery Date") { }
                    column(PostedShipmentDate; "Shipment Date") { }
                    column(PromisedDeliveryDate; "Promised Delivery Date") { }
                    column(QtyInvoicedBase; "Qty. Invoiced (Base)") { }
                    column(QtyPerUOM; "Qty. per Unit of Measure") { }
                    column(QtyToInvoiceBase; "Qty. to Invoice (Base)") { }
                    column(Quantity; Quantity) { }
                    column(QuantityBase; "Quantity (Base)") { }
                    column(QuantityInvoiced; "Quantity Invoiced") { }
                    column(ReservedQtyBase; "Reserved Qty. (Base)") { }
                    column(Type; Format(Type)) { }
                    column(TypeNo; Type.AsInteger()) { }
                    column(UnitCost; "Unit Cost") { }
                    column(UnitCostLCY; "Unit Cost (LCY)") { }
                    column(UnitPrice; "Unit Price")
                    {
                        AutoFormatExpression = "Currency Code";
                        AutoFormatType = 2;
                    }
                    column(UnitsPerParcel; "Units per Parcel") { }
                    column(UOM; wgCduwDCR_TranslationMgt.wgFncGetUnitOfMeaseTrl("Unit of Measure Code")) { }
                    column(UOMCode; "Unit of Measure Code") { }
                    column(VATIdentifier; "VAT Identifier") { }

                    dataitem(LineComment; "Sales Comment Line")
                    {
                        DataItemLink = "Document Type" = Field("Document Type"), "No." = Field("Document No."), "Document Line No." = Field("Line No.");
                        DataItemTableView = sorting("Document Type", "No.", "Document Line No.", "Line No.");

                        column(Comment; Comment) { }

                        trigger OnPreDataItem()
                        begin
                            if not wgShowInternalInfo then
                                CurrReport.Break();
                        end;
                    }
                    dataitem(LineDim; "Dimension Set Entry")
                    {
                        DataItemLink = "Dimension Set ID" = Field("Dimension Set ID");
                        DataItemTableView = sorting("Dimension Set ID", "Dimension Code");

                        column(DimText_2; wgDimText) { }

                        trigger OnAfterGetRecord()
                        begin
                            wgCduwDCR_ReportFunctions.wgFncGetDimText(LineDim, wgDimText);
                        end;

                        trigger OnPreDataItem()
                        begin
                            if not wgShowInternalInfo then
                                CurrReport.Break();
                        end;
                    }
                    dataitem(AsmLine; "Assembly Line")
                    {
                        DataItemTableView = sorting("Document Type", "Document No.", "Line No.");

                        column(Description_3; Description) { }
                        column(LineNo_2; "No.") { }
                        column(Quantity_3; Quantity)
                        {
                            DecimalPlaces = 0 : 5;
                        }
                        column(UOM_2; wgCduwDCR_TranslationMgt.wgFncGetUnitOfMeaseTrl("Unit of Measure Code")) { }
                        column(VariantCode; "Variant Code") { }

                        trigger OnPreDataItem()
                        begin
                            if not wgDisplayAssemblyInformation then
                                CurrReport.Break();
                            if not wgAsmInfoExistsForLine then
                                CurrReport.Break();
                            SetRange("Document Type", wgRecAsmHeader."Document Type");
                            SetRange("Document No.", wgRecAsmHeader."No.");
                        end;
                    }
                    dataitem(TrackingSpec; "Tracking Specification")
                    {
                        DataItemTableView = sorting("Entry No.");
                        UseTemporary = true;

                        column(LotNo; "Lot No.") { }
                        column(Quantity_4; "Quantity (Base)") { }
                        column(SerialNo; "Serial No.") { }

                        trigger OnPreDataItem()
                        begin
                            if not wgShowLotSN then
                                CurrReport.Break();

                            Reset();
                            SetRange("Source Ref. No.", SalesLine."Line No.");
                        end;
                    }

                    trigger OnAfterGetRecord()
                    begin
                        if wgDisplayAssemblyInformation then
                            wgAsmInfoExistsForLine := SalesLine.AsmToOrderExists(wgRecAsmHeader);

                        if not SalesHdr."Prices Including VAT" and
                           (SalesLine."VAT Calculation Type" = SalesLine."VAT Calculation Type"::"Full VAT")
                        then
                            SalesLine."Line Amount" := 0;

                        if (SalesLine.Type = SalesLine.Type::"G/L Account") and (not wgShowInternalInfo) then
                            SalesLine."No." := '';
                    end;

                    trigger OnPreDataItem()
                    var
                        wlMoreLines: Boolean;
                    begin
                        Reset();
                        wlMoreLines := SalesLine.Find('+');
                        while wlMoreLines and (SalesLine.Description = '') and (SalesLine."Description 2" = '') and
                              (SalesLine."No." = '') and (SalesLine.Quantity = 0) and
                              (SalesLine.Amount = 0)
                        do
                            wlMoreLines := SalesLine.Next(-1) <> 0;
                        if not wlMoreLines then
                            CurrReport.Break();
                        SalesLine.SetRange("Line No.", 0, SalesLine."Line No.");
                    end;
                }
                dataitem(VATAmtLine; "VAT Amount Line")
                {
                    DataItemTableView = sorting("VAT Identifier", "VAT Calculation Type", "Tax Group Code", "Use Tax", Positive);
                    UseTemporary = true;

                    column(InvDiscAmount_2; "Invoice Discount Amount")
                    {
                        AutoFormatExpression = SalesHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(InvDiscBaseAmount; "Inv. Disc. Base Amount")
                    {
                        AutoFormatExpression = SalesHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(LineAmount_2; "Line Amount")
                    {
                        AutoFormatExpression = SalesHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(VATAmount; "VAT Amount")
                    {
                        AutoFormatExpression = SalesHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(VATBase; "VAT Base")
                    {
                        AutoFormatExpression = SalesHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(VATIdentifier_2; "VAT Identifier") { }
                    column(VATPerc; "VAT %")
                    {
                        DecimalPlaces = 0 : 5;
                    }

                    trigger OnPreDataItem()
                    begin
                        if wgTotVATAmount = 0 then
                            CurrReport.Break();

                        Reset();
                    end;
                }
                dataitem(VATAmtLineLCY; "VAT Amount Line")
                {
                    DataItemTableView = sorting("VAT Identifier", "VAT Calculation Type", "Tax Group Code", "Use Tax", Positive);
                    UseTemporary = true;
                    column(VALVATAmountLCY; wgVALVATAmountLCY)
                    {
                        AutoFormatType = 1;
                    }

                    column(VALVATBaseLCY; wgVALVATBaseLCY)
                    {
                        AutoFormatType = 1;
                    }
                    column(VATIdentifier_3; "VAT Identifier") { }
                    column(VATPerc_2; "VAT %")
                    {
                        DecimalPlaces = 0 : 5;
                    }

                    trigger OnAfterGetRecord()
                    begin
                        wgVALVATBaseLCY :=
                          VATAmtLine.GetBaseLCY(
                            SalesHdr."Posting Date", SalesHdr."Currency Code", SalesHdr."Currency Factor");
                        wgVALVATAmountLCY :=
                          VATAmtLine.GetAmountLCY(
                            SalesHdr."Posting Date", SalesHdr."Currency Code", SalesHdr."Currency Factor");

                        wgTotVALVATBaseLCY += wgVALVATBaseLCY;
                        wgTotVALVATAmountLCY += wgVALVATAmountLCY;
                    end;

                    trigger OnPreDataItem()
                    begin
                        if not wgShowVATLCY then
                            CurrReport.Break();

                        VATAmtLineLCY.Copy(VATAmtLine, true); //Set VATAmtLineLCY to VATAmtLine
                        Reset();
                    end;
                }
                dataitem(Total; "Integer")
                {
                    DataItemTableView = sorting(Number) where(Number = const(1));

                    column(MonolithicVAT; wgMonolithicVAT) { }
                    column(NoOfVATAmtLines; wgNoOfVATAmountLines) { }
                    column(TotAmount; wgTotAmount)
                    {
                        AutoFormatExpression = SalesHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(TotInvDiscAmount; wgTotInvDiscAmount) { }
                    column(TotInvDiscBaseAmount; wgTotInvDiscBaseAmount) { }
                    column(TotLineAmount; wgTotLineAmount) { }
                    column(TotPaymentDiscOnVAT; wgTotPaymentDiscOnVAT)
                    {
                        AutoFormatExpression = SalesHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(TotVALVATAmountLCY; wgTotVALVATAmountLCY) { }
                    column(TotVALVATBaseLCY; wgTotVALVATBaseLCY) { }
                    column(TotVATAmount; wgTotVATAmount)
                    {
                        AutoFormatExpression = SalesHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(VATAmtText; wgVATAmountText) { }

                    trigger OnAfterGetRecord()
                    begin
                        wgNoOfVATAmountLines := VATAmtLine.Count();
                        wgMonolithicVAT := wgCduwDCR_ReportFunctions.wgFncIsMonolithicVAT(VATAmtLine);
                        if wgMonolithicVAT then
                            wgVATAmountText := CopyStr(StrSubstNo(Trl('TotalVATAmount%1Perc'), VATAmtLine."VAT %"), 1, 30)
                        else
                            wgVATAmountText := CopyStr(Trl('TotalVATAmount'), 1, 30);
                    end;
                }

                trigger OnAfterGetRecord()
                begin
                    if Number > 1 then begin
                        wgCopyText := CopyStr(Trl('Copy'), 1, MaxStrLen(wgCopyText));
                        wgOutputNo += 1;
                    end;

                    wgTotVALVATBaseLCY := 0;
                    wgTotVALVATAmountLCY := 0;
                end;

                trigger OnPostDataItem()
                begin
                    if wgPrint then
                        Codeunit.Run(Codeunit::"Sales-Printed", SalesHdr);
                end;

                trigger OnPreDataItem()
                begin
                    wgNoOfLoops := Abs(wgNoOfCopies) + 1;
                    wgCopyText := '';
                    SetRange(Number, 1, wgNoOfLoops);
                    wgOutputNo := 1;
                end;
            }

            trigger OnAfterGetRecord()
            var
                wlCduSalesPost: Codeunit "Sales-Post";
                wlRecRef: RecordRef;
            begin
                CurrReport.Language := wgCduLanguage.GetLanguageIdOrDefault("Language Code");
                wgCduwDCR_TranslationMgt.wgFncSetLanguageCode("Language Code");

                wlFncFormatAddressFields(SalesHdr);
                wlFncFormatDocumentFields(SalesHdr);

                if wgPrint then begin
                    if wgArchiveDocument then
                        wgCduArchiveManagement.StoreSalesDocument(SalesHdr, wgLogInteraction);

                    if wgLogInteraction then begin
                        CalcFields("No. of Archived Versions");
                        if "Bill-to Contact No." <> '' then
                            wgCduSegManagement.LogDocument(
                              3, "No.", "Doc. No. Occurrence",
                              "No. of Archived Versions", Database::Contact, "Bill-to Contact No."
                              , "Salesperson Code", "Campaign No.", "Posting Description", "Opportunity No.")
                        else
                            wgCduSegManagement.LogDocument(
                              3, "No.", "Doc. No. Occurrence",
                              "No. of Archived Versions", Database::Customer, "Bill-to Customer No.",
                              "Salesperson Code", "Campaign No.", "Posting Description", "Opportunity No.");
                    end;
                end;

                //Get Sales Lines
                Clear(wlCduSalesPost);
                SalesLine.Reset();
                SalesLine.DeleteAll();
                VATAmtLine.Reset();
                VATAmtLine.DeleteAll();
                wlCduSalesPost.GetSalesLines(SalesHdr, SalesLine, 0);  //0 = General

                //Get VAT Amount Lines
                SalesLine.CalcVATAmountLines(0, SalesHdr, SalesLine, VATAmtLine); //0 = General
                SalesLine.UpdateVATOnLines(0, SalesHdr, SalesLine, VATAmtLine);   //0 = General

                wgTotInvDiscAmount := VATAmtLine.GetTotalInvDiscAmount();
                wgTotInvDiscBaseAmount := VATAmtLine.GetTotalInvDiscBaseAmount(SalesHdr."Prices Including VAT", SalesHdr."Currency Code");
                wgTotLineAmount := VATAmtLine.GetTotalLineAmount(SalesHdr."Prices Including VAT", SalesHdr."Currency Code");
                wgTotVATAmount := VATAmtLine.GetTotalVATAmount();
                wgTotPaymentDiscOnVAT := -(wgTotLineAmount - wgTotInvDiscAmount - VATAmtLine.GetTotalAmountInclVAT());
                wgTotAmount := VATAmtLine.GetTotalVATBase();

                //Prepare VAT Amount Lines LCY
                if (not wgRecGLSetup."Print VAT specification in LCY") or
                   (SalesHdr."Currency Code" = '') or
                   (VATAmtLine.GetTotalVATAmount() = 0)
                then begin
                    wgShowVATLCY := false;
                    wgVALSpecLCYHeader := '';
                    wgVALExchRate := '';
                end
                else begin
                    wgShowVATLCY := true;
                    if wgRecGLSetup."LCY Code" = '' then
                        wgVALSpecLCYHeader := Trl('VATAmtSpecIn') + ' ' + Trl('LocalCurrency')
                    else
                        wgVALSpecLCYHeader := Trl('VATAmtSpecIn') + ' ' + Format(wgRecGLSetup."LCY Code");
                    wgRecCurrExchRate.FindCurrency(SalesHdr."Posting Date", SalesHdr."Currency Code", 1);
                    wgVALExchRate := CopyStr(StrSubstNo(Trl('ExchangeRate%1/%2'), wgRecCurrExchRate."Relational Exch. Rate Amount", wgRecCurrExchRate."Exchange Rate Amount"), 1, 50);
                end;

                //Get Item Tracking
                TrackingSpec.Reset();
                TrackingSpec.DeleteAll();
                if wgShowLotSN then begin
                    wgCduItemTrackingDocMgt.SetRetrieveAsmItemTracking(true);
                    wgCduItemTrackingDocMgt.RetrieveDocumentItemTracking(TrackingSpec, SalesHdr."No.",
                        Database::"Sales Header", SalesHdr."Document Type");
                end;

                //Set HideLineDiscount
                wlRecRef.GetTable(SalesHdr);
                wgHideLineDiscount := wgCduwDCR_ReportFunctions.wgFncHideLineDiscount(wlRecRef);

                if not wgRecLocation.Get("Location Code") then
                    Clear(wgRecLocation);

                if not wgRecShippingAgent.Get("Shipping Agent Code") then
                    Clear(wgRecShippingAgent);
            end;
        }
    }

    requestpage
    {
        SaveValues = true;

        layout
        {
            area(content)
            {
                group(Options)
                {
                    Caption = 'Options';
                    field(NoOfCopies; wgNoOfCopies)
                    {
                        ApplicationArea = All;
                        Caption = 'No. of Copies';
                    }
                    field(ShowInternalInfo; wgShowInternalInfo)
                    {
                        ApplicationArea = All;
                        Caption = 'Show Internal Information';
                    }
                    field(ShowLotSN; wgShowLotSN)
                    {
                        ApplicationArea = All;
                        Caption = 'Show Serial/Lot Number';
                        Visible = false;
                    }
                    field(ArchiveDocument; wgArchiveDocument)
                    {
                        ApplicationArea = All;
                        Caption = 'Archive Document';

                        trigger OnValidate()
                        begin
                            if not wgArchiveDocument then
                                wgLogInteraction := false;
                        end;
                    }
                    field(LogInteraction; wgLogInteraction)
                    {
                        ApplicationArea = All;
                        Caption = 'Log Interaction';
                        Enabled = wgLogInteractionEnable;

                        trigger OnValidate()
                        begin
                            if wgLogInteraction then
                                wgArchiveDocument := wgArchiveDocumentEnable;
                        end;
                    }
                    field(ShowAssemblyComponents; wgDisplayAssemblyInformation)
                    {
                        ApplicationArea = All;
                        Caption = 'Show Assembly Components';
                    }
                }
            }
        }

        trigger OnInit()
        begin
            wgLogInteractionEnable := true;
        end;

        trigger OnOpenPage()
        begin
            wgArchiveDocument := wgRecSalesSetup."Archive Orders";
            wgLogInteraction := false;

            wgLogInteractionEnable := wgLogInteraction;

            wgNoOfCopies := 0;
        end;
    }

    trigger OnInitReport()
    begin
        wgRecGLSetup.Get();

        wgRecSalesSetup.Get();

        wgRecCompanyInfo.Get();

        if wgRecSalesSetup."Logo Position on Documents" <> wgRecSalesSetup."Logo Position on Documents"::"No Logo" then
            wgRecCompanyInfo.CalcFields(Picture);
    end;

    trigger OnPreReport()
    begin
        wlFncInitReportSettings();
        wgPrint := wgPrint or not CurrReport.Preview();

        if not CurrReport.UseRequestPage() then
            wgNoOfCopies := 0;
    end;

    var
        wgRecAsmHeader: Record "Assembly Header";
        wgRecCompanyInfo: Record "Company Information";
        wgRecCurrExchRate: Record "Currency Exchange Rate";
        wgRecGLSetup: Record "General Ledger Setup";
        wgRecLocation: Record Location;
        wgRecPaymentMethod: Record "Payment Method";
        wgRecPaymentTerms: Record "Payment Terms";
        wgRecSalesSetup: Record "Sales & Receivables Setup";
        wgRecSalesPurchPerson: Record "Salesperson/Purchaser";
        wgRecShipmentMethod: Record "Shipment Method";
        wgRecShippingAgent: Record "Shipping Agent";
        wgCduArchiveManagement: Codeunit ArchiveManagement;
        wgCduFormatAddr: Codeunit "Format Address";
        wgCduFormatDoc: Codeunit "Format Document";
        wgCduItemTrackingDocMgt: Codeunit "Item Tracking Doc. Management";
        wgCduLanguage: Codeunit Language;
        wgCduSegManagement: Codeunit SegManagement;
        wgCduwDCR_ReportFunctions: Codeunit wDCR_ReportFunctions;
        wgCduwDCR_TranslationMgt: Codeunit wDCR_TranslationMgt;
        wgArchiveDocument: Boolean;
        [InDataSet]
        wgArchiveDocumentEnable: Boolean;
        wgAsmInfoExistsForLine: Boolean;
        wgDisplayAssemblyInformation: Boolean;
        wgHideLineDiscount: Boolean;
        wgLogInteraction: Boolean;
        [InDataSet]
        wgLogInteractionEnable: Boolean;
        wgMonolithicVAT: Boolean;
        wgPrint: Boolean;
        wgShowInternalInfo: Boolean;
        wgShowLotSN: Boolean;
        wgShowShippingAddr: Boolean;
        wgShowVATLCY: Boolean;
        wgTotAmount: Decimal;
        wgTotInvDiscAmount: Decimal;
        wgTotInvDiscBaseAmount: Decimal;
        wgTotLineAmount: Decimal;
        wgTotPaymentDiscOnVAT: Decimal;
        wgTotVALVATAmountLCY: Decimal;
        wgTotVALVATBaseLCY: Decimal;
        wgTotVATAmount: Decimal;
        wgVALVATAmountLCY: Decimal;
        wgVALVATBaseLCY: Decimal;
        wgDateFormatHdr: Integer;
        wgNoOfCopies: Integer;
        wgNoOfLoops: Integer;
        wgNoOfVATAmountLines: Integer;
        wgOutputNo: Integer;
        wgReportId: Integer;
        wgCompanyInfoFaxNo: Text;
        wgCompanyInfoPhoneNo: Text;
        wgCopyText: Text[30];
        wgVATAmountText: Text[30];
        wgTotalExclVATText: Text[50];
        wgTotalInclVATText: Text[50];
        wgTotalText: Text[50];
        wgVALExchRate: Text[50];
        wgVALSpecLCYHeader: Text[80];
        wgCompanyAddr: array[8] of Text[100];
        wgCustAddr: array[8] of Text[100];
        wgShipToAddr: array[8] of Text[100];
        wgDimText: Text[120];

    procedure InitializeRequest(pNoOfCopiesFrom: Integer; pShowInternalInfoFrom: Boolean; pArchiveDocumentFrom: Boolean; pLogInteractionFrom: Boolean; pPrintFrom: Boolean; pDisplayAsmInfo: Boolean)
    begin
        wgNoOfCopies := pNoOfCopiesFrom;
        wgShowInternalInfo := pShowInternalInfoFrom;
        wgArchiveDocument := pArchiveDocumentFrom;
        wgLogInteraction := pLogInteractionFrom;
        wgPrint := pPrintFrom;
        wgDisplayAssemblyInformation := pDisplayAsmInfo;
    end;

    local procedure Trl(pLblName: Text[50]): Text
    begin
        exit(wgCduwDCR_TranslationMgt.wgFncTranslate(pLblName));
    end;

    local procedure wlFncFormatAddressFields(var vRecSalesHeader: Record "Sales Header")
    var
        wlRecRespCenter: Record "Responsibility Center";
    begin
        wgCduFormatAddr.GetCompanyAddr(vRecSalesHeader."Responsibility Center", wlRecRespCenter, wgRecCompanyInfo, wgCompanyAddr);
        wgCompanyInfoPhoneNo := wgRecCompanyInfo."Phone No.";
        wgCompanyInfoFaxNo := wgRecCompanyInfo."Fax No.";
        wgCduFormatAddr.SalesHeaderBillTo(wgCustAddr, vRecSalesHeader);
        wgShowShippingAddr := wgCduFormatAddr.SalesHeaderShipTo(wgShipToAddr, wgCustAddr, vRecSalesHeader);
    end;

    local procedure wlFncFormatDocumentFields(pRecSalesHeader: Record "Sales Header")
    var
        wlCurrencyCode: Code[10];
        wlSalesPersonText: Text[50];
    begin
        wlCurrencyCode := pRecSalesHeader."Currency Code";
        if wlCurrencyCode = '' then begin
            wgRecGLSetup.TestField("LCY Code");
            wlCurrencyCode := wgRecGLSetup."LCY Code";
        end;
        wgTotalText := CopyStr(StrSubstNo(Trl('Total%1'), wlCurrencyCode), 1, MaxStrLen(wgTotalText));
        wgTotalInclVATText := CopyStr(StrSubstNo(Trl('Total%1InclVAT'), wlCurrencyCode), 1, MaxStrLen(wgTotalInclVATText));
        wgTotalExclVATText := CopyStr(StrSubstNo(Trl('Total%1ExclVAT'), wlCurrencyCode), 1, MaxStrLen(wgTotalExclVATText));
        wgCduFormatDoc.SetSalesPerson(wgRecSalesPurchPerson, pRecSalesHeader."Salesperson Code", wlSalesPersonText);
        wgCduFormatDoc.SetPaymentTerms(wgRecPaymentTerms, pRecSalesHeader."Payment Terms Code", pRecSalesHeader."Language Code");
        wgCduFormatDoc.SetPaymentMethod(wgRecPaymentMethod, pRecSalesHeader."Payment Method Code", pRecSalesHeader."Language Code");
        wgCduFormatDoc.SetShipmentMethod(wgRecShipmentMethod, pRecSalesHeader."Shipment Method Code", pRecSalesHeader."Language Code");
    end;

    local procedure wlFncInitReportSettings()
    var
        wlCduTemplateReportHelperDCR: Codeunit TemplateReportHelperDCR;
    begin
        if wgReportId = 0 then
            Evaluate(wgReportId, (DelChr(CurrReport.ObjectId(false), '=', DelChr(CurrReport.ObjectId(false), '=', '1234567890'))));
        wgCduwDCR_TranslationMgt.wgFncSetReportId(wgReportId);
        wgDateFormatHdr := wlCduTemplateReportHelperDCR.wgFncGetHeaderDateFormat(wgReportId);
    end;
}
