report 72104 SalesShipmentDCR
{
    Caption = 'Sales - Shipment';
    PreviewMode = PrintLayout;
    UsageCategory = None;

    dataset
    {
        dataitem(ShptHdr; "Sales Shipment Header")
        {
            DataItemTableView = sorting("No.");
            RequestFilterFields = "No.", "Sell-to Customer No.", "No. Printed";
            RequestFilterHeading = 'Posted Sales Shipment';

            column(BilltoCustNo; "Bill-to Customer No.") { }
            column(CompanyAddr1; wgCompanyAddr[1]) { }
            column(CompanyAddr2; wgCompanyAddr[2]) { }
            column(CompanyAddr3; wgCompanyAddr[3]) { }
            column(CompanyAddr4; wgCompanyAddr[4]) { }
            column(CompanyAddr5; wgCompanyAddr[5]) { }
            column(CompanyAddr6; wgCompanyAddr[6]) { }
            column(CompanyBankAccNo; wgRecCompanyInfo."Bank Account No.") { }
            column(CompanyBankBranchNo; wgRecCompanyInfo."Bank Branch No.") { }
            column(CompanyBankName; wgRecCompanyInfo."Bank Name") { }
            column(CompanyCity; wgRecCompanyInfo.City) { }
            column(CompanyEMail; wgRecCompanyInfo."E-Mail") { }
            column(CompanyFaxNo; wgRecCompanyInfo."Fax No.") { }
            column(CompanyGiroNo; wgRecCompanyInfo."Giro No.") { }
            column(CompanyHomePage; wgRecCompanyInfo."Home Page") { }
            column(CompanyIBAN; wgRecCompanyInfo.IBAN) { }
            column(CompanyPhoneNo; wgRecCompanyInfo."Phone No.") { }
            column(CompanyPicture; wgRecCompanyInfo.Picture) { }
            column(CompanyRegistrationNo; wgRecCompanyInfo."Registration No.") { }
            column(CompanySWIFT; wgRecCompanyInfo."SWIFT Code") { }
            column(CompanyVATRegNo; wgRecCompanyInfo."VAT Registration No.") { }
            column(CustAddr1; wgCustAddr[1]) { }
            column(CustAddr2; wgCustAddr[2]) { }
            column(CustAddr3; wgCustAddr[3]) { }
            column(CustAddr4; wgCustAddr[4]) { }
            column(CustAddr5; wgCustAddr[5]) { }
            column(CustAddr6; wgCustAddr[6]) { }
            column(CustAddr7; wgCustAddr[7]) { }
            column(CustAddr8; wgCustAddr[8]) { }
            column(CustAddrSet; wgShowCustAddr) { }
            column(DocumentDate; "Document Date") { }
            column(DocumentDateText; Format("Document Date", 0, wgDateFormatHdr)) { }
            column(DocumentNo; "No.") { }
            column(ExternalDocumentNo; "External Document No.") { }
            column(LanguageCode; "Language Code") { }
            column(lblAttachedToLineNo; Trl('AttachedToLineNo')) { }
            column(lblBankAccNo; Trl('BankAccNo')) { }
            column(lblBankBranchNo; Trl('BankBranchNo')) { }
            column(lblBankName; Trl('BankName')) { }
            column(lblBillToAddress; Trl('BillToAddress')) { }
            column(lblBillToCustomerNo; Trl('BillToCustomerNo')) { }
            column(lblCompanyRegistrationNo; Trl('CompanyRegistrationNo')) { }
            column(lblCrossReferenceNo; Trl('CrossReferenceNo')) { }
            column(lblDescription; Trl('Description')) { }
            column(lblDocumentDate; Trl('DocumentDate')) { }
            column(lblDocumentNo; Trl('DocumentNo')) { }
            column(lblEmail; Trl('Email')) { }
            column(lblExternalDocumentNo; Trl('ExternalDocumentNo')) { }
            column(lblFaxNo; Trl('FaxNo')) { }
            column(lblFreeText1; Trl('FreeText1')) { }
            column(lblFreeText2; Trl('FreeText2')) { }
            column(lblFreeText3; Trl('FreeText3')) { }
            column(lblFreeText4; Trl('FreeText4')) { }
            column(lblGiroNo; Trl('GiroNo')) { }
            column(lblGLAccountNo; Trl('GLAccountNo')) { }
            column(lblGrossWeight; Trl('GrossWeight')) { }
            column(lblHeaderDimensions; Trl('HeaderDimensions')) { }
            column(lblHomePage; Trl('HomePage')) { }
            column(lblIBAN; Trl('IBAN')) { }
            column(lblLineDimensions; Trl('LineDimensions')) { }
            column(lblLineNo; Trl('LineNo')) { }
            column(lblLocationCode; Trl('LocationCode')) { }
            column(lblLotNo; Trl('LotNo')) { }
            column(lblNetWeight; Trl('NetWeight')) { }
            column(lblNo; Trl('No')) { }
            column(lblOrderDate; Trl('OrderDate')) { }
            column(lblOrderNo; Trl('OrderNo')) { }
            column(lblPageOf; Trl('Page{0}of{1}')) { }
            column(lblPhoneNo; Trl('PhoneNo')) { }
            column(lblPostingDate; Trl('PostingDate')) { }
            column(lblQtyPerUOM; Trl('QtyPerUOM')) { }
            column(lblQuantity; Trl('Quantity')) { }
            column(lblQuantityBase; Trl('QuantityBase')) { }
            column(lblQuantityInvoiced; Trl('QuantityInvoiced')) { }
            column(lblSalesPerson; Trl('SalesPerson')) { }
            column(lblSellToCustomerNo; Trl('SellToCustomerNo')) { }
            column(lblSerialNo; Trl('SerialNo')) { }
            column(lblShipment; Trl('Shipment')) { }
            column(lblShipmentDate; Trl('ShipmentDate')) { }
            column(lblShipmentMethod; Trl('ShipmentMethod')) { }
            column(lblShipmentNo; Trl('ShipmentNo')) { }
            column(lblShipToAddress; Trl('ShipToAddress')) { }
            column(lblSubtotal; Trl('Subtotal')) { }
            column(lblSWIFT; Trl('SWIFT')) { }
            column(lblTotal; Trl('Total')) { }
            column(lblTotalGrossWeight; Trl('TotalGrossWeight')) { }
            column(lblTotalNetWeight; Trl('TotalNetWeight')) { }
            column(lblTotalTransFooter; Trl('TotalTransFooter')) { }
            column(lblTotalTransHeader; Trl('TotalTransHeader')) { }
            column(lblType; Trl('Type')) { }
            column(lblUnitCost; Trl('UnitCost')) { }
            column(lblUnitCostLCY; Trl('UnitCostLCY')) { }
            column(lblUnitsPerParcel; Trl('UnitsPerParcel')) { }
            column(lblUOM; Trl('UOM')) { }
            column(lblUOMCode; Trl('UOMCode')) { }
            column(lblVATPerc; Trl('VATPerc')) { }
            column(lblVATRegistrationNo; Trl('VATRegistrationNo')) { }
            column(lblWorkDescription; Trl('WorkDescription')) { }
            column(lblYourReference; Trl('YourReference')) { }
            column(LocationCity; wgRecLocation.City) { }
            column(LocationCode; "Location Code") { }
            column(LocationName; wgRecLocation.Name) { }
            column(OrderContactMobilePhoneNo; wgRecOrderContact."Mobile Phone No.") { }
            column(OrderContactPhoneNo; wgRecOrderContact."Phone No.") { }
            column(OrderDate; "Order Date") { }
            column(OrderDateText; Format("Order Date", 0, wgDateFormatHdr)) { }
            column(OrderNo; "Order No.") { }
            column(PostingDate; "Posting Date") { }
            column(PostingDateText; Format("Posting Date", 0, wgDateFormatHdr)) { }
            column(SalesPurchPersonName; wgRecSalesPurchPerson.Name) { }
            column(SelltoCustNo; "Sell-to Customer No.") { }
            column(SelltoPhoneNo; "Sell-to Phone No.") { }
            column(ShipmentMethodDesc; wgRecShipmentMethod.Description) { }
            column(ShipToAddr1; wgShipToAddr[1]) { }
            column(ShipToAddr2; wgShipToAddr[2]) { }
            column(ShipToAddr3; wgShipToAddr[3]) { }
            column(ShipToAddr4; wgShipToAddr[4]) { }
            column(ShipToAddr5; wgShipToAddr[5]) { }
            column(ShipToAddr6; wgShipToAddr[6]) { }
            column(ShipToAddr7; wgShipToAddr[7]) { }
            column(ShipToAddr8; wgShipToAddr[8]) { }
            column(ShowCorrectionLines; wgShowCorrectionLines) { }
            column(ShowLotSN; wgShowLotSN) { }
            column(TodayText; Format(Today(), 0, wgDateFormatHdr)) { }
            column(VATRegNo; "VAT Registration No.") { }
            column(WorkDescription; "Work Description") { }
            column(YourReference; "Your Reference") { }

            dataitem(CopyLoop; "Integer")
            {
                DataItemTableView = sorting(Number);

                column(OutputNo; wgOutputNo) { }
                column(SalesShipmentTitle; StrSubstNo(Trl('SalesShipment%1'), wgCopyText)) { }

                dataitem(HdrComment; "Sales Comment Line")
                {
                    DataItemLink = "No." = Field("No.");
                    DataItemLinkReference = ShptHdr;
                    DataItemTableView = sorting("Document Type", "No.", "Document Line No.", "Line No.") where("Document Type" = const(Shipment), "Document Line No." = const(0));

                    column(Comment; Comment) { }

                    trigger OnPreDataItem()
                    begin
                        if not wgShowInternalInfo then
                            CurrReport.Break();
                    end;
                }
                dataitem(HeaderDim; "Dimension Set Entry")
                {
                    DataItemLink = "Dimension Set ID" = Field("Dimension Set ID");
                    DataItemLinkReference = ShptHdr;
                    DataItemTableView = sorting("Dimension Set ID", "Dimension Code");

                    column(DimText; wgDimText) { }

                    trigger OnAfterGetRecord()
                    begin
                        wgCduwDCR_ReportFunctions.wgFncGetDimText(HeaderDim, wgDimText);
                    end;

                    trigger OnPreDataItem()
                    begin
                        if not wgShowInternalInfo then
                            CurrReport.Break();
                    end;
                }
                dataitem(ShptLine; "Sales Shipment Line")
                {
                    DataItemLink = "Document No." = Field("No.");
                    DataItemLinkReference = ShptHdr;
                    DataItemTableView = sorting("Document No.", "Line No.");

                    column(AttachedToLineNo; "Attached to Line No.") { }
                    column(CrossReferenceNo; "Cross-Reference No.") { }
                    column(Description; Description) { }
                    column(Description2; "Description 2") { }
                    column(GrossWeight; Quantity * "Gross Weight") { }
                    column(LineNo; "Line No.") { }
                    column(NetWeight; Quantity * "Net Weight") { }
                    column(No_2; "No.") { }
                    column(QtyInvoicedBase; "Qty. Invoiced (Base)") { }
                    column(QtyPerUOM; "Qty. per Unit of Measure") { }
                    column(Quantity; Quantity) { }
                    column(QuantityBase; "Quantity (Base)") { }
                    column(QuantityInvoiced; "Quantity Invoiced") { }
                    column(Type; Format(Type)) { }
                    column(TypeNo; Type.AsInteger()) { }
                    column(UnitCost; "Unit Cost") { }
                    column(UnitCostLCY; "Unit Cost (LCY)") { }
                    column(UnitPrice; "Unit Price")
                    {
                        AutoFormatExpression = "Currency Code";
                        AutoFormatType = 2;
                    }
                    column(UnitsPerParcel; "Units per Parcel") { }
                    column(UOM; wgCduwDCR_TranslationMgt.wgFncGetUnitOfMeaseTrl("Unit of Measure Code")) { }
                    column(UOMCode; "Unit of Measure Code") { }

                    dataitem(LineComment; "Sales Comment Line")
                    {
                        DataItemLink = "No." = Field("Document No."), "Document Line No." = Field("Line No.");
                        DataItemTableView = sorting("Document Type", "No.", "Document Line No.", "Line No.") where("Document Type" = const(Shipment));
                        column(Comment_2; Comment) { }

                        trigger OnPreDataItem()
                        begin
                            if not wgShowInternalInfo then
                                CurrReport.Break();
                        end;
                    }
                    dataitem(LineDim; "Dimension Set Entry")
                    {
                        DataItemLink = "Dimension Set ID" = Field("Dimension Set ID");
                        DataItemTableView = sorting("Dimension Set ID", "Dimension Code");

                        column(DimText_2; wgDimText) { }

                        trigger OnAfterGetRecord()
                        begin
                            wgCduwDCR_ReportFunctions.wgFncGetDimText(LineDim, wgDimText);
                        end;

                        trigger OnPreDataItem()
                        begin
                            if not wgShowInternalInfo then
                                CurrReport.Break();
                        end;
                    }
                    dataitem(AsmLine; "Posted Assembly Line")
                    {
                        DataItemTableView = sorting("Document No.", "Line No.");
                        UseTemporary = true;

                        column(Description_3; Description) { }
                        column(LineNo_2; "No.") { }
                        column(Quantity_3; Quantity)
                        {
                            DecimalPlaces = 0 : 5;
                        }
                        column(UOM_2; wgCduwDCR_TranslationMgt.wgFncGetUnitOfMeaseTrl("Unit of Measure Code")) { }

                        trigger OnPreDataItem()
                        begin
                            Reset();
                        end;
                    }
                    dataitem(TrackingSpec; "Tracking Specification")
                    {
                        DataItemTableView = sorting("Entry No.");
                        UseTemporary = true;

                        column(LotNo; "Lot No.") { }
                        column(Quantity_4; "Quantity (Base)") { }
                        column(SerialNo; "Serial No.") { }

                        trigger OnAfterGetRecord()
                        begin
                            wgTotalTrackingQty += TrackingSpec."Quantity (Base)";
                        end;

                        trigger OnPreDataItem()
                        begin
                            if not wgShowLotSN then
                                CurrReport.Break();

                            Reset();
                            SetRange("Source Ref. No.", ShptLine."Line No.");
                            wgTotalTrackingQty := 0;
                        end;
                    }

                    trigger OnAfterGetRecord()
                    begin
                        if not wgShowCorrectionLines and Correction then
                            CurrReport.Skip();

                        if wgDisplayAssemblyInformation then
                            wlFncCollectAsmInformation(ShptLine, AsmLine);
                    end;

                    trigger OnPreDataItem()
                    var
                        wlMoreLines: Boolean;
                    begin
                        wlMoreLines := ShptLine.Find('+');
                        while wlMoreLines and (Description = '') and ("No." = '') and (Quantity = 0) do
                            wlMoreLines := Next(-1) <> 0;
                        if not wlMoreLines then
                            CurrReport.Break();
                        SetRange("Line No.", 0, "Line No.");
                    end;
                }
                dataitem(Total; "Integer")
                {
                    DataItemTableView = sorting(Number) where(Number = const(1));

                    column(TotalTrackingQty; wgTotalTrackingQty) { }
                }

                trigger OnAfterGetRecord()
                begin
                    if Number > 1 then begin
                        wgCopyText := CopyStr(Trl('Copy'), 1, MaxStrLen(wgCopyText));
                        wgOutputNo += 1;
                    end;
                end;

                trigger OnPostDataItem()
                begin
                    if not CurrReport.Preview() then
                        Codeunit.Run(Codeunit::"Sales Shpt.-Printed", ShptHdr);
                end;

                trigger OnPreDataItem()
                begin
                    wgNoOfLoops := Abs(wgNoOfCopies) + 1;
                    wgCopyText := '';
                    SetRange(Number, 1, wgNoOfLoops);
                    wgOutputNo := 1;
                end;
            }

            trigger OnAfterGetRecord()
            begin
                CurrReport.Language := wgCduLanguage.GetLanguageIdOrDefault("Language Code");
                wgCduwDCR_TranslationMgt.wgFncSetLanguageCode("Language Code");

                wlFncFormatAddressFields(ShptHdr);
                wlFncFormatDocumentFields(ShptHdr);

                if wgLogInteraction then
                    if not CurrReport.Preview() then
                        wgCduSegManagement.LogDocument(
                          5, "No.", 0, 0, Database::Customer, "Sell-to Customer No.", "Salesperson Code",
                          "Campaign No.", "Posting Description", '');

                // Get Item Tracking
                TrackingSpec.Reset();
                TrackingSpec.DeleteAll();
                if wgShowLotSN then begin
                    wgCduItemTrackingDocMgt.SetRetrieveAsmItemTracking(true);
                    wgCduItemTrackingDocMgt.RetrieveDocumentItemTracking(TrackingSpec, ShptHdr."No.",
                        Database::"Sales Shipment Header", 0);
                end;

                if not wgRecLocation.Get("Location Code") then
                    Clear(wgRecLocation);

                if not wgRecOrderContact.Get("Sell-to Contact No.") then
                    Clear(wgRecOrderContact);

                if not wgRecShippingAgent.Get("Shipping Agent Code") then
                    Clear(wgRecShippingAgent);
            end;
        }
    }

    requestpage
    {
        SaveValues = true;

        layout
        {
            area(content)
            {
                group(Options)
                {
                    Caption = 'Options';
                    field(NoOfCopies; wgNoOfCopies)
                    {
                        ApplicationArea = All;
                        Caption = 'No. of Copies';
                    }
                    field(ShowInternalInfo; wgShowInternalInfo)
                    {
                        ApplicationArea = All;
                        Caption = 'Show Internal Information';
                    }
                    field(ShowLotSN; wgShowLotSN)
                    {
                        ApplicationArea = All;
                        Caption = 'Show Serial/Lot Number';
                    }
                    field(LogInteraction; wgLogInteraction)
                    {
                        ApplicationArea = All;
                        Caption = 'Log Interaction';
                        Enabled = wgLogInteractionEnable;
                    }
                    field("Show Correction Lines"; wgShowCorrectionLines)
                    {
                        ApplicationArea = All;
                        Caption = 'Show Correction Lines';
                    }
                    field(ShowAssemblyComponents; wgDisplayAssemblyInformation)
                    {
                        ApplicationArea = All;
                        Caption = 'Show Assembly Components';
                    }
                }
            }
        }

        trigger OnInit()
        begin
            wgLogInteractionEnable := true;
        end;

        trigger OnOpenPage()
        begin
            wlFncInitLogInteraction();

            wgLogInteractionEnable := wgLogInteraction;

            wgNoOfCopies := 0;
        end;
    }

    trigger OnInitReport()
    begin
        wgRecSalesSetup.Get();

        wgRecCompanyInfo.Get();

        if wgRecSalesSetup."Logo Position on Documents" <> wgRecSalesSetup."Logo Position on Documents"::"No Logo" then
            wgRecCompanyInfo.CalcFields(Picture);
    end;

    trigger OnPreReport()
    begin
        wlFncInitReportSettings();
        if not CurrReport.UseRequestPage() then begin
            wlFncInitLogInteraction();
            wgNoOfCopies := 0;
        end;
    end;

    var
        wgRecCompanyInfo: Record "Company Information";
        wgRecOrderContact: Record Contact;
        wgRecLocation: Record Location;
        wgRecSalesSetup: Record "Sales & Receivables Setup";
        wgRecSalesPurchPerson: Record "Salesperson/Purchaser";
        wgRecShipmentMethod: Record "Shipment Method";
        wgRecShippingAgent: Record "Shipping Agent";
        wgCduFormatAddr: Codeunit "Format Address";
        wgCduFormatDoc: Codeunit "Format Document";
        wgCduItemTrackingDocMgt: Codeunit "Item Tracking Doc. Management";
        wgCduLanguage: Codeunit Language;
        wgCduSegManagement: Codeunit SegManagement;
        wgCduwDCR_ReportFunctions: Codeunit wDCR_ReportFunctions;
        wgCduwDCR_TranslationMgt: Codeunit wDCR_TranslationMgt;
        wgDisplayAssemblyInformation: Boolean;
        wgLogInteraction: Boolean;
        [InDataSet]
        wgLogInteractionEnable: Boolean;
        wgShowCorrectionLines: Boolean;
        wgShowCustAddr: Boolean;
        wgShowInternalInfo: Boolean;
        wgShowLotSN: Boolean;
        wgTotalTrackingQty: Decimal;
        wgDateFormatHdr: Integer;
        wgNoOfCopies: Integer;
        wgNoOfLoops: Integer;
        wgOutputNo: Integer;
        wgReportId: Integer;
        wgCompanyInfoFaxNo: Text;
        wgCompanyInfoPhoneNo: Text;
        wgCopyText: Text[30];
        wgCompanyAddr: array[8] of Text[100];
        wgCustAddr: array[8] of Text[100];
        wgShipToAddr: array[8] of Text[100];
        wgDimText: Text[120];

    procedure InitializeRequest(pNewNoOfCopies: Integer; pNewShowInternalInfo: Boolean; pNewLogInteraction: Boolean; pNewShowCorrectionLines: Boolean; pNewShowLotSN: Boolean; pDisplayAsmInfo: Boolean)
    begin
        wgNoOfCopies := pNewNoOfCopies;
        wgShowInternalInfo := pNewShowInternalInfo;
        wgLogInteraction := pNewLogInteraction;
        wgShowCorrectionLines := pNewShowCorrectionLines;
        wgShowLotSN := pNewShowLotSN;
        wgDisplayAssemblyInformation := pDisplayAsmInfo;
    end;

    local procedure Trl(pLblName: Text[50]): Text
    begin
        exit(wgCduwDCR_TranslationMgt.wgFncTranslate(pLblName));
    end;

    local procedure wlFncCollectAsmInformation(var vRecSalesShptLine: Record "Sales Shipment Line"; var vRecPostedAsmLine: Record "Posted Assembly Line")
    var
        wlRecPostedAsmHeader: Record "Posted Assembly Header";
        wlRecPostedAsmLine: Record "Posted Assembly Line";
    begin
        //According CollectAsmInformation Report 206
        if vRecSalesShptLine.AsmToShipmentExists(wlRecPostedAsmHeader) then begin
            wlRecPostedAsmLine.SetRange("Document No.", wlRecPostedAsmHeader."No.");
            if wlRecPostedAsmLine.FindSet() then
                repeat
                    wlFncTreatAsmLineBuffer(wlRecPostedAsmLine, vRecPostedAsmLine);
                until wlRecPostedAsmLine.Next() = 0;
        end;
    end;

    local procedure wlFncFormatAddressFields(var vRecSalesShptHeader: Record "Sales Shipment Header")
    var
        wlRecRespCenter: Record "Responsibility Center";
    begin
        wgCduFormatAddr.GetCompanyAddr(vRecSalesShptHeader."Responsibility Center", wlRecRespCenter, wgRecCompanyInfo, wgCompanyAddr);
        wgCompanyInfoPhoneNo := wgRecCompanyInfo."Phone No.";
        wgCompanyInfoFaxNo := wgRecCompanyInfo."Fax No.";
        wgCduFormatAddr.SalesShptShipTo(wgShipToAddr, vRecSalesShptHeader);
        wgShowCustAddr := wgCduFormatAddr.SalesShptBillTo(wgCustAddr, wgShipToAddr, vRecSalesShptHeader);
    end;

    local procedure wlFncFormatDocumentFields(pRecSalesShptHeader: Record "Sales Shipment Header")
    var
        wlSalesPersonText: Text[50];
    begin
        wgCduFormatDoc.SetSalesPerson(wgRecSalesPurchPerson, pRecSalesShptHeader."Salesperson Code", wlSalesPersonText);
        wgCduFormatDoc.SetShipmentMethod(wgRecShipmentMethod, pRecSalesShptHeader."Shipment Method Code", pRecSalesShptHeader."Language Code");
    end;

    local procedure wlFncInitLogInteraction()
    begin
        wgLogInteraction := wgCduSegManagement.FindInteractTmplCode(5) <> '';
    end;

    local procedure wlFncInitReportSettings()
    var
        wlCduTemplateReportHelperDCR: Codeunit TemplateReportHelperDCR;
    begin
        if wgReportId = 0 then
            Evaluate(wgReportId, (DelChr(CurrReport.ObjectId(false), '=', DelChr(CurrReport.ObjectId(false), '=', '1234567890'))));
        wgCduwDCR_TranslationMgt.wgFncSetReportId(wgReportId);
        wgDateFormatHdr := wlCduTemplateReportHelperDCR.wgFncGetHeaderDateFormat(wgReportId);
    end;

    local procedure wlFncTreatAsmLineBuffer(var vRecPostedAsmLine: Record "Posted Assembly Line"; var vRecPostedAsmLineBuffer: Record "Posted Assembly Line")
    begin
        //According TreatAsmLineBuffer Report 206
        //Needed for AsmLine
        Clear(vRecPostedAsmLineBuffer);
        vRecPostedAsmLineBuffer.SetRange(Type, vRecPostedAsmLine.Type);
        vRecPostedAsmLineBuffer.SetRange("No.", vRecPostedAsmLine."No.");
        vRecPostedAsmLineBuffer.SetRange("Variant Code", vRecPostedAsmLine."Variant Code");
        vRecPostedAsmLineBuffer.SetRange(Description, vRecPostedAsmLine.Description);
        vRecPostedAsmLineBuffer.SetRange("Unit of Measure Code", vRecPostedAsmLine."Unit of Measure Code");
        if vRecPostedAsmLineBuffer.FindFirst() then begin
            vRecPostedAsmLineBuffer.Quantity += vRecPostedAsmLine.Quantity;
            vRecPostedAsmLineBuffer.Modify();
        end else begin
            Clear(vRecPostedAsmLineBuffer);
            vRecPostedAsmLineBuffer := vRecPostedAsmLine;
            vRecPostedAsmLineBuffer.Insert();
        end;
    end;
}
