report 72177 ServiceContractDCR
{
    Caption = 'Service - Contract';
    PreviewMode = PrintLayout;
    UsageCategory = None;

    dataset
    {
        dataitem(ContHdr; "Service Contract Header")
        {
            DataItemTableView = sorting("Contract Type", "Contract No.") where("Contract Type" = const(Contract));
            PrintOnlyIfDetail = true;
            RequestFilterFields = "Contract No.", "Customer No.";
            column(AnnualAmount; "Annual Amount")
            {
            }
            column(BilltoCustNo; "Bill-to Customer No.")
            {
            }
            column(BilltoName; "Bill-to Name")
            {
            }
            column(CompanyAddr1; wgCompanyAddr[1])
            {
            }
            column(CompanyAddr2; wgCompanyAddr[2])
            {
            }
            column(CompanyAddr3; wgCompanyAddr[3])
            {
            }
            column(CompanyAddr4; wgCompanyAddr[4])
            {
            }
            column(CompanyAddr5; wgCompanyAddr[5])
            {
            }
            column(CompanyAddr6; wgCompanyAddr[6])
            {
            }
            column(CompanyBankAccNo; wgRecCompanyInfo."Bank Account No.")
            {
            }
            column(CompanyBankName; wgRecCompanyInfo."Bank Name")
            {
            }
            column(CompanyEMail; wgRecCompanyInfo."E-Mail")
            {
            }
            column(CompanyFaxNo; wgRecCompanyInfo."Fax No.")
            {
            }
            column(CompanyGiroNo; wgRecCompanyInfo."Giro No.")
            {
            }
            column(CompanyHomePage; wgRecCompanyInfo."Home Page")
            {
            }
            column(CompanyIBAN; wgRecCompanyInfo.IBAN)
            {
            }
            column(CompanyPhoneNo; wgRecCompanyInfo."Phone No.")
            {
            }
            column(CompanyPicture; wgRecCompanyInfo.Picture)
            {
            }
            column(CompanyRegistrationNo; wgRecCompanyInfo."Registration No.")
            {
            }
            column(CompanySWIFT; wgRecCompanyInfo."SWIFT Code")
            {
            }
            column(CompanyVATRegNo; wgRecCompanyInfo."VAT Registration No.")
            {
            }
            column(ContractNo; "Contract No.")
            {
            }
            column(ContractType; "Contract Type")
            {
            }
            column(CustAddr1; wgCustAddr[1])
            {
            }
            column(CustAddr2; wgCustAddr[2])
            {
            }
            column(CustAddr3; wgCustAddr[3])
            {
            }
            column(CustAddr4; wgCustAddr[4])
            {
            }
            column(CustAddr5; wgCustAddr[5])
            {
            }
            column(CustAddr6; wgCustAddr[6])
            {
            }
            column(CustAddr7; wgCustAddr[7])
            {
            }
            column(CustAddr8; wgCustAddr[8])
            {
            }
            column(CustNo; "Customer No.")
            {
            }
            column(CustomerNo; "Customer No.")
            {
            }
            column(Description2; "Description 2")
            {
            }
            column(Description_2; Description)
            {
            }
            column(EMail; "E-Mail")
            {
            }
            column(ExpirationDate; "Expiration Date")
            {
            }
            column(ExpirationDateText; Format("Expiration Date", 0, wgDateFormatHdr))
            {
            }
            column(InvoicePeriod; Format("Invoice Period"))
            {
            }
            column(LanguageCode; "Language Code")
            {
            }
            column(lblAnnualAmount; Trl('AnnualAmount'))
            {
            }
            column(lbLastServiceDate; Trl('LastServiceDate'))
            {
            }
            column(lblBankAccNo; Trl('BankAccNo'))
            {
            }
            column(lblBankName; Trl('BankName'))
            {
            }
            column(lblBillToAddress; Trl('BillToAddress'))
            {
            }
            column(lblBillToCustomerNo; Trl('BillToCustomerNo'))
            {
            }
            column(lblCompanyRegistrationNo; Trl('CompanyRegistrationNo'))
            {
            }
            column(lblContractNo; Trl('ContractNo'))
            {
            }
            column(lblContractText; Trl('ContractText'))
            {
            }
            column(lblContractType; Trl('ContractType'))
            {
            }
            column(lblCreditMemoDate; Trl('CreditMemoDate'))
            {
            }
            column(lblDate; Trl('Date'))
            {
            }
            column(lblDescription; Trl('Description'))
            {
            }
            column(lblDiscountPerc; Trl('DiscountPerc'))
            {
            }
            column(lblDocumentDate; Trl('DocumentDate'))
            {
            }
            column(lblEmail; Trl('Email'))
            {
            }
            column(lblExpirationDate; Trl('ExpirationDate'))
            {
            }
            column(lblFaxNo; Trl('FaxNo'))
            {
            }
            column(lblGiroNo; Trl('GiroNo'))
            {
            }
            column(lblGLAccountNo; Trl('GLAccountNo'))
            {
            }
            column(lblHeaderComment; Trl('HeaderComment'))
            {
            }
            column(lblHomePage; Trl('HomePage'))
            {
            }
            column(lblIBAN; Trl('IBAN'))
            {
            }
            column(lblInvoicedToDate; Trl('InvoicedToDate'))
            {
            }
            column(lblInvoicePeriod; Trl('InvoicePeriod'))
            {
            }
            column(lblItemNo; Trl('ItemNo'))
            {
            }
            column(lblLineAmount; Trl('LineAmount'))
            {
            }
            column(lblLineComment; Trl('LineComment'))
            {
            }
            column(lblLineNo; Trl('LineNo'))
            {
            }
            column(lblLineValue; Trl('LineValue'))
            {
            }
            column(lblNextInvoiceDate; Trl('NextInvoiceDate'))
            {
            }
            column(lblNo; Trl('No'))
            {
            }
            column(lblPageOf; Trl('Page{0}of{1}'))
            {
            }
            column(lblPhoneNo; Trl('PhoneNo'))
            {
            }
            column(lblQuantity; Trl('Quantity'))
            {
            }
            column(lblResponseTimeHours; Trl('ResponseTimeHours'))
            {
            }
            column(lblSalesPerson; Trl('SalesPerson'))
            {
            }
            column(lblSellToAddress; Trl('SellToAddress'))
            {
            }
            column(lblSerialNo; Trl('SerialNo'))
            {
            }
            column(lblServiceDiscounts; Trl('ServiceDiscounts'))
            {
            }
            column(lblServiceItemNo; Trl('ServiceItemNo'))
            {
            }
            column(lblServicePeriod; Trl('ServicePeriod'))
            {
            }
            column(lblShipment; Trl('Shipment'))
            {
            }
            column(lblShipToAddress; Trl('ShipToAddress'))
            {
            }
            column(lblShipToCode; Trl('ShipToCode'))
            {
            }
            column(lblStartingDate; Trl('StartingDate'))
            {
            }
            column(lblStatus; Trl('Status'))
            {
            }
            column(lblSWIFT; Trl('SWIFT'))
            {
            }
            column(lblTotal; Trl('Total'))
            {
            }
            column(lblType; Trl('Type'))
            {
            }
            column(lblUOM; Trl('UOM'))
            {
            }
            column(lblUOMCode; Trl('UOMCode'))
            {
            }
            column(lblVATIdentifier; Trl('VATIdentifier'))
            {
            }
            column(lblVATPerc; Trl('VATPerc'))
            {
            }
            column(lblVATRegistrationNo; Trl('VATRegistrationNo'))
            {
            }
            column(lblYourReference; Trl('YourReference'))
            {
            }
            column(Name; Name)
            {
            }
            column(NextInvoiceDate; "Next Invoice Date")
            {
            }
            column(NextInvoiceDateText; Format("Next Invoice Date", 0, wgDateFormatHdr))
            {
            }
            column(PhoneNo; "Phone No.")
            {
            }
            column(Print; wgPrint)
            {
            }
            column(SalesPurchPersonName; wgRecSalesPurchPerson.Name)
            {
            }
            column(SalesPurchPersonText; wgSalesPersonText)
            {
            }
            column(ShipToAddr1; wgShipToAddr[1])
            {
            }
            column(ShipToAddr2; wgShipToAddr[2])
            {
            }
            column(ShipToAddr3; wgShipToAddr[3])
            {
            }
            column(ShipToAddr4; wgShipToAddr[4])
            {
            }
            column(ShipToAddr5; wgShipToAddr[5])
            {
            }
            column(ShipToAddr6; wgShipToAddr[6])
            {
            }
            column(ShipToAddr7; wgShipToAddr[7])
            {
            }
            column(ShipToAddr8; wgShipToAddr[8])
            {
            }
            column(ShipToCode; "Ship-to Code")
            {
            }
            column(StartingDate; "Starting Date")
            {
            }
            column(StartingDateText; Format("Starting Date", 0, wgDateFormatHdr))
            {
            }
            column(Status; Format(Status))
            {
            }
            column(TodayText; Format(Today(), 0, wgDateFormatHdr))
            {
            }
            column(YourReference; "Your Reference")
            {
            }
            dataitem(CopyLoop; "Integer")
            {
                DataItemTableView = sorting(Number);
                column(OutputNo; wgOutputNo)
                {
                }
                column(ServContractTitle; StrSubstNo(Trl('ServiceContract%1'), wgCopyText))
                {
                }
                dataitem(HdrComment; "Service Comment Line")
                {
                    DataItemLink = "No." = field("Contract No."), "Table Subtype" = field("Contract Type");
                    DataItemLinkReference = ContHdr;
                    DataItemTableView = sorting("Table Name", "Table Subtype", "No.", Type, "Table Line No.", "Line No.") order(ascending) where("Table Name" = filter("Service Contract"), "Table Line No." = filter(0));
                    column(Comment; Comment)
                    {
                    }
                    column(Date; Date)
                    {
                    }
                }
                dataitem(ContServDisc; "Contract/Service Discount")
                {
                    DataItemLink = "Contract Type" = field("Contract Type"), "Contract No." = field("Contract No.");
                    DataItemLinkReference = ContHdr;
                    DataItemTableView = sorting("Contract Type", "Contract No.", Type, "No.", "Starting Date");
                    column(DiscountPerc; "Discount %")
                    {
                    }
                    column(No; "No.")
                    {
                    }
                    column(StartingDate_2; "Starting Date")
                    {
                    }
                    column(Type; Format(Type))
                    {
                    }
                    column(TypeNo; Type + 0)
                    {
                    }
                }
                dataitem(ContLine; "Service Contract Line")
                {
                    DataItemLink = "Contract Type" = field("Contract Type"), "Contract No." = field("Contract No.");
                    DataItemLinkReference = ContHdr;
                    DataItemTableView = sorting("Contract Type", "Contract No.", "Line No.") order(ascending);
                    column(CreditMemoDate; "Credit Memo Date")
                    {
                    }
                    column(Description; Description)
                    {
                    }
                    column(InvoicedToDate; "Invoiced to Date")
                    {
                    }
                    column(ItemNo; "Item No.")
                    {
                    }
                    column(LastServiceDate; "Last Service Date")
                    {
                    }
                    column(LineAmount; "Line Amount")
                    {
                    }
                    column(LineNo; "Line No.")
                    {
                    }
                    column(LineValue; "Line Value")
                    {
                    }
                    column(ResponseTimeHours; "Response Time (Hours)")
                    {
                    }
                    column(SerialNo; "Serial No.")
                    {
                    }
                    column(ServiceItemNo; "Service Item No.")
                    {
                    }
                    column(ServicePeriod; Format("Service Period"))
                    {
                    }
                    column(UOM; wgCduwDCR_TranslationMgt.wgFncGetUnitOfMeaseTrl("Unit of Measure Code"))
                    {
                    }
                    column(UOMCode; "Unit of Measure Code")
                    {
                    }
                    dataitem(LineComment; "Service Comment Line")
                    {
                        DataItemLink = "Table Subtype" = field("Contract Type"), "Table Line No." = field("Line No."), "No." = field("Contract No.");
                        DataItemLinkReference = ContLine;
                        DataItemTableView = sorting("Table Name", "Table Subtype", "No.", Type, "Table Line No.", "Line No.") order(ascending) where("Table Name" = filter("Service Contract"));
                        column(Comment_2; Comment)
                        {
                        }
                        column(Date_2; Date)
                        {
                        }
                    }
                }

                trigger OnPreDataItem()
                begin
                    wgNoOfLoops := Abs(wgNoOfCopies) + 1;
                    wgCopyText := '';
                    SetRange(Number, 1, wgNoOfLoops);
                    wgOutputNo := 1;
                end;

                trigger OnAfterGetRecord()
                begin
                    if Number > 1 then begin
                        wgCopyText := CopyStr(Trl('Copy'), 1, MaxStrLen(wgCopyText));
                        wgOutputNo += 1;
                    end;
                end;
            }

            trigger OnAfterGetRecord()
            var
                wlCduLanguage: Codeunit Language;
            begin
                CurrReport.Language := wlCduLanguage.GetLanguageIdOrDefault("Language Code");
                wgCduwDCR_TranslationMgt.wgFncSetLanguageCode("Language Code");

                wlFncFormatAddressFields(ContHdr);
                wlFncFormatDocumentFields(ContHdr);

                if wgLogInteraction then
                    if not CurrReport.Preview then
                        if "Contact No." <> '' then
                            wgCduSegMgt.LogDocument(
                                23, "Contract No.", 0, 0, Database::Contact, "Contact No.", "Salesperson Code", '', '', '')
                        else
                            wgCduSegMgt.LogDocument(
                                23, "Contract No.", 0, 0, Database::Customer, "Customer No.", "Salesperson Code", '', '', '')
            end;
        }
    }

    requestpage
    {

        layout
        {
            area(Content)
            {
                group(Options)
                {
                    Caption = 'Options';
                    field(NoOfCopies; wgNoOfCopies)
                    {
                        ApplicationArea = All;
                        Caption = 'No. of Copies';
                        ToolTip = 'Specifies how many copies of the document to print.';
                    }
                    field(LogInteraction; wgLogInteraction)
                    {
                        ApplicationArea = All;
                        Caption = 'Log Interaction';
                        Enabled = wgLogInteractionEnabled;
                        ToolTip = 'Specifies if you want the service contract quotes that you print to be recorded as interactions and to be added to the Interaction Log Entry table.';
                    }
                }
            }
        }

        trigger OnInit()
        begin
            wgLogInteractionEnabled := true;
        end;

        trigger OnOpenPage()
        begin
            wgNoOfCopies := 0;
            wgRequestPage := true;

            wgLogInteraction := wgCduSegMgt.FindInteractTmplCode(23) <> '';
            wgLogInteractionEnabled := wgLogInteraction;
        end;
    }

    trigger OnInitReport()
    var
        wlRecServMgtSetup: Record "Service Mgt. Setup";
    begin
        wlRecServMgtSetup.Get();
        wgRecCompanyInfo.Get();

        if wlRecServMgtSetup."Logo Position on Documents" <> wlRecServMgtSetup."Logo Position on Documents"::"No Logo" then
            wgRecCompanyInfo.CalcFields(Picture);
    end;

    trigger OnPreReport()
    begin
        wlFncInitReportSettings();
        wgPrint := wgPrint or not CurrReport.Preview;

        if not wgRequestPage then
            wgNoOfCopies := 0;
    end;

    var
        wgRecCompanyInfo: Record "Company Information";
        wgRecSalesPurchPerson: Record "Salesperson/Purchaser";
        wgCduSegMgt: Codeunit SegManagement;
        wgCduwDCR_TranslationMgt: Codeunit wDCR_TranslationMgt;
        wgLogInteraction: Boolean;
        [InDataSet]
        wgLogInteractionEnabled: Boolean;
        wgPrint: Boolean;
        wgRequestPage: Boolean;
        wgDateFormatHdr: Integer;
        wgNoOfCopies: Integer;
        wgNoOfLoops: Integer;
        wgOutputNo: Integer;
        wgReportId: Integer;
        wgCopyText: Text[30];
        wgSalesPersonText: Text[50];
        wgCompanyAddr: array[8] of Text[100];
        wgCustAddr: array[8] of Text[100];
        wgShipToAddr: array[8] of Text[100];

    local procedure Trl(pLblName: Text[50]): Text
    begin
        exit(wgCduwDCR_TranslationMgt.wgFncTranslate(pLblName));
    end;

    local procedure wlFncFormatAddressFields(var vRecServContHdr: Record "Service Contract Header")
    var
        wlRecRespCenter: Record "Responsibility Center";
        wlCduFormatAddr: Codeunit "Format Address";
    begin
        wlCduFormatAddr.GetCompanyAddr(vRecServContHdr."Responsibility Center", wlRecRespCenter, wgRecCompanyInfo, wgCompanyAddr);
        wlCduFormatAddr.ServContractSellto(wgCustAddr, vRecServContHdr);
        wlCduFormatAddr.ServContractShipto(wgShipToAddr, vRecServContHdr);
    end;

    local procedure wlFncFormatDocumentFields(var vRecServContHdr: Record "Service Contract Header")
    var
        wlCduFormatDoc: Codeunit "Format Document";
    begin
        wlCduFormatDoc.SetSalesPerson(wgRecSalesPurchPerson, vRecServContHdr."Salesperson Code", wgSalesPersonText);
    end;

    local procedure wlFncInitReportSettings()
    var
        wlCduTemplateReportHelperDCR: Codeunit TemplateReportHelperDCR;
    begin
        if wgReportId = 0 then
            Evaluate(wgReportId, (DelChr(CurrReport.ObjectId(false), '=', DelChr(CurrReport.ObjectId(false), '=', '1234567890'))));
        wgCduwDCR_TranslationMgt.wgFncSetReportId(wgReportId);
        wgDateFormatHdr := wlCduTemplateReportHelperDCR.wgFncGetHeaderDateFormat(wgReportId);
    end;
}
