report 72173 ServiceCreditMemoDCR
{
    Caption = 'Service - Credit Memo';
    Permissions = TableData "Service Shipment Buffer" = rimd;
    PreviewMode = PrintLayout;
    UsageCategory = None;

    dataset
    {
        dataitem(CrMemoHdr; "Service Cr.Memo Header")
        {
            DataItemTableView = sorting("No.");
            RequestFilterFields = "No.", "Customer No.", "No. Printed";
            RequestFilterHeading = 'Posted Service Credit Memo';
            column(BilltoCustNo; "Bill-to Customer No.")
            {
            }
            column(CompanyAddr1; wgCompanyAddr[1])
            {
            }
            column(CompanyAddr2; wgCompanyAddr[2])
            {
            }
            column(CompanyAddr3; wgCompanyAddr[3])
            {
            }
            column(CompanyAddr4; wgCompanyAddr[4])
            {
            }
            column(CompanyAddr5; wgCompanyAddr[5])
            {
            }
            column(CompanyAddr6; wgCompanyAddr[6])
            {
            }
            column(CompanyBankAccNo; wgRecCompanyInfo."Bank Account No.")
            {
            }
            column(CompanyBankName; wgRecCompanyInfo."Bank Name")
            {
            }
            column(CompanyEMail; wgRecCompanyInfo."E-Mail")
            {
            }
            column(CompanyFaxNo; wgRecCompanyInfo."Fax No.")
            {
            }
            column(CompanyGiroNo; wgRecCompanyInfo."Giro No.")
            {
            }
            column(CompanyHomePage; wgRecCompanyInfo."Home Page")
            {
            }
            column(CompanyIBAN; wgRecCompanyInfo.IBAN)
            {
            }
            column(CompanyPhoneNo; wgRecCompanyInfo."Phone No.")
            {
            }
            column(CompanyPicture; wgRecCompanyInfo.Picture)
            {
            }
            column(CompanyRegistrationNo; wgRecCompanyInfo."Registration No.")
            {
            }
            column(CompanySWIFT; wgRecCompanyInfo."SWIFT Code")
            {
            }
            column(CompanyVATRegNo; wgRecCompanyInfo."VAT Registration No.")
            {
            }
            column(CustAddr1; wgCustAddr[1])
            {
            }
            column(CustAddr2; wgCustAddr[2])
            {
            }
            column(CustAddr3; wgCustAddr[3])
            {
            }
            column(CustAddr4; wgCustAddr[4])
            {
            }
            column(CustAddr5; wgCustAddr[5])
            {
            }
            column(CustAddr6; wgCustAddr[6])
            {
            }
            column(CustAddr7; wgCustAddr[7])
            {
            }
            column(CustAddr8; wgCustAddr[8])
            {
            }
            column(CustomerNo; "Customer No.")
            {
            }
            column(DocumentDate; "Document Date")
            {

            }
            column(DocumentDateText; Format("Document Date", 0, wgDateFormatHdr))
            {
            }
            column(DocumentNo; "No.")
            {
            }
            column(DueDate; "Due Date")
            {

            }
            column(DueDateText; Format("Due Date", 0, wgDateFormatHdr))
            {
            }
            column(HideLineDiscount; wgHideLineDiscount)
            {
            }
            column(LanguageCode; "Language Code")
            {
            }
            column(lblAllowInvDisc; Trl('AllowInvDisc'))
            {
            }
            column(lblAmount; Trl('Amount'))
            {
            }
            column(lblAmountInclVAT; Trl('AmountInclVAT'))
            {
            }
            column(lblAttachedToLineNo; Trl('AttachedToLineNo'))
            {
            }
            column(lblBankAccNo; Trl('BankAccNo'))
            {
            }
            column(lblBankName; Trl('BankName'))
            {
            }
            column(lblBillToAddress; Trl('BillToAddress'))
            {
            }
            column(lblBillToCustomerNo; Trl('BillToCustomerNo'))
            {
            }
            column(lblCompanyRegistrationNo; Trl('CompanyRegistrationNo'))
            {
            }
            column(lblCostLines; Trl('CostLines'))
            {
            }
            column(lblCounterRead; Trl('CounterRead'))
            {
            }
            column(lblCreditMemoNo; Trl('CreditMemoNo'))
            {
            }
            column(lblCustomerNo; Trl('CustomerNo'))
            {
            }
            column(lblDescription; Trl('Description'))
            {
            }
            column(lblDocumentDate; Trl('DocumentDate'))
            {
            }
            column(lblDocumentNo; Trl('DocumentNo'))
            {
            }
            column(lblDueDate; Trl('DueDate'))
            {
            }
            column(lblEmail; Trl('Email'))
            {
            }
            column(lblExternalDocumentNo; Trl('ExternalDocumentNo'))
            {
            }
            column(lblFaultComment; Trl('FaultComment'))
            {
            }
            column(lblFaxNo; Trl('FaxNo'))
            {
            }
            column(lblGiroNo; Trl('GiroNo'))
            {
            }
            column(lblGLAccountNo; Trl('GLAccountNo'))
            {
            }
            column(lblGrossWeight; Trl('GrossWeight'))
            {
            }
            column(lblHeaderDimensions; Trl('HeaderDimensions'))
            {
            }
            column(lblHomePage; Trl('HomePage'))
            {
            }
            column(lblIBAN; Trl('IBAN'))
            {
            }
            column(lblInvDiscAmount; Trl('InvDiscAmount'))
            {
            }
            column(lblInvDiscBaseAmount; Trl('InvDiscBaseAmount'))
            {
            }
            column(lblInvoiceDate; Trl('InvoiceDate'))
            {
            }
            column(lblItemLines; Trl('ItemLines'))
            {
            }
            column(lblLineAmount; Trl('LineAmount'))
            {
            }
            column(lblLineDimensions; Trl('LineDimensions'))
            {
            }
            column(lblLineDiscountAmount; Trl('LineDiscountAmount'))
            {
            }
            column(lblLineDiscountPerc; Trl('LineDiscountPerc'))
            {
            }
            column(lblLineNo; Trl('LineNo'))
            {
            }
            column(lblLocationCode; Trl('LocationCode'))
            {
            }
            column(lblLotNo; Trl('LotNo'))
            {
            }
            column(lblNetWeight; Trl('NetWeight'))
            {
            }
            column(lblNewCounterRead; Trl('NewCounterRead'))
            {
            }
            column(lblNo; Trl('No'))
            {
            }
            column(lblOtherLines; Trl('OtherLines'))
            {
            }
            column(lblPageOf; Trl('Page{0}of{1}'))
            {
            }
            column(lblPaymentDiscountVAT; Trl('PaymentDiscountVAT'))
            {
            }
            column(lblPaymentTerms; Trl('PaymentTerms'))
            {
            }
            column(lblPhoneNo; Trl('PhoneNo'))
            {
            }
            column(lblPrepaymentPaymentTerms; Trl('PrepaymentPaymentTerms'))
            {
            }
            column(lblPrepaymentSpecification; Trl('PrepaymentSpecification'))
            {
            }
            column(lblPrepaymentVATSpecification; Trl('PrepaymentVATSpecification'))
            {
            }
            column(lblPrevCounterRead; Trl('PrevCounterRead'))
            {
            }
            column(lblPricesInclVAT; Trl('PricesInclVAT'))
            {
            }
            column(lblQtyPerUOM; Trl('QtyPerUOM'))
            {
            }
            column(lblQuantity; Trl('Quantity'))
            {
            }
            column(lblQuantityBase; Trl('QuantityBase'))
            {
            }
            column(lblResolutionComment; Trl('ResolutionComment'))
            {
            }
            column(lblResourceLines; Trl('ResourceLines'))
            {
            }
            column(lblReturnOrderNo; Trl('ReturnOrderNo'))
            {
            }
            column(lblReturnReceipt; Trl('ReturnReceipt'))
            {
            }
            column(lblReturnReceiptDate; Trl('ReturnReceiptDate'))
            {
            }
            column(lblSalesPerson; Trl('SalesPerson'))
            {
            }
            column(lblSerialNo; Trl('SerialNo'))
            {
            }
            column(lblServObjLocationName; Trl('ServObjLocationName'))
            {
            }
            column(lblServObjLocationNo; Trl('ServObjLocationNo'))
            {
            }
            column(lblShipmentMethod; Trl('ShipmentMethod'))
            {
            }
            column(lblShipToAddress; Trl('ShipToAddress'))
            {
            }
            column(lblSubtotal; Trl('Subtotal'))
            {
            }
            column(lblSWIFT; Trl('SWIFT'))
            {
            }
            column(lblTotal; Trl('Total'))
            {
            }
            column(lblTotalCosts; Trl('TotalCosts'))
            {
            }
            column(lblTotalItems; Trl('TotalItems'))
            {
            }
            column(lblTotalOther; Trl('TotalOther'))
            {
            }
            column(lblTotalResources; Trl('TotalResources'))
            {
            }
            column(lblTotalTransFooter; Trl('TotalTransFooter'))
            {
            }
            column(lblTotalTransHeader; Trl('TotalTransHeader'))
            {
            }
            column(lblType; Trl('Type'))
            {
            }
            column(lblUnitCost; Trl('UnitCost'))
            {
            }
            column(lblUnitCostLCY; Trl('UnitCostLCY'))
            {
            }
            column(lblUnitPrice; Trl('UnitPrice'))
            {
            }
            column(lblUnitsPerParcel; Trl('UnitsPerParcel'))
            {
            }
            column(lblUOM; Trl('UOM'))
            {
            }
            column(lblUOMCode; Trl('UOMCode'))
            {
            }
            column(lblVATAmount; Trl('VATAmount'))
            {
            }
            column(lblVATAmountSpecification; Trl('VATAmountSpecification'))
            {
            }
            column(lblVATBase; Trl('VATBase'))
            {
            }
            column(lblVATClause; Trl('VATClause'))
            {
            }
            column(lblVATIdentifier; Trl('VATIdentifier'))
            {
            }
            column(lblVATPerc; Trl('VATPerc'))
            {
            }
            column(lblVATRegistrationNo; Trl('VATRegistrationNo'))
            {
            }
            column(lblYourReference; Trl('YourReference'))
            {
            }
            column(LocationCode; "Location Code")
            {
            }
            column(PaymentTermsDesc; wgCduwDCR_TranslationMgt.wgFncGetPaymTermsTrl("Payment Terms Code"))
            {
            }
            column(PostingDate; "Posting Date")
            {
            }
            column(PostingDateText; Format("Posting Date", 0, wgDateFormatHdr))
            {
            }
            column(PricesInclVAT; "Prices Including VAT")
            {
            }
            column(PricesInclVATYesNo; Format("Prices Including VAT"))
            {
            }
            column(SalesPurchPersonName; wgRecSalesPurchPerson.Name)
            {
            }
            column(ShipToAddr1; wgShipToAddr[1])
            {
            }
            column(ShipToAddr2; wgShipToAddr[2])
            {
            }
            column(ShipToAddr3; wgShipToAddr[3])
            {
            }
            column(ShipToAddr4; wgShipToAddr[4])
            {
            }
            column(ShipToAddr5; wgShipToAddr[5])
            {
            }
            column(ShipToAddr6; wgShipToAddr[6])
            {
            }
            column(ShipToAddr7; wgShipToAddr[7])
            {
            }
            column(ShipToAddr8; wgShipToAddr[8])
            {
            }
            column(ShipToAddrSet; wgShowShippingAddr)
            {
            }
            column(TodayText; Format(Today(), 0, wgDateFormatHdr))
            {
            }
            column(TotalExclVATText; wgTotalExclVATText)
            {
            }
            column(TotalInclVATText; wgTotalInclVATText)
            {
            }
            column(TotalText; wgTotalText)
            {
            }
            column(VALExchRate; wgVALExchRate)
            {
            }
            column(VALSpecLCYHeader; wgVALSpecLCYHeader)
            {
            }
            column(VATBaseDiscPerc; "VAT Base Discount %")
            {
                AutoFormatType = 1;
            }
            column(VATRegNo; "VAT Registration No.")
            {
            }
            column(YourReference; "Your Reference")
            {
            }
            dataitem(CopyLoop; "Integer")
            {
                DataItemTableView = sorting(Number);
                column(OutputNo; wgOutputNo)
                {
                }
                column(ServiceCrMemoTitle; StrSubstNo(Trl('ServiceCreditMemo%1'), wgCopyText))
                {
                }
                dataitem(HdrComment; "Service Comment Line")
                {
                    DataItemLink = "No." = field("No.");
                    DataItemLinkReference = CrMemoHdr;
                    DataItemTableView = sorting("Table Name", "Table Subtype", "No.", Type, "Table Line No.", "Line No.") order(ascending) where("Table Line No." = const(0), "Table Subtype" = const("0"), Type = const(General));
                    column(Comment_2; Comment)
                    {
                    }
                }
                dataitem(HeaderDim; "Dimension Set Entry")
                {
                    DataItemLink = "Dimension Set ID" = field("Dimension Set ID");
                    DataItemLinkReference = CrMemoHdr;
                    DataItemTableView = sorting("Dimension Set ID", "Dimension Code");
                    column(DimText; wgDimText)
                    {
                    }

                    trigger OnPreDataItem()
                    begin
                        if not wgShowInternalInfo then
                            CurrReport.Break();
                    end;

                    trigger OnAfterGetRecord()
                    begin
                        wgCduwDCR_ReportFunctions.wgFncGetDimText(HeaderDim, wgDimText);
                    end;
                }
                dataitem(CrMemoLine; "Service Cr.Memo Line")
                {
                    DataItemLink = "Document No." = field("No.");
                    DataItemLinkReference = CrMemoHdr;
                    DataItemTableView = sorting("Document No.", "Line No.");
                    UseTemporary = true;
                    column(Amount; Amount)
                    {
                        AutoFormatExpression = CrMemoHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(AmountInclVAT; "Amount Including VAT")
                    {
                        AutoFormatExpression = CrMemoHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(AttachedToLineNo; "Attached to Line No.")
                    {
                    }
                    column(Description; Description)
                    {
                    }
                    column(Description2_2; "Description 2")
                    {
                    }
                    column(GrossWeight; "Gross Weight")
                    {
                    }
                    column(InvDiscAmount; -"Inv. Discount Amount")
                    {
                        AutoFormatExpression = CrMemoHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(LineAmount; "Line Amount")
                    {
                        AutoFormatExpression = CrMemoHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(LineDiscAmount; "Line Discount Amount")
                    {
                    }
                    column(LineDiscPerc; "Line Discount %")
                    {
                    }
                    column(LineNo; wgLineNo)
                    {
                    }
                    column(NetWeight; "Net Weight")
                    {
                    }
                    column(No_2; "No.")
                    {
                    }
                    column(PostedReceiptDate; wgPostedReceiptDate)
                    {
                    }
                    column(QtyPerUOM; "Qty. per Unit of Measure")
                    {
                    }
                    column(Quantity; Quantity)
                    {
                    }
                    column(QuantityBase; "Quantity (Base)")
                    {
                    }
                    column(ResourceType; Format(wgRecResource.Type))
                    {
                    }
                    column(ResourceTypeNo; wgRecResource.Type.AsInteger())
                    {
                    }
                    column(ServCostDescription; wgRecServiceCost.Description)
                    {
                    }
                    column(Type; Format(Type))
                    {
                    }
                    column(TypeNo; Type.AsInteger())
                    {
                    }
                    column(UnitCost; "Unit Cost")
                    {
                    }
                    column(UnitCostLCY; "Unit Cost (LCY)")
                    {
                    }
                    column(UnitPrice; "Unit Price")
                    {
                        AutoFormatExpression = CrMemoHdr."Currency Code";
                        AutoFormatType = 2;
                    }
                    column(UnitsPerParcel; "Units per Parcel")
                    {
                    }
                    column(UOM; wgCduwDCR_TranslationMgt.wgFncGetUnitOfMeaseTrl("Unit of Measure Code"))
                    {
                    }
                    column(UOMCode; "Unit of Measure Code")
                    {
                    }
                    column(VATIdentifier; "VAT Identifier")
                    {
                    }
                    column(VATPerc_3; "VAT %")
                    {
                    }
                    column(WorkTypeCode; "Work Type Code")
                    {
                    }
                    column(WorkTypeDescription; wgRecWorkType.Description)
                    {
                    }
                    dataitem(LineComment; "Service Comment Line")
                    {
                        DataItemLink = "No." = field("Document No."), "Table Line No." = field("Line No.");
                        DataItemTableView = sorting("Table Name", "Table Subtype", "No.", Type, "Table Line No.", "Line No.") where("Table Name" = const("Service Cr.Memo Header"), Type = const(General));
                        column(Comment; Comment)
                        {
                        }
                    }
                    dataitem(FaultComment; "Service Comment Line")
                    {
                        DataItemLink = "No." = field("Document No."), "Table Line No." = field("Line No.");
                        DataItemTableView = sorting("Table Name", "Table Subtype", "No.", Type, "Table Line No.", "Line No.") where("Table Name" = const("Service Cr.Memo Header"), Type = const(Fault));
                        column(Comment_Fault; Comment)
                        {
                        }
                    }
                    dataitem(ResolutionComment; "Service Comment Line")
                    {
                        DataItemLink = "No." = field("Document No."), "Table Line No." = field("Line No.");
                        DataItemTableView = sorting("Table Name", "Table Subtype", "No.", Type, "Table Line No.", "Line No.") where("Table Name" = const("Service Cr.Memo Header"), Type = const(Resolution));
                        column(Comment_Resolution; Comment)
                        {
                        }
                    }
                    dataitem(ShipmentBuf; "Service Shipment Buffer")
                    {
                        DataItemTableView = sorting("Document No.", "Line No.", "Entry No.");
                        UseTemporary = true;
                        column(PostingDate_2; "Posting Date")
                        {
                        }
                        column(Quantity_5; Quantity)
                        {
                        }

                        trigger OnPreDataItem()
                        begin
                            Reset();
                        end;
                    }
                    dataitem(LineDim; "Dimension Set Entry")
                    {
                        DataItemLink = "Dimension Set ID" = field("Dimension Set ID");
                        DataItemTableView = sorting("Dimension Set ID", "Dimension Code");
                        column(DimText_2; wgDimText)
                        {
                        }

                        trigger OnPreDataItem()
                        begin
                            if not wgShowInternalInfo then
                                CurrReport.Break();
                        end;

                        trigger OnAfterGetRecord()
                        begin
                            wgCduwDCR_ReportFunctions.wgFncGetDimText(LineDim, wgDimText);
                        end;
                    }

                    trigger OnPreDataItem()
                    var
                        wlMoreLines: Boolean;
                    begin
                        Reset();
                        wlMoreLines := CrMemoLine.Find('+');
                        while wlMoreLines and (CrMemoLine.Description = '') and (CrMemoLine."Description 2" = '') and
                                    (CrMemoLine."No." = '') and (CrMemoLine.Quantity = 0) and
                                    (CrMemoLine.Amount = 0)
                        do
                            wlMoreLines := CrMemoLine.Next(-1) <> 0;
                        if not wlMoreLines then
                            CurrReport.Break();
                        CrMemoLine.SetRange("Line No.", 0, CrMemoLine."Line No.");
                    end;

                    trigger OnAfterGetRecord()
                    begin
                        //Get Shipment Lines
                        wgPostedReceiptDate := 0D;
                        if CrMemoLine.Quantity <> 0 then
                            wgPostedReceiptDate := wlFncFindPostedShipmentDate(CrMemoLine);

                        if not CrMemoHdr."Prices Including VAT" and
                              (CrMemoLine."VAT Calculation Type" = CrMemoLine."VAT Calculation Type"::"Full VAT")
                        then
                            CrMemoLine."Line Amount" := 0;

                        if (CrMemoLine.Type = CrMemoLine.Type::"G/L Account") and (not wgShowInternalInfo) then
                            CrMemoLine."No." := '';

                        wgLineNo := CrMemoLine."Line No.";
                        if CrMemoLine."Attached to Line No." <> 0 then
                            wgLineNo := CrMemoLine."Attached to Line No.";

                        if (Type <> Type::Resource) or (not wgRecResource.Get("No.")) then
                            Clear(wgRecResource);

                        if not wgRecWorkType.Get("Work Type Code") then
                            Clear(wgRecWorkType);

                        if not wgRecServiceCost.Get("No.") then
                            Clear(wgRecServiceCost);
                    end;
                }
                dataitem(VATAmtLine; "VAT Amount Line")
                {
                    DataItemTableView = sorting("VAT Identifier", "VAT Calculation Type", "Tax Group Code", "Use Tax", Positive);
                    UseTemporary = true;
                    column(InvDiscAmount_2; "Invoice Discount Amount")
                    {
                        AutoFormatExpression = CrMemoHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(InvDiscBaseAmount; "Inv. Disc. Base Amount")
                    {
                        AutoFormatExpression = CrMemoHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(LineAmount_2; "Line Amount")
                    {
                        AutoFormatExpression = CrMemoHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(VATAmount; "VAT Amount")
                    {
                        AutoFormatExpression = CrMemoHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(VATBase; "VAT Base")
                    {
                        AutoFormatExpression = CrMemoHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(VATIdentifier_2; "VAT Identifier")
                    {
                    }
                    column(VATPerc; "VAT %")
                    {
                        DecimalPlaces = 0 : 5;
                    }

                    trigger OnPreDataItem()
                    begin
                        if wgTotVATAmount = 0 then
                            CurrReport.Break();

                        Reset();
                    end;
                }
                dataitem(VATClause; "VAT Amount Line")
                {
                    DataItemTableView = sorting("VAT Identifier", "VAT Calculation Type", "Tax Group Code", "Use Tax", Positive);
                    UseTemporary = true;
                    column(Description2; wgRecVATClause."Description 2")
                    {
                    }
                    column(Description_4; wgRecVATClause.Description)
                    {
                    }
                    column(VATAmount_4; "VAT Amount")
                    {
                    }
                    column(VATClauseCode; "VAT Clause Code")
                    {
                    }
                    column(VATIdentifier_4; "VAT Identifier")
                    {
                    }

                    trigger OnPreDataItem()
                    begin
                        Copy(VATAmtLine, true); //Set VATClause to VATAmtLine
                        Reset();
                    end;

                    trigger OnAfterGetRecord()
                    begin
                        if "VAT Clause Code" = '' then
                            CurrReport.Skip();
                        if wgRecVATClause.Code <> "VAT Clause Code" then
                            if not wgRecVATClause.Get("VAT Clause Code") then
                                CurrReport.Skip();

                        wgRecVATClause.TranslateDescription(CrMemoHdr."Language Code");
                    end;
                }
                dataitem(VATAmtLineLCY; "VAT Amount Line")
                {
                    DataItemTableView = sorting("VAT Identifier", "VAT Calculation Type", "Tax Group Code", "Use Tax", Positive);
                    UseTemporary = true;
                    column(VALVATAmountLCY; wgVALVATAmountLCY)
                    {
                        AutoFormatType = 1;
                    }
                    column(VALVATBaseLCY; wgVALVATBaseLCY)
                    {
                        AutoFormatType = 1;
                    }
                    column(VATIdentifier_3; "VAT Identifier")
                    {
                    }
                    column(VATPerc_2; "VAT %")
                    {
                        DecimalPlaces = 0 : 5;
                    }

                    trigger OnPreDataItem()
                    begin
                        if not wgShowVATLCY then
                            CurrReport.Break();

                        Copy(VATAmtLine, true); //Set VATAmtLineLCY to VATAmtLine
                        Reset();
                    end;

                    trigger OnAfterGetRecord()
                    begin
                        wgVALVATBaseLCY :=
                            VATAmtLine.GetBaseLCY(
                                CrMemoHdr."Posting Date", CrMemoHdr."Currency Code", CrMemoHdr."Currency Factor");
                        wgVALVATAmountLCY :=
                            VATAmtLine.GetAmountLCY(
                                CrMemoHdr."Posting Date", CrMemoHdr."Currency Code", CrMemoHdr."Currency Factor");

                        wgTotVALVATBaseLCY += wgVALVATBaseLCY;
                        wgTotVALVATAmountLCY += wgVALVATAmountLCY;
                    end;
                }
                dataitem(Total; "Integer")
                {
                    DataItemTableView = sorting(Number) where(Number = const(1));
                    column(MonolithicVAT; wgMonolithicVAT)
                    {
                    }
                    column(NoOfVATAmtLines; wgNoOfVATAmountLines)
                    {
                    }
                    column(TotAmount; wgTotAmount)
                    {
                        AutoFormatExpression = CrMemoHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(TotInvDiscAmount; wgTotInvDiscAmount)
                    {
                    }
                    column(TotInvDiscBaseAmount; wgTotInvDiscBaseAmount)
                    {
                    }
                    column(TotLineAmount; wgTotLineAmount)
                    {
                    }
                    column(TotPaymentDiscOnVAT; wgTotPaymentDiscOnVAT)
                    {
                        AutoFormatExpression = CrMemoHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(TotVALVATAmountLCY; wgTotVALVATAmountLCY)
                    {
                    }
                    column(TotVALVATBaseLCY; wgTotVALVATBaseLCY)
                    {
                    }
                    column(TotVATAmount; wgTotVATAmount)
                    {
                        AutoFormatExpression = CrMemoHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(VATAmtText; wgVATAmountText)
                    {
                    }

                    trigger OnAfterGetRecord()
                    begin
                        wgNoOfVATAmountLines := VATAmtLine.Count();
                        wgMonolithicVAT := wgCduwDCR_ReportFunctions.wgFncIsMonolithicVAT(VATAmtLine);
                        if wgMonolithicVAT then
                            wgVATAmountText := CopyStr(StrSubstNo(Trl('TotalVATAmount%1Perc'), VATAmtLine."VAT %"), 1, MaxStrLen(wgVATAmountText))
                        else
                            wgVATAmountText := CopyStr(Trl('TotalVATAmount'), 1, MaxStrLen(wgVATAmountText));
                    end;
                }

                trigger OnPreDataItem()
                begin
                    wgNoOfLoops := Abs(wgNoOfCopies) + 1;
                    wgCopyText := '';
                    SetRange(Number, 1, wgNoOfLoops);
                    wgOutputNo := 1;
                end;

                trigger OnAfterGetRecord()
                begin
                    if Number > 1 then begin
                        wgCopyText := CopyStr(Trl('Copy'), 1, MaxStrLen(wgCopyText));
                        ;
                        wgOutputNo += 1;
                    end;

                    wgTotVALVATBaseLCY := 0;
                    wgTotVALVATAmountLCY := 0;
                end;

                trigger OnPostDataItem()
                begin
                    if not CurrReport.Preview then
                        wgCduServiceCrMemoCountPrinted.Run(CrMemoHdr);
                end;
            }

            trigger OnAfterGetRecord()
            var
                wlRecRespCenter: Record "Responsibility Center";
                wlCduLanguage: Codeunit Language;
                wlRecRef: RecordRef;
                wlCurrencyCode: Code[10];
            begin
                CurrReport.Language := wlCduLanguage.GetLanguageIdOrDefault("Language Code");
                wgCduwDCR_TranslationMgt.wgFncSetLanguageCode("Language Code");

                if wlRecRespCenter.Get("Responsibility Center") then begin
                    wgCduFormatAddr.RespCenter(wgCompanyAddr, wlRecRespCenter);
                    wgRecCompanyInfo."Phone No." := wlRecRespCenter."Phone No.";
                    wgRecCompanyInfo."Fax No." := wlRecRespCenter."Fax No.";
                end else begin
                    wgRecCompanyInfo."Phone No." := wgCompanyInfoPhoneNo;
                    wgRecCompanyInfo."Fax No." := wgCompanyInfoFaxNo;
                    wgCduFormatAddr.Company(wgCompanyAddr, wgRecCompanyInfo);
                end;

                if "Salesperson Code" = '' then
                    Clear(wgRecSalesPurchPerson)
                else
                    wgRecSalesPurchPerson.Get("Salesperson Code");

                wlCurrencyCode := "Currency Code";
                if wlCurrencyCode = '' then begin
                    wgRecGLSetup.TestField("LCY Code");
                    wlCurrencyCode := wgRecGLSetup."LCY Code";
                end;
                wgTotalText := StrSubstNo(Trl('Total%1'), wlCurrencyCode);
                wgTotalInclVATText := StrSubstNo(Trl('Total%1InclVAT'), wlCurrencyCode);
                wgTotalExclVATText := StrSubstNo(Trl('Total%1ExclVAT'), wlCurrencyCode);

                wgCduFormatAddr.ServiceCrMemoBillTo(wgCustAddr, CrMemoHdr);
                wgShowShippingAddr := wgCduFormatAddr.ServiceCrMemoShipTo(wgShipToAddr, wgCustAddr, CrMemoHdr);

                if "Applies-to Doc. No." = '' then
                    wgAppliedToText := ''
                else
                    wgAppliedToText := StrSubstNo(Trl('AppliesTo%1%2'), "Applies-to Doc. Type", "Applies-to Doc. No.");

                //Get Credit Memo Lines
                CrMemoLine.Reset();
                CrMemoLine.DeleteAll();
                VATAmtLine.Reset();
                VATAmtLine.DeleteAll();
                wlFncGetServiceCrMemoLines(CrMemoHdr, CrMemoLine);

                //Get VAT Amount Lines
                CrMemoLine.CalcVATAmountLines(CrMemoHdr, VATAmtLine);
                wgTotInvDiscAmount := VATAmtLine.GetTotalInvDiscAmount();
                wgTotInvDiscBaseAmount := VATAmtLine.GetTotalInvDiscBaseAmount(CrMemoHdr."Prices Including VAT", CrMemoHdr."Currency Code");
                wgTotLineAmount := VATAmtLine.GetTotalLineAmount(CrMemoHdr."Prices Including VAT", CrMemoHdr."Currency Code");
                wgTotVATAmount := VATAmtLine.GetTotalVATAmount();
                wgTotPaymentDiscOnVAT := -(wgTotLineAmount - wgTotInvDiscAmount - VATAmtLine.GetTotalAmountInclVAT());
                wgTotAmount := VATAmtLine.GetTotalVATBase();

                //Prepare VAT Amount Lines LCY
                if (not wgRecGLSetup."Print VAT specification in LCY") or
                      (CrMemoHdr."Currency Code" = '') or
                      (VATAmtLine.GetTotalVATAmount() = 0)
                then begin
                    wgShowVATLCY := false;
                    wgVALSpecLCYHeader := '';
                    wgVALExchRate := '';
                end
                else begin
                    wgShowVATLCY := true;
                    if wgRecGLSetup."LCY Code" = '' then
                        wgVALSpecLCYHeader := Trl('VATAmtSpecIn') + ' ' + Trl('LocalCurrency')
                    else
                        wgVALSpecLCYHeader := Trl('VATAmtSpecIn') + ' ' + Format(wgRecGLSetup."LCY Code");
                    wgRecCurrExchRate.FindCurrency(CrMemoHdr."Posting Date", CrMemoHdr."Currency Code", 1);
                    wgVALExchRate := StrSubstNo(Trl('ExchangeRate%1/%2'), wgRecCurrExchRate."Relational Exch. Rate Amount", wgRecCurrExchRate."Exchange Rate Amount");
                end;

                //Set HideLineDiscount
                wlRecRef.GetTable(CrMemoHdr);
                wgHideLineDiscount := wgCduwDCR_ReportFunctions.wgFncHideLineDiscount(wlRecRef);
            end;
        }
    }

    requestpage
    {

        SaveValues = true;

        layout
        {
            area(Content)
            {
                group(Options)
                {
                    Caption = 'Options';
                    field(NoOfCopies; wgNoOfCopies)
                    {
                        ApplicationArea = All;
                        Caption = 'No. of Copies';
                    }
                    field(ShowInternalInfo; wgShowInternalInfo)
                    {
                        ApplicationArea = All;
                        Caption = 'Show Internal Information';
                    }
                }
            }
        }

        trigger OnOpenPage()
        begin
            wgNoOfCopies := 0;
            wgRequestPage := true;
        end;
    }

    trigger OnInitReport()
    begin
        wgRecGLSetup.Get();

        wgRecServiceSetup.Get();

        wgRecCompanyInfo.Get();
        wgCompanyInfoPhoneNo := wgRecCompanyInfo."Phone No.";
        wgCompanyInfoFaxNo := wgRecCompanyInfo."Fax No.";

        if wgRecServiceSetup."Logo Position on Documents" <> wgRecServiceSetup."Logo Position on Documents"::"No Logo" then
            wgRecCompanyInfo.CalcFields(Picture);
    end;

    trigger OnPreReport()
    begin
        wlFncInitReportSettings();
        if not wgRequestPage then
            wgNoOfCopies := 0;
    end;

    var
        wgRecCompanyInfo: Record "Company Information";
        wgRecCurrExchRate: Record "Currency Exchange Rate";
        wgRecGLSetup: Record "General Ledger Setup";
        wgRecResource: Record Resource;
        wgRecSalesPurchPerson: Record "Salesperson/Purchaser";
        wgRecServiceCost: Record "Service Cost";
        wgRecServiceSetup: Record "Service Mgt. Setup";
        wgRecVATClause: Record "VAT Clause";
        wgRecWorkType: Record "Work Type";
        wgCduFormatAddr: Codeunit "Format Address";
        wgCduServiceCrMemoCountPrinted: Codeunit "Service Cr. Memo-Printed";
        wgCduwDCR_ReportFunctions: Codeunit wDCR_ReportFunctions;
        wgCduwDCR_TranslationMgt: Codeunit wDCR_TranslationMgt;
        wgHideLineDiscount: Boolean;
        wgMonolithicVAT: Boolean;
        wgRequestPage: Boolean;
        wgShowInternalInfo: Boolean;
        wgShowShippingAddr: Boolean;
        wgShowVATLCY: Boolean;
        wgPostedReceiptDate: Date;
        wgTotAmount: Decimal;
        wgTotInvDiscAmount: Decimal;
        wgTotInvDiscBaseAmount: Decimal;
        wgTotLineAmount: Decimal;
        wgTotPaymentDiscOnVAT: Decimal;
        wgTotVALVATAmountLCY: Decimal;
        wgTotVALVATBaseLCY: Decimal;
        wgTotVATAmount: Decimal;
        wgVALVATAmountLCY: Decimal;
        wgVALVATBaseLCY: Decimal;
        wgDateFormatHdr: Integer;
        wgFirstValueEntryNo: Integer;
        wgLineNo: Integer;
        wgNoOfCopies: Integer;
        wgNoOfLoops: Integer;
        wgNoOfVATAmountLines: Integer;
        wgOutputNo: Integer;
        wgReportId: Integer;
        wgShipmentLineNextEntryNo: Integer;
        wgCompanyInfoFaxNo: Text[30];
        wgCompanyInfoPhoneNo: Text[30];
        wgCopyText: Text[30];
        wgVATAmountText: Text[30];
        wgAppliedToText: Text[40];
        wgTotalExclVATText: Text[50];
        wgTotalInclVATText: Text[50];
        wgTotalText: Text[50];
        wgVALExchRate: Text[50];
        wgVALSpecLCYHeader: Text[80];
        wgCompanyAddr: array[8] of Text[100];
        wgCustAddr: array[8] of Text[100];
        wgShipToAddr: array[8] of Text[100];
        wgDimText: Text[120];

    procedure InitializeRequest(pNewNoOfCopies: Integer; pNewShowInternalInfo: Boolean)
    begin
        wgNoOfCopies := pNewNoOfCopies;
        wgShowInternalInfo := pNewShowInternalInfo;
    end;

    local procedure Trl(pLblName: Text[50]): Text
    begin
        exit(wgCduwDCR_TranslationMgt.wgFncTranslate(pLblName));
    end;

    local procedure wlFncAddBufferEntry(var vRecServiceCrMemoLine: Record "Service Cr.Memo Line"; pQtyOnShipment: Decimal; pPostingDate: Date)
    begin
        //According AddBufferEntry Report 207
        ShipmentBuf.SetRange("Document No.", vRecServiceCrMemoLine."Document No.");
        ShipmentBuf.SetRange("Line No.", vRecServiceCrMemoLine."Line No.");
        ShipmentBuf.SetRange("Posting Date", pPostingDate);
        if ShipmentBuf.Find('-') then begin
            ShipmentBuf.Quantity := ShipmentBuf.Quantity - pQtyOnShipment;
            ShipmentBuf.Modify();
            exit;
        end;

        ShipmentBuf."Document No." := vRecServiceCrMemoLine."Document No.";
        ShipmentBuf."Line No." := vRecServiceCrMemoLine."Line No.";
        ShipmentBuf."Entry No." := wgShipmentLineNextEntryNo;
        ShipmentBuf.Type := vRecServiceCrMemoLine.Type;
        ShipmentBuf."No." := vRecServiceCrMemoLine."No.";
        ShipmentBuf.Quantity := -pQtyOnShipment;
        ShipmentBuf."Posting Date" := pPostingDate;
        ShipmentBuf.Insert();
        wgShipmentLineNextEntryNo += 1;
    end;

    local procedure wlFncFindPostedShipmentDate(var vRecServiceCrMemoLine: Record "Service Cr.Memo Line"): Date
    var
        wlRecServiceCrMemoLine: Record "Service Cr.Memo Line";
        wlRecTempServiceShipmentBuffer2: Record "Service Shipment Buffer" temporary;
    begin
        wgShipmentLineNextEntryNo := 1;

        wlRecServiceCrMemoLine.Reset();
        wlRecServiceCrMemoLine.SetRange("Document No.", vRecServiceCrMemoLine."Document No.");
        wlRecServiceCrMemoLine.SetFilter(Type, '<> %1', vRecServiceCrMemoLine.Type::" ");
        wlRecServiceCrMemoLine.SetFilter(Quantity, '<> %1', 0);
        if not wlRecServiceCrMemoLine.FindFirst() then
            wlRecServiceCrMemoLine.Init();

        case wlRecServiceCrMemoLine.Type of
            wlRecServiceCrMemoLine.Type::Item:
                wlFncGenerateBufferFromValueEntry(wlRecServiceCrMemoLine);
            wlRecServiceCrMemoLine.Type::" ":
                exit(0D);
        end;

        ShipmentBuf.Reset();
        ShipmentBuf.SetRange("Document No.", wlRecServiceCrMemoLine."Document No.");
        ShipmentBuf.SetRange("Line No.", wlRecServiceCrMemoLine."Line No.");

        if ShipmentBuf.Find('-') then begin
            wlRecTempServiceShipmentBuffer2 := ShipmentBuf;
            if ShipmentBuf.Next() = 0 then begin
                ShipmentBuf.Get(wlRecTempServiceShipmentBuffer2."Document No.", wlRecTempServiceShipmentBuffer2."Line No.", wlRecTempServiceShipmentBuffer2.
                    "Entry No.");
                ShipmentBuf.Delete();
                exit(wlRecTempServiceShipmentBuffer2."Posting Date");
            end;
            ShipmentBuf.CalcSums(Quantity);
            if ShipmentBuf.Quantity <> wlRecServiceCrMemoLine.Quantity then begin
                ShipmentBuf.DeleteAll();
                exit(wlRecServiceCrMemoLine."Posting Date");
            end;
        end else
            exit(wlRecServiceCrMemoLine."Posting Date");
    end;

    local procedure wlFncGenerateBufferFromValueEntry(vRecServiceCrMemoLine: Record "Service Cr.Memo Line")
    var
        wlRecItemLedgerEntry: Record "Item Ledger Entry";
        wlRecValueEntry: Record "Value Entry";
        wlQuantity: Decimal;
        wlTotalQuantity: Decimal;
    begin
        wlTotalQuantity := vRecServiceCrMemoLine."Quantity (Base)";
        wlRecValueEntry.SetCurrentKey("Document No.");
        wlRecValueEntry.SetRange("Document No.", vRecServiceCrMemoLine."Document No.");
        wlRecValueEntry.SetRange("Posting Date", CrMemoHdr."Posting Date");
        wlRecValueEntry.SetRange("Item Charge No.", '');
        wlRecValueEntry.SetFilter("Entry No.", '%1..', wgFirstValueEntryNo);
        if wlRecValueEntry.Find('-') then
            repeat
                if wlRecItemLedgerEntry.Get(wlRecValueEntry."Item Ledger Entry No.") then begin
                    if vRecServiceCrMemoLine."Qty. per Unit of Measure" <> 0 then
                        wlQuantity := wlRecValueEntry."Invoiced Quantity" / vRecServiceCrMemoLine."Qty. per Unit of Measure"
                    else
                        wlQuantity := wlRecValueEntry."Invoiced Quantity";
                    wlFncAddBufferEntry(
                        vRecServiceCrMemoLine,
                        -wlQuantity,
                        wlRecItemLedgerEntry."Posting Date");
                    wlTotalQuantity := wlTotalQuantity - wlRecValueEntry."Invoiced Quantity";
                end;
                wgFirstValueEntryNo := wlRecValueEntry."Entry No." + 1;
            until (wlRecValueEntry.Next() = 0) or (wlTotalQuantity = 0);
    end;

    local procedure wlFncGetServiceCrMemoLines(var vRecServiceCrMemoHeader: Record "Service Cr.Memo Header"; var vRecServiceCrMemoLine: Record "Service Cr.Memo Line")
    var
        wlRecServiceCrMemoLine: Record "Service Cr.Memo Line";
    begin
        wlRecServiceCrMemoLine.SetRange("Document No.", vRecServiceCrMemoHeader."No.");
        if wlRecServiceCrMemoLine.FindSet() then
            repeat
                vRecServiceCrMemoLine := wlRecServiceCrMemoLine;
                vRecServiceCrMemoLine.Insert();
            until wlRecServiceCrMemoLine.Next() = 0;
    end;

    local procedure wlFncInitReportSettings()
    var
        wlCduTemplateReportHelperDCR: Codeunit TemplateReportHelperDCR;
    begin
        if wgReportId = 0 then
            Evaluate(wgReportId, (DelChr(CurrReport.ObjectId(false), '=', DelChr(CurrReport.ObjectId(false), '=', '1234567890'))));
        wgCduwDCR_TranslationMgt.wgFncSetReportId(wgReportId);
        wgDateFormatHdr := wlCduTemplateReportHelperDCR.wgFncGetHeaderDateFormat(wgReportId);
    end;
}
