report 72178 ServiceDraftInvoiceDCR
{
    Caption = 'Service - Draft Invoice';
    PreviewMode = PrintLayout;
    UsageCategory = None;

    dataset
    {
        dataitem(ServHdr; "Service Header")
        {
            DataItemTableView = sorting("Document Type", "No.") where("Document Type" = const(Order));
            RequestFilterFields = "No.";
            RequestFilterHeading = 'Service Order';
            column(BillToAddr1; wgBillToAddr[1])
            {
            }
            column(BillToAddr2; wgBillToAddr[2])
            {
            }
            column(BillToAddr3; wgBillToAddr[3])
            {
            }
            column(BillToAddr4; wgBillToAddr[4])
            {
            }
            column(BillToAddr5; wgBillToAddr[5])
            {
            }
            column(BillToAddr6; wgBillToAddr[6])
            {
            }
            column(BillToAddr7; wgBillToAddr[7])
            {
            }
            column(BillToAddr8; wgBillToAddr[8])
            {
            }
            column(BilltoCustNo; "Bill-to Customer No.")
            {
            }
            column(CompanyAddr1; wgCompanyAddr[1])
            {
            }
            column(CompanyAddr2; wgCompanyAddr[2])
            {
            }
            column(CompanyAddr3; wgCompanyAddr[3])
            {
            }
            column(CompanyAddr4; wgCompanyAddr[4])
            {
            }
            column(CompanyAddr5; wgCompanyAddr[5])
            {
            }
            column(CompanyAddr6; wgCompanyAddr[6])
            {
            }
            column(CompanyBankAccNo; wgRecCompanyInfo."Bank Account No.")
            {
            }
            column(CompanyBankName; wgRecCompanyInfo."Bank Name")
            {
            }
            column(CompanyEMail; wgRecCompanyInfo."E-Mail")
            {
            }
            column(CompanyFaxNo; wgRecCompanyInfo."Fax No.")
            {
            }
            column(CompanyGiroNo; wgRecCompanyInfo."Giro No.")
            {
            }
            column(CompanyHomePage; wgRecCompanyInfo."Home Page")
            {
            }
            column(CompanyIBAN; wgRecCompanyInfo.IBAN)
            {
            }
            column(CompanyPhoneNo; wgRecCompanyInfo."Phone No.")
            {
            }
            column(CompanyPicture; wgRecCompanyInfo.Picture)
            {
            }
            column(CompanyRegistrationNo; wgRecCompanyInfo."Registration No.")
            {
            }
            column(CompanySWIFT; wgRecCompanyInfo."SWIFT Code")
            {
            }
            column(CompanyVATRegNo; wgRecCompanyInfo."VAT Registration No.")
            {
            }
            column(CustAddr1; wgCustAddr[1])
            {
            }
            column(CustAddr2; wgCustAddr[2])
            {
            }
            column(CustAddr3; wgCustAddr[3])
            {
            }
            column(CustAddr4; wgCustAddr[4])
            {
            }
            column(CustAddr5; wgCustAddr[5])
            {
            }
            column(CustAddr6; wgCustAddr[6])
            {
            }
            column(CustAddr7; wgCustAddr[7])
            {
            }
            column(CustAddr8; wgCustAddr[8])
            {
            }
            column(CustNo; "Customer No.")
            {
            }
            column(DocumentDate; "Document Date")
            {
            }
            column(DocumentDateText; Format("Document Date", 0, wgDateFormatHdr))
            {
            }
            column(DocumentNo; "No.")
            {
            }
            column(DocumentType; "Document Type")
            {
            }
            column(DueDate; "Due Date")
            {
            }
            column(DueDateText; Format("Due Date", 0, wgDateFormatHdr))
            {
            }
            column(HideLineDiscount; wgHideLineDiscount)
            {
            }
            column(LanguageCode; "Language Code")
            {
            }
            column(lblAddress; Trl('Address'))
            {
            }
            column(lblAllowInvDisc; Trl('AllowInvDisc'))
            {
            }
            column(lblAmount; Trl('Amount'))
            {
            }
            column(lblAmountInclVAT; Trl('AmountInclVAT'))
            {
            }
            column(lblAttachedToLineNo; Trl('AttachedToLineNo'))
            {
            }
            column(lblBankAccNo; Trl('BankAccNo'))
            {
            }
            column(lblBankName; Trl('BankName'))
            {
            }
            column(lblBillToAddress; Trl('BillToAddress'))
            {
            }
            column(lblBillToCustomerNo; Trl('BillToCustomerNo'))
            {
            }
            column(lblCompanyRegistrationNo; Trl('CompanyRegistrationNo'))
            {
            }
            column(lblCostLines; Trl('CostLines'))
            {
            }
            column(lblCounterRead; Trl('CounterRead'))
            {
            }
            column(lblCrossReferenceNo; Trl('CrossReferenceNo'))
            {
            }
            column(lblDescription; Trl('Description'))
            {
            }
            column(lblDocumentDate; Trl('DocumentDate'))
            {
            }
            column(lblDocumentNo; Trl('DocumentNo'))
            {
            }
            column(lblDocumentType; Trl('DocumentType'))
            {
            }
            column(lblDueDate; Trl('DueDate'))
            {
            }
            column(lblEmail; Trl('Email'))
            {
            }
            column(lblFaultComment; Trl('FaultComment'))
            {
            }
            column(lblFaxNo; Trl('FaxNo'))
            {
            }
            column(lblGiroNo; Trl('GiroNo'))
            {
            }
            column(lblGLAccountNo; Trl('GLAccountNo'))
            {
            }
            column(lblGrossWeight; Trl('GrossWeight'))
            {
            }
            column(lblHeaderDimensions; Trl('HeaderDimensions'))
            {
            }
            column(lblHomePage; Trl('HomePage'))
            {
            }
            column(lblIBAN; Trl('IBAN'))
            {
            }
            column(lblInvDiscAmount; Trl('InvDiscAmount'))
            {
            }
            column(lblInvDiscBaseAmount; Trl('InvDiscBaseAmount'))
            {
            }
            column(lblInvoiceDate; Trl('InvoiceDate'))
            {
            }
            column(lblInvoiceNo; Trl('InvoiceNo'))
            {
            }
            column(lblItemLines; Trl('ItemLines'))
            {
            }
            column(lblItemTariffNo; Trl('ItemTariffNo'))
            {
            }
            column(lblLineAmount; Trl('LineAmount'))
            {
            }
            column(lblLineDimensions; Trl('LineDimensions'))
            {
            }
            column(lblLineDiscountAmount; Trl('LineDiscountAmount'))
            {
            }
            column(lblLineDiscountPerc; Trl('LineDiscountPerc'))
            {
            }
            column(lblLineNo; Trl('LineNo'))
            {
            }
            column(lblLocationCode; Trl('LocationCode'))
            {
            }
            column(lblLotNo; Trl('LotNo'))
            {
            }
            column(lblNeededByDate; Trl('NeededByDate'))
            {
            }
            column(lblNetWeight; Trl('NetWeight'))
            {
            }
            column(lblNewCounterRead; Trl('NewCounterRead'))
            {
            }
            column(lblNo; Trl('No'))
            {
            }
            column(lblOrderDate; Trl('OrderDate'))
            {
            }
            column(lblOrderNo; Trl('OrderNo'))
            {
            }
            column(lblOtherLines; Trl('OtherLines'))
            {
            }
            column(lblOutstandingQtyBase; Trl('OutstandingQtyBase'))
            {
            }
            column(lblOutstandingQuantity; Trl('OutstandingQuantity'))
            {
            }
            column(lblPageOf; Trl('Page{0}of{1}'))
            {
            }
            column(lblPaymentDiscountVAT; Trl('PaymentDiscountVAT'))
            {
            }
            column(lblPaymentTerms; Trl('PaymentTerms'))
            {
            }
            column(lblPhoneNo; Trl('PhoneNo'))
            {
            }
            column(lblPrevCounterRead; Trl('PrevCounterRead'))
            {
            }
            column(lblPricesInclVAT; Trl('PricesInclVAT'))
            {
            }
            column(lblQtyInvoicedBase; Trl('QtyInvoicedBase'))
            {
            }
            column(lblQtyPerUOM; Trl('QtyPerUOM'))
            {
            }
            column(lblQtyToInvoiceBase; Trl('QtyToInvoiceBase'))
            {
            }
            column(lblQuantity; Trl('Quantity'))
            {
            }
            column(lblQuantityBase; Trl('QuantityBase'))
            {
            }
            column(lblQuantityInvoiced; Trl('QuantityInvoiced'))
            {
            }
            column(lblReservedQtyBase; Trl('ReservedQtyBase'))
            {
            }
            column(lblResolutionComment; Trl('ResolutionComment'))
            {
            }
            column(lblResourceLines; Trl('ResourceLines'))
            {
            }
            column(lblSalesPerson; Trl('SalesPerson'))
            {
            }
            column(lblSellToCustomerNo; Trl('SellToCustomerNo'))
            {
            }
            column(lblSerialNo; Trl('SerialNo'))
            {
            }
            column(lblServItemGroup; Trl('ServItemGroup'))
            {
            }
            column(lblServObjLocationName; Trl('ServObjLocationName'))
            {
            }
            column(lblServObjLocationNo; Trl('ServObjLocationNo'))
            {
            }
            column(lblShipment; Trl('Shipment'))
            {
            }
            column(lblShipmentMethod; Trl('ShipmentMethod'))
            {
            }
            column(lblShipToAddress; Trl('ShipToAddress'))
            {
            }
            column(lblSubtotal; Trl('Subtotal'))
            {
            }
            column(lblSWIFT; Trl('SWIFT'))
            {
            }
            column(lblTotal; Trl('Total'))
            {
            }
            column(lblTotalCosts; Trl('TotalCosts'))
            {
            }
            column(lblTotalItems; Trl('TotalItems'))
            {
            }
            column(lblTotalOther; Trl('TotalOther'))
            {
            }
            column(lblTotalResources; Trl('TotalResources'))
            {
            }
            column(lblTotalTransFooter; Trl('TotalTransFooter'))
            {
            }
            column(lblTotalTransHeader; Trl('TotalTransHeader'))
            {
            }
            column(lblType; Trl('Type'))
            {
            }
            column(lblUnitCost; Trl('UnitCost'))
            {
            }
            column(lblUnitCostLCY; Trl('UnitCostLCY'))
            {
            }
            column(lblUnitPrice; Trl('UnitPrice'))
            {
            }
            column(lblUnitsPerParcel; Trl('UnitsPerParcel'))
            {
            }
            column(lblUOM; Trl('UOM'))
            {
            }
            column(lblUOMCode; Trl('UOMCode'))
            {
            }
            column(lblVATAmount; Trl('VATAmount'))
            {
            }
            column(lblVATAmountSpecification; Trl('VATAmountSpecification'))
            {
            }
            column(lblVATBase; Trl('VATBase'))
            {
            }
            column(lblVATIdentifier; Trl('VATIdentifier'))
            {
            }
            column(lblVATPerc; Trl('VATPerc'))
            {
            }
            column(lblVATRegistrationNo; Trl('VATRegistrationNo'))
            {
            }
            column(lblYourReference; Trl('YourReference'))
            {
            }
            column(LocationCode; "Location Code")
            {
            }
            column(OrderDate; "Order Date")
            {
            }
            column(OrderDateText; Format("Order Date", 0, wgDateFormatHdr))
            {
            }
            column(PaymentTermsDesc; wgCduwDCR_TranslationMgt.wgFncGetPaymTermsTrl("Payment Terms Code"))
            {
            }
            column(PostingDate; "Posting Date")
            {
            }
            column(PostingDateText; Format("Posting Date", 0, wgDateFormatHdr))
            {
            }
            column(PricesInclVAT; "Prices Including VAT")
            {
            }
            column(PricesInclVATYesNo; Format("Prices Including VAT"))
            {
            }
            column(SalesPurchPersonName; wgRecSalesPurchPerson.Name)
            {
            }
            column(ShipmentMethodDesc; wgCduwDCR_TranslationMgt.wgFncGetShipmMethodTrl("Shipment Method Code"))
            {
            }
            column(ShipToAddr1; wgShipToAddr[1])
            {
            }
            column(ShipToAddr2; wgShipToAddr[2])
            {
            }
            column(ShipToAddr3; wgShipToAddr[3])
            {
            }
            column(ShipToAddr4; wgShipToAddr[4])
            {
            }
            column(ShipToAddr5; wgShipToAddr[5])
            {
            }
            column(ShipToAddr6; wgShipToAddr[6])
            {
            }
            column(ShipToAddr7; wgShipToAddr[7])
            {
            }
            column(ShipToAddr8; wgShipToAddr[8])
            {
            }
            column(ShipToAddrSet; wgShowShippingAddr)
            {
            }
            column(TodayText; Format(Today(), 0, wgDateFormatHdr))
            {
            }
            column(TotalExclVATText; wgTotalExclVATText)
            {
            }
            column(TotalInclVATText; wgTotalInclVATText)
            {
            }
            column(TotalText; wgTotalText)
            {
            }
            column(VALExchRate; wgVALExchRate)
            {
            }
            column(VALSpecLCYHeader; wgVALSpecLCYHeader)
            {
            }
            column(VATBaseDiscPerc; "VAT Base Discount %")
            {
                AutoFormatType = 1;
            }
            column(VATRegNo; "VAT Registration No.")
            {
            }
            column(YourReference; "Your Reference")
            {
            }
            dataitem(CopyLoop; "Integer")
            {
                DataItemTableView = sorting(Number);
                column(OutputNo; wgOutputNo)
                {
                }
                column(ServiceDraftInvoiceTitle; StrSubstNo(Trl('ServiceDraftInvoice%1'), wgCopyText))
                {
                }
                dataitem(HdrComment; "Service Comment Line")
                {
                    DataItemLink = "Table Subtype" = field("Document Type"), "No." = field("No.");
                    DataItemLinkReference = ServHdr;
                    DataItemTableView = sorting("Table Name", "Table Subtype", "No.", Type, "Table Line No.", "Line No.") where("Table Name" = const("Service Header"), Type = const(General), "Table Line No." = const(0));
                    column(Comment_2; Comment)
                    {
                    }
                }
                dataitem(HeaderDim; "Dimension Set Entry")
                {
                    DataItemLink = "Dimension Set ID" = field("Dimension Set ID");
                    DataItemLinkReference = ServHdr;
                    DataItemTableView = sorting("Dimension Set ID", "Dimension Code");
                    column(DimText; wgDimText)
                    {
                    }

                    trigger OnPreDataItem()
                    begin
                        if not wgShowInternalInfo then
                            CurrReport.Break();
                    end;

                    trigger OnAfterGetRecord()
                    begin
                        wgCduwDCR_ReportFunctions.wgFncGetDimText(HeaderDim, wgDimText);
                    end;
                }
                dataitem(ServItemLine; "Service Item Line")
                {
                    DataItemLink = "Document Type" = field("Document Type"), "Document No." = field("No.");
                    DataItemLinkReference = ServHdr;
                    DataItemTableView = sorting("Document Type", "Document No.", "Line No.");
                    UseTemporary = true;
                    column(ContractNo; "Contract No.")
                    {
                    }
                    column(CustomerNo; "Customer No.")
                    {
                    }
                    column(Description2_2; "Description 2")
                    {
                    }
                    column(Description_2; Description)
                    {
                    }
                    column(FaultAreaCode; "Fault Area Code")
                    {
                    }
                    column(FaultCode; "Fault Code")
                    {
                    }
                    column(FaultReasonCode; "Fault Reason Code")
                    {
                    }
                    column(ItemNo; "Item No.")
                    {
                    }
                    column(LocationofServItem; "Location of Service Item")
                    {
                    }
                    column(RepairStatusCode; "Repair Status Code")
                    {
                    }
                    column(ResolutionCode; "Resolution Code")
                    {
                    }
                    column(SerialNo_2; "Serial No.")
                    {
                    }
                    column(ServItemGroupCode; "Service Item Group Code")
                    {
                    }
                    column(ServItemNo; "Service Item No.")
                    {
                    }
                    column(ServPriceGroupCode; "Service Price Group Code")
                    {
                    }
                    column(ServShelfNo; "Service Shelf No.")
                    {
                    }
                    column(ShiptoCode; "Ship-to Code")
                    {
                    }
                    column(SymptomCode; "Symptom Code")
                    {
                    }
                    column(VendorItemNo; "Vendor Item No.")
                    {
                    }
                    column(VendorNo; "Vendor No.")
                    {
                    }
                    column(Warranty; Warranty)
                    {
                    }
                    dataitem(FaultComment; "Service Comment Line")
                    {
                        DataItemLink = "Table Subtype" = field("Document Type"), "No." = field("Document No."), "Table Line No." = field("Line No.");
                        DataItemTableView = sorting("Table Name", "Table Subtype", "No.", Type, "Table Line No.", "Line No.") where("Table Name" = const("Service Header"), Type = const(Fault));
                        column(Comment_Fault; Comment)
                        {
                        }
                    }
                    dataitem(ResolutionComment; "Service Comment Line")
                    {
                        DataItemLink = "Table Subtype" = field("Document Type"), "No." = field("Document No."), "Table Line No." = field("Line No.");
                        DataItemTableView = sorting("Table Name", "Table Subtype", "No.", Type, "Table Line No.", "Line No.") where("Table Name" = const("Service Header"), Type = const(Resolution));
                        column(Comment_Resolution; Comment)
                        {
                        }
                    }
                    dataitem(ServLine; "Service Line")
                    {
                        DataItemTableView = sorting("Document Type", "Document No.", "Line No.");
                        UseTemporary = true;
                        column(Amount; Amount)
                        {
                            AutoFormatExpression = "Currency Code";
                            AutoFormatType = 1;
                        }
                        column(AmountInclVAT; "Amount Including VAT")
                        {
                            AutoFormatExpression = "Currency Code";
                            AutoFormatType = 1;
                        }
                        column(AttachedToLineNo; "Attached to Line No.")
                        {
                        }
                        column(Description; Description)
                        {
                        }
                        column(Description2; "Description 2")
                        {
                        }
                        column(GrossWeight; "Gross Weight")
                        {
                        }
                        column(InvDiscAmount; -"Inv. Discount Amount")
                        {
                            AutoFormatExpression = "Currency Code";
                            AutoFormatType = 1;
                        }
                        column(ItemTariffNo; wgRecItem."Tariff No.")
                        {
                        }
                        column(LineAmount; "Line Amount")
                        {
                            AutoFormatExpression = "Currency Code";
                            AutoFormatType = 1;
                        }
                        column(LineDiscAmount; "Line Discount Amount")
                        {
                        }
                        column(LineDiscPerc; "Line Discount %")
                        {
                        }
                        column(LineNo; "Line No.")
                        {
                        }
                        column(NeededByDate; "Needed by Date")
                        {
                        }
                        column(NetWeight; "Net Weight")
                        {
                        }
                        column(No_2; "No.")
                        {
                        }
                        column(OutstandingQtyBase; "Outstanding Qty. (Base)")
                        {
                        }
                        column(OutstandingQuantity; "Outstanding Quantity")
                        {
                        }
                        column(QtyInvoicedBase; "Qty. Invoiced (Base)")
                        {
                        }
                        column(QtyPerUOM; "Qty. per Unit of Measure")
                        {
                        }
                        column(QtyToInvoiceBase; "Qty. to Invoice (Base)")
                        {
                        }
                        column(Quantity; Quantity)
                        {
                        }
                        column(QuantityBase; "Quantity (Base)")
                        {
                        }
                        column(QuantityInvoiced; "Quantity Invoiced")
                        {
                        }
                        column(ReservedQtyBase; "Reserved Qty. (Base)")
                        {
                        }
                        column(ResourceType; Format(wgRecResource.Type))
                        {
                        }
                        column(ResourceTypeNo; wgRecResource.Type.AsInteger())
                        {
                        }
                        column(ServCostDescription; wgRecServiceCost.Description)
                        {
                        }
                        column(ServItemNo_2; "Service Item No.")
                        {
                        }
                        column(Type; Format(Type))
                        {
                        }
                        column(TypeNo; Type.AsInteger())
                        {
                        }
                        column(UnitCost; "Unit Cost")
                        {
                        }
                        column(UnitCostLCY; "Unit Cost (LCY)")
                        {
                        }
                        column(UnitPrice; "Unit Price")
                        {
                            AutoFormatExpression = "Currency Code";
                            AutoFormatType = 2;
                        }
                        column(UnitsPerParcel; "Units per Parcel")
                        {
                        }
                        column(UOM; wgCduwDCR_TranslationMgt.wgFncGetUnitOfMeaseTrl("Unit of Measure Code"))
                        {
                        }
                        column(UOMCode; "Unit of Measure Code")
                        {
                        }
                        column(VATIdentifier; "VAT Identifier")
                        {
                        }
                        column(VATPerc_3; "VAT %")
                        {
                        }
                        column(WorkTypeCode; "Work Type Code")
                        {
                        }
                        column(WorkTypeDescription; wgRecWorkType.Description)
                        {
                        }
                        dataitem(LineComment; "Service Comment Line")
                        {
                            DataItemLink = "Table Subtype" = field("Document Type"), "No." = field("Document No."), "Table Line No." = field("Line No.");
                            DataItemTableView = sorting("Table Name", "Table Subtype", "No.", Type, "Table Line No.", "Line No.") where("Table Name" = const("Service Header"), Type = const(General));
                            column(Comment; Comment)
                            {
                            }
                        }
                        dataitem(LineDim; "Dimension Set Entry")
                        {
                            DataItemLink = "Dimension Set ID" = field("Dimension Set ID");
                            DataItemTableView = sorting("Dimension Set ID", "Dimension Code");
                            column(DimText_2; wgDimText)
                            {
                            }

                            trigger OnPreDataItem()
                            begin
                                if not wgShowInternalInfo then
                                    CurrReport.Break();
                            end;

                            trigger OnAfterGetRecord()
                            begin
                                wgCduwDCR_ReportFunctions.wgFncGetDimText(LineDim, wgDimText);
                            end;
                        }
                        dataitem(TrackingSpec; "Tracking Specification")
                        {
                            DataItemTableView = sorting("Entry No.");
                            UseTemporary = true;
                            column(LotNo; "Lot No.")
                            {
                            }
                            column(Quantity_4; "Quantity (Base)")
                            {
                            }
                            column(SerialNo; "Serial No.")
                            {
                            }

                            trigger OnPreDataItem()
                            begin
                                if not wgShowLotSN then
                                    CurrReport.Break();
                                Reset();
                                SetRange("Source Ref. No.", ServLine."Line No.");
                            end;
                        }

                        trigger OnPreDataItem()
                        var
                            wlMoreLines: Boolean;
                        begin
                            Reset();
                            wlMoreLines := ServLine.Find('+');
                            while wlMoreLines and (ServLine.Description = '') and (ServLine."Description 2" = '') and
                                        (ServLine."No." = '') and (ServLine.Quantity = 0) and
                                        (ServLine.Amount = 0)
                            do
                                wlMoreLines := ServLine.Next(-1) <> 0;
                            if not wlMoreLines then
                                CurrReport.Break();
                            ServLine.SetRange("Line No.", 0, ServLine."Line No.");
                            ServLine.SetRange("Service Item Line No.", ServItemLine."Line No.");
                        end;

                        trigger OnAfterGetRecord()
                        begin
                            if not ServHdr."Prices Including VAT" and
                                  (ServLine."VAT Calculation Type" = ServLine."VAT Calculation Type"::"Full VAT")
                            then
                                ServLine."Line Amount" := 0;

                            if (ServLine.Type = ServLine.Type::"G/L Account") and (not wgShowInternalInfo) then
                                ServLine."No." := '';

                            if (ServLine.Type <> ServLine.Type::Item) or (not wgRecItem.Get("No.")) then
                                Clear(wgRecItem);

                            if (Type <> Type::Resource) or (not wgRecResource.Get("No.")) then
                                Clear(wgRecResource);

                            if not wgRecWorkType.Get("Work Type Code") then
                                Clear(wgRecWorkType);

                            if not wgRecServiceCost.Get("No.") then
                                Clear(wgRecServiceCost);
                        end;
                    }
                }
                dataitem(VATAmtLine; "VAT Amount Line")
                {
                    DataItemTableView = sorting("VAT Identifier", "VAT Calculation Type", "Tax Group Code", "Use Tax", Positive);
                    UseTemporary = true;
                    column(InvDiscAmount_2; "Invoice Discount Amount")
                    {
                        AutoFormatExpression = ServHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(InvDiscBaseAmount; "Inv. Disc. Base Amount")
                    {
                        AutoFormatExpression = ServHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(LineAmount_2; "Line Amount")
                    {
                        AutoFormatExpression = ServHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(VATAmount; "VAT Amount")
                    {
                        AutoFormatExpression = ServHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(VATBase; "VAT Base")
                    {
                        AutoFormatExpression = ServHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(VATIdentifier_2; "VAT Identifier")
                    {
                    }
                    column(VATPerc; "VAT %")
                    {
                        DecimalPlaces = 0 : 5;
                    }

                    trigger OnPreDataItem()
                    begin
                        if wgTotVATAmount = 0 then
                            CurrReport.Break();

                        Reset();
                    end;
                }
                dataitem(VATAmtLineLCY; "VAT Amount Line")
                {
                    DataItemTableView = sorting("VAT Identifier", "VAT Calculation Type", "Tax Group Code", "Use Tax", Positive);
                    UseTemporary = true;
                    column(VALVATAmountLCY; wgVALVATAmountLCY)
                    {
                        AutoFormatType = 1;
                    }
                    column(VALVATBaseLCY; wgVALVATBaseLCY)
                    {
                        AutoFormatType = 1;
                    }
                    column(VATIdentifier_3; "VAT Identifier")
                    {
                    }
                    column(VATPerc_2; "VAT %")
                    {
                        DecimalPlaces = 0 : 5;
                    }

                    trigger OnPreDataItem()
                    begin
                        if not wgShowVATLCY then
                            CurrReport.Break();

                        VATAmtLineLCY.Copy(VATAmtLine, true); //Set VATAmtLineLCY to VATAmtLine
                        Reset();
                    end;

                    trigger OnAfterGetRecord()
                    begin
                        wgVALVATBaseLCY :=
                            VATAmtLine.GetBaseLCY(
                                ServHdr."Posting Date", ServHdr."Currency Code", ServHdr."Currency Factor");
                        wgVALVATAmountLCY :=
                            VATAmtLine.GetAmountLCY(
                                ServHdr."Posting Date", ServHdr."Currency Code", ServHdr."Currency Factor");

                        wgTotVALVATBaseLCY += wgVALVATBaseLCY;
                        wgTotVALVATAmountLCY += wgVALVATAmountLCY;
                    end;
                }
                dataitem(Total; "Integer")
                {
                    DataItemTableView = sorting(Number) where(Number = const(1));
                    column(MonolithicVAT; wgMonolithicVAT)
                    {
                    }
                    column(NoOfVATAmtLines; wgNoOfVATAmountLines)
                    {
                    }
                    column(TotAmount; wgTotAmount)
                    {
                        AutoFormatExpression = ServHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(TotInvDiscAmount; wgTotInvDiscAmount)
                    {
                    }
                    column(TotInvDiscBaseAmount; wgTotInvDiscBaseAmount)
                    {
                    }
                    column(TotLineAmount; wgTotLineAmount)
                    {
                    }
                    column(TotPaymentDiscOnVAT; wgTotPaymentDiscOnVAT)
                    {
                        AutoFormatExpression = ServHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(TotVALVATAmountLCY; wgTotVALVATAmountLCY)
                    {
                    }
                    column(TotVALVATBaseLCY; wgTotVALVATBaseLCY)
                    {
                    }
                    column(TotVATAmount; wgTotVATAmount)
                    {
                        AutoFormatExpression = ServHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(VATAmtText; wgVATAmountText)
                    {
                    }

                    trigger OnAfterGetRecord()
                    begin
                        wgNoOfVATAmountLines := VATAmtLine.Count();
                        wgMonolithicVAT := wgCduwDCR_ReportFunctions.wgFncIsMonolithicVAT(VATAmtLine);
                        if wgMonolithicVAT then
                            wgVATAmountText := CopyStr(StrSubstNo(Trl('TotalVATAmount%1Perc'), VATAmtLine."VAT %"), 1, MaxStrLen(wgVATAmountText))
                        else
                            wgVATAmountText := CopyStr(Trl('TotalVATAmount'), 1, MaxStrLen(wgVATAmountText));
                    end;
                }

                trigger OnPreDataItem()
                begin
                    wgNoOfLoops := Abs(wgNoOfCopies) + 1;
                    wgCopyText := '';
                    SetRange(Number, 1, wgNoOfLoops);
                    wgOutputNo := 1;
                end;

                trigger OnAfterGetRecord()
                begin
                    if Number > 1 then begin
                        wgCopyText := CopyStr(Trl('Copy'), 1, MaxStrLen(wgCopyText));
                        ;
                        wgOutputNo += 1;
                    end;

                    wgTotVALVATBaseLCY := 0;
                    wgTotVALVATAmountLCY := 0;
                end;

                trigger OnPostDataItem()
                begin
                    if wgPrint then
                        wgCduServCountPrinted.Run(ServHdr);
                end;
            }

            trigger OnAfterGetRecord()
            var
                wlRecRespCenter: Record "Responsibility Center";
                wlRecServItemLine: Record "Service Item Line";
                wlCduLanguage: Codeunit Language;
                wlCduServAmtMgt: Codeunit "Serv-Amounts Mgt.";
                wlRecRef: RecordRef;
                wlCurrencyCode: Code[10];
                i: Integer;
                wlEmptyServItemLineNo: Integer;
            begin
                CurrReport.Language := wlCduLanguage.GetLanguageIdOrDefault("Language Code");
                wgCduwDCR_TranslationMgt.wgFncSetLanguageCode("Language Code");

                if wlRecRespCenter.Get("Responsibility Center") then begin
                    wgCduFormatAddr.RespCenter(wgCompanyAddr, wlRecRespCenter);
                    wgRecCompanyInfo."Phone No." := wlRecRespCenter."Phone No.";
                    wgRecCompanyInfo."Fax No." := wlRecRespCenter."Fax No.";
                end else begin
                    wgRecCompanyInfo."Phone No." := wgCompanyInfoPhoneNo;
                    wgRecCompanyInfo."Fax No." := wgCompanyInfoFaxNo;
                    wgCduFormatAddr.Company(wgCompanyAddr, wgRecCompanyInfo);
                end;

                if "Salesperson Code" = '' then
                    Clear(wgRecSalesPurchPerson)
                else
                    wgRecSalesPurchPerson.Get("Salesperson Code");

                wlCurrencyCode := "Currency Code";
                if wlCurrencyCode = '' then begin
                    wgRecGLSetup.TestField("LCY Code");
                    wlCurrencyCode := wgRecGLSetup."LCY Code";
                end;
                wgTotalText := StrSubstNo(Trl('Total%1'), wlCurrencyCode);
                wgTotalInclVATText := StrSubstNo(Trl('Total%1InclVAT'), wlCurrencyCode);
                wgTotalExclVATText := StrSubstNo(Trl('Total%1ExclVAT'), wlCurrencyCode);

                wgCduFormatAddr.ServiceHeaderBillTo(wgBillToAddr, ServHdr);
                wgCduFormatAddr.ServiceOrderSellto(wgCustAddr, ServHdr);
                wgCduFormatAddr.ServiceOrderShipto(wgShipToAddr, ServHdr);
                wgShowShippingAddr := "Customer No." <> "Bill-to Customer No.";
                for i := 1 to ArrayLen(wgShipToAddr) do
                    if wgShipToAddr[i] <> wgCustAddr[i] then
                        wgShowShippingAddr := true;
                if not wgShowShippingAddr then
                    Clear(wgShipToAddr);

                //Get Service Lines
                Clear(wlCduServAmtMgt);
                ServItemLine.Reset();
                ServItemLine.DeleteAll();
                ServLine.Reset();
                ServLine.DeleteAll();
                VATAmtLine.Reset();
                VATAmtLine.DeleteAll();
                wlCduServAmtMgt.GetServiceLines(ServHdr, ServLine, 0);  //0 = General

                //Get Service Item Lines
                wlRecServItemLine.SetRange("Document Type", "Document Type");
                wlRecServItemLine.SetRange("Document No.", "No.");
                if wlRecServItemLine.FindSet() then
                    repeat
                        ServItemLine.Init();
                        ServItemLine := wlRecServItemLine;
                        ServItemLine.Insert();
                    until wlRecServItemLine.Next() = 0;
                //Create empty dummy line
                ServLine.Reset();
                ServLine.SetRange("Document Type", "Document Type");
                ServLine.SetRange("Document No.", "No.");
                ServLine.SetRange("Service Item Line No.", 0);
                if ServLine.FindSet(true, false) then begin
                    wlEmptyServItemLineNo := wlFncEmptyServiceItemLine();
                    repeat
                        ServLine."Service Item Line No." := wlEmptyServItemLineNo;
                        ServLine.Modify();
                    until ServLine.Next() = 0;
                end;
                ServLine.Reset();

                //Get VAT Amount Lines
                ServLine.CalcVATAmountLines(0, ServHdr, ServLine, VATAmtLine, false); //0 = General
                ServLine.UpdateVATOnLines(0, ServHdr, ServLine, VATAmtLine);   //0 = General

                wgTotInvDiscAmount := VATAmtLine.GetTotalInvDiscAmount();
                wgTotInvDiscBaseAmount := VATAmtLine.GetTotalInvDiscBaseAmount(ServHdr."Prices Including VAT", ServHdr."Currency Code");
                wgTotLineAmount := VATAmtLine.GetTotalLineAmount(ServHdr."Prices Including VAT", ServHdr."Currency Code");
                wgTotVATAmount := VATAmtLine.GetTotalVATAmount();
                wgTotPaymentDiscOnVAT := -(wgTotLineAmount - wgTotInvDiscAmount - VATAmtLine.GetTotalAmountInclVAT());
                wgTotAmount := VATAmtLine.GetTotalVATBase();

                //Prepare VAT Amount Lines LCY
                if (not wgRecGLSetup."Print VAT specification in LCY") or
                      (ServHdr."Currency Code" = '') or
                      (VATAmtLine.GetTotalVATAmount() = 0)
                then begin
                    wgShowVATLCY := false;
                    wgVALSpecLCYHeader := '';
                    wgVALExchRate := '';
                end
                else begin
                    wgShowVATLCY := true;
                    if wgRecGLSetup."LCY Code" = '' then
                        wgVALSpecLCYHeader := Trl('VATAmtSpecIn') + ' ' + Trl('LocalCurrency')
                    else
                        wgVALSpecLCYHeader := Trl('VATAmtSpecIn') + ' ' + Format(wgRecGLSetup."LCY Code");
                    wgRecCurrExchRate.FindCurrency(ServHdr."Posting Date", ServHdr."Currency Code", 1);
                    wgVALExchRate := StrSubstNo(Trl('ExchangeRate%1/%2'), wgRecCurrExchRate."Relational Exch. Rate Amount", wgRecCurrExchRate."Exchange Rate Amount");
                end;

                //Get Item Tracking
                TrackingSpec.Reset();
                TrackingSpec.DeleteAll();
                if wgShowLotSN then begin
                    wgCduItemTrackingDocMgt.SetRetrieveAsmItemTracking(true);
                    wgCduItemTrackingDocMgt.RetrieveDocumentItemTracking(TrackingSpec, ServHdr."No.",
                            Database::"Service Header", ServHdr."Document Type");
                end;

                //Set HideLineDiscount
                wlRecRef.GetTable(ServHdr);
                wgHideLineDiscount := wgCduwDCR_ReportFunctions.wgFncHideLineDiscount(wlRecRef);
            end;
        }
    }

    requestpage
    {

        SaveValues = true;

        layout
        {
            area(Content)
            {
                group(Options)
                {
                    Caption = 'Options';
                    field(NoOfCopies; wgNoOfCopies)
                    {
                        ApplicationArea = All;
                        Caption = 'No. of Copies';
                    }
                    field(ShowInternalInfo; wgShowInternalInfo)
                    {
                        ApplicationArea = All;
                        Caption = 'Show Internal Information';
                    }
                    field(ShowLotSN; wgShowLotSN)
                    {
                        ApplicationArea = All;
                        Caption = 'Show Serial/Lot Number';
                        Visible = false;
                    }
                }
            }
        }

        trigger OnOpenPage()
        begin
            wgNoOfCopies := 0;
            wgRequestPage := true;
        end;
    }

    trigger OnInitReport()
    begin
        wgRecGLSetup.Get();

        wgRecServSetup.Get();

        wgRecCompanyInfo.Get();
        wgCompanyInfoPhoneNo := wgRecCompanyInfo."Phone No.";
        wgCompanyInfoFaxNo := wgRecCompanyInfo."Fax No.";

        if wgRecServSetup."Logo Position on Documents" <> wgRecServSetup."Logo Position on Documents"::"No Logo" then
            wgRecCompanyInfo.CalcFields(Picture);
    end;

    trigger OnPreReport()
    begin
        wlFncInitReportSettings();
        wgPrint := wgPrint or not CurrReport.Preview;

        if not wgRequestPage then
            wgNoOfCopies := 0;
    end;

    var
        wgRecCompanyInfo: Record "Company Information";
        wgRecCurrExchRate: Record "Currency Exchange Rate";
        wgRecGLSetup: Record "General Ledger Setup";
        wgRecItem: Record Item;
        wgRecResource: Record Resource;
        wgRecSalesPurchPerson: Record "Salesperson/Purchaser";
        wgRecServiceCost: Record "Service Cost";
        wgRecServSetup: Record "Service Mgt. Setup";
        wgRecWorkType: Record "Work Type";
        wgCduFormatAddr: Codeunit "Format Address";
        wgCduItemTrackingDocMgt: Codeunit "Item Tracking Doc. Management";
        wgCduServCountPrinted: Codeunit "Service-Printed";
        wgCduwDCR_ReportFunctions: Codeunit wDCR_ReportFunctions;
        wgCduwDCR_TranslationMgt: Codeunit wDCR_TranslationMgt;
        wgHideLineDiscount: Boolean;
        wgMonolithicVAT: Boolean;
        wgPrint: Boolean;
        wgRequestPage: Boolean;
        wgShowInternalInfo: Boolean;
        wgShowLotSN: Boolean;
        wgShowShippingAddr: Boolean;
        wgShowVATLCY: Boolean;
        wgTotAmount: Decimal;
        wgTotInvDiscAmount: Decimal;
        wgTotInvDiscBaseAmount: Decimal;
        wgTotLineAmount: Decimal;
        wgTotPaymentDiscOnVAT: Decimal;
        wgTotVALVATAmountLCY: Decimal;
        wgTotVALVATBaseLCY: Decimal;
        wgTotVATAmount: Decimal;
        wgVALVATAmountLCY: Decimal;
        wgVALVATBaseLCY: Decimal;
        wgDateFormatHdr: Integer;
        wgNoOfCopies: Integer;
        wgNoOfLoops: Integer;
        wgNoOfVATAmountLines: Integer;
        wgOutputNo: Integer;
        wgReportId: Integer;
        wgCompanyInfoFaxNo: Text[30];
        wgCompanyInfoPhoneNo: Text[30];
        wgCopyText: Text[30];
        wgVATAmountText: Text[30];
        wgTotalText, wgTotalExclVATText, wgTotalInclVATText : Text[50];
        wgVALExchRate: Text[50];
        wgVALSpecLCYHeader: Text[80];
        wgBillToAddr, wgCompanyAddr, wgCustAddr, wgShipToAddr : array[8] of Text[100];
        wgDimText: Text[120];

    procedure InitializeRequest(pNoOfCopiesFrom: Integer; pShowInternalInfoFrom: Boolean; pPrintFrom: Boolean)
    begin
        wgNoOfCopies := pNoOfCopiesFrom;
        wgShowInternalInfo := pShowInternalInfoFrom;
        wgPrint := pPrintFrom;
    end;

    local procedure Trl(pLblName: Text[50]): Text
    begin
        exit(wgCduwDCR_TranslationMgt.wgFncTranslate(pLblName));
    end;

    local procedure wlFncEmptyServiceItemLine(): Integer
    begin
        ServItemLine.Init();
        ServItemLine."Document Type" := ServHdr."Document Type";
        ServItemLine."Document No." := ServHdr."No.";
        ServItemLine."Line No." := wlFncGetEmptyServiceItemLineNo();
        ServItemLine.Description := CopyStr(Trl('DescriptionEmptyLine'), 1, MaxStrLen(ServItemLine.Description));
        ServItemLine.Insert(false);
        exit(ServItemLine."Line No.");
    end;

    local procedure wlFncGetEmptyServiceItemLineNo(): Integer
    var
        wlRecServItemLine: Record "Service Item Line";
    begin
        wlRecServItemLine.SetRange("Document Type", ServHdr."Document Type");
        wlRecServItemLine.SetRange("Document No.", ServHdr."No.");
        if wlRecServItemLine.FindLast() then
            exit(wlRecServItemLine."Line No." + 10000)
        else
            exit(10000);
    end;

    local procedure wlFncInitReportSettings()
    var
        wlCduTemplateReportHelperDCR: Codeunit TemplateReportHelperDCR;
    begin
        if wgReportId = 0 then
            Evaluate(wgReportId, (DelChr(CurrReport.ObjectId(false), '=', DelChr(CurrReport.ObjectId(false), '=', '1234567890'))));
        wgCduwDCR_TranslationMgt.wgFncSetReportId(wgReportId);
        wgDateFormatHdr := wlCduTemplateReportHelperDCR.wgFncGetHeaderDateFormat(wgReportId);
    end;
}
