report 72172 ServiceInvoiceDCR
{
    Caption = 'Service - Invoice';
    PreviewMode = PrintLayout;
    UsageCategory = None;

    dataset
    {
        dataitem(InvHdr; "Service Invoice Header")
        {
            DataItemTableView = sorting("No.");
            RequestFilterFields = "No.";
            RequestFilterHeading = 'Posted Service Invoice';
            column(BilltoCustNo; "Bill-to Customer No.")
            {
            }
            column(CompanyAddr1; wgCompanyAddr[1])
            {
            }
            column(CompanyAddr2; wgCompanyAddr[2])
            {
            }
            column(CompanyAddr3; wgCompanyAddr[3])
            {
            }
            column(CompanyAddr4; wgCompanyAddr[4])
            {
            }
            column(CompanyAddr5; wgCompanyAddr[5])
            {
            }
            column(CompanyAddr6; wgCompanyAddr[6])
            {
            }
            column(CompanyBankAccNo; wgRecCompanyInfo."Bank Account No.")
            {
            }
            column(CompanyBankName; wgRecCompanyInfo."Bank Name")
            {
            }
            column(CompanyEMail; wgRecCompanyInfo."E-Mail")
            {
            }
            column(CompanyFaxNo; wgRecCompanyInfo."Fax No.")
            {
            }
            column(CompanyGiroNo; wgRecCompanyInfo."Giro No.")
            {
            }
            column(CompanyHomePage; wgRecCompanyInfo."Home Page")
            {
            }
            column(CompanyIBAN; wgRecCompanyInfo.IBAN)
            {
            }
            column(CompanyPhoneNo; wgRecCompanyInfo."Phone No.")
            {
            }
            column(CompanyPicture; wgRecCompanyInfo.Picture)
            {
            }
            column(CompanyRegistrationNo; wgRecCompanyInfo."Registration No.")
            {
            }
            column(CompanySWIFT; wgRecCompanyInfo."SWIFT Code")
            {
            }
            column(CompanyVATRegNo; wgRecCompanyInfo."VAT Registration No.")
            {
            }
            column(CustAddr1; wgCustAddr[1])
            {
            }
            column(CustAddr2; wgCustAddr[2])
            {
            }
            column(CustAddr3; wgCustAddr[3])
            {
            }
            column(CustAddr4; wgCustAddr[4])
            {
            }
            column(CustAddr5; wgCustAddr[5])
            {
            }
            column(CustAddr6; wgCustAddr[6])
            {
            }
            column(CustAddr7; wgCustAddr[7])
            {
            }
            column(CustAddr8; wgCustAddr[8])
            {
            }
            column(CustNo; "Customer No.")
            {
            }
            column(DocumentDate; "Document Date")
            {
            }
            column(DocumentDateText; Format("Document Date", 0, wgDateFormatHdr))
            {
            }
            column(DocumentNo; "No.")
            {
            }
            column(DueDate; "Due Date")
            {
            }
            column(DueDateText; Format("Due Date", 0, wgDateFormatHdr))
            {
            }
            column(HideLineDiscount; wgHideLineDiscount)
            {
            }
            column(LanguageCode; "Language Code")
            {
            }
            column(lblAllowInvDisc; Trl('AllowInvDisc'))
            {
            }
            column(lblAmount; Trl('Amount'))
            {
            }
            column(lblAmountInclVAT; Trl('AmountInclVAT'))
            {
            }
            column(lblAttachedToLineNo; Trl('AttachedToLineNo'))
            {
            }
            column(lblBankAccNo; Trl('BankAccNo'))
            {
            }
            column(lblBankName; Trl('BankName'))
            {
            }
            column(lblBillToAddress; Trl('BillToAddress'))
            {
            }
            column(lblBillToCustomerNo; Trl('BillToCustomerNo'))
            {
            }
            column(lblCompanyRegistrationNo; Trl('CompanyRegistrationNo'))
            {
            }
            column(lblCostLines; Trl('CostLines'))
            {
            }
            column(lblCounterRead; Trl('CounterRead'))
            {
            }
            column(lblCrossReferenceNo; Trl('CrossReferenceNo'))
            {
            }
            column(lblDescription; Trl('Description'))
            {
            }
            column(lblDocumentDate; Trl('DocumentDate'))
            {
            }
            column(lblDocumentNo; Trl('DocumentNo'))
            {
            }
            column(lblDocumentType; Trl('DocumentType'))
            {
            }
            column(lblDueDate; Trl('DueDate'))
            {
            }
            column(lblEmail; Trl('Email'))
            {
            }
            column(lblFaultComment; Trl('FaultComment'))
            {
            }
            column(lblFaxNo; Trl('FaxNo'))
            {
            }
            column(lblGiroNo; Trl('GiroNo'))
            {
            }
            column(lblGLAccountLines; Trl('GLAccountLines'))
            {
            }
            column(lblGLAccountNo; Trl('GLAccountNo'))
            {
            }
            column(lblGrossWeight; Trl('GrossWeight'))
            {
            }
            column(lblHeaderDimensions; Trl('HeaderDimensions'))
            {
            }
            column(lblHomePage; Trl('HomePage'))
            {
            }
            column(lblIBAN; Trl('IBAN'))
            {
            }
            column(lblInvDiscAmount; Trl('InvDiscAmount'))
            {
            }
            column(lblInvDiscBaseAmount; Trl('InvDiscBaseAmount'))
            {
            }
            column(lblInvoiceDate; Trl('InvoiceDate'))
            {
            }
            column(lblInvoiceNo; Trl('InvoiceNo'))
            {
            }
            column(lblItemLines; Trl('ItemLines'))
            {
            }
            column(lblLineAmount; Trl('LineAmount'))
            {
            }
            column(lblLineDimensions; Trl('LineDimensions'))
            {
            }
            column(lblLineDiscountAmount; Trl('LineDiscountAmount'))
            {
            }
            column(lblLineDiscountPerc; Trl('LineDiscountPerc'))
            {
            }
            column(lblLineNo; Trl('LineNo'))
            {
            }
            column(lblLocationCode; Trl('LocationCode'))
            {
            }
            column(lblLotNo; Trl('LotNo'))
            {
            }
            column(lblNeededByDate; Trl('NeededByDate'))
            {
            }
            column(lblNetWeight; Trl('NetWeight'))
            {
            }
            column(lblNewCounterRead; Trl('NewCounterRead'))
            {
            }
            column(lblNo; Trl('No'))
            {
            }
            column(lblOrderDate; Trl('OrderDate'))
            {
            }
            column(lblOrderNo; Trl('OrderNo'))
            {
            }
            column(lblOtherLines; Trl('OtherLines'))
            {
            }
            column(lblOutstandingQtyBase; Trl('OutstandingQtyBase'))
            {
            }
            column(lblOutstandingQuantity; Trl('OutstandingQuantity'))
            {
            }
            column(lblPageOf; Trl('Page{0}of{1}'))
            {
            }
            column(lblPaymentDiscountVAT; Trl('PaymentDiscountVAT'))
            {
            }
            column(lblPaymentTerms; Trl('PaymentTerms'))
            {
            }
            column(lblPhoneNo; Trl('PhoneNo'))
            {
            }
            column(lblPrevCounterRead; Trl('PrevCounterRead'))
            {
            }
            column(lblPricesInclVAT; Trl('PricesInclVAT'))
            {
            }
            column(lblQtyInvoicedBase; Trl('QtyInvoicedBase'))
            {
            }
            column(lblQtyPerUOM; Trl('QtyPerUOM'))
            {
            }
            column(lblQtyToInvoiceBase; Trl('QtyToInvoiceBase'))
            {
            }
            column(lblQuantity; Trl('Quantity'))
            {
            }
            column(lblQuantityBase; Trl('QuantityBase'))
            {
            }
            column(lblQuantityInvoiced; Trl('QuantityInvoiced'))
            {
            }
            column(lblReservedQtyBase; Trl('ReservedQtyBase'))
            {
            }
            column(lblResolutionComment; Trl('ResolutionComment'))
            {
            }
            column(lblResourceLines; Trl('ResourceLines'))
            {
            }
            column(lblSalesPerson; Trl('SalesPerson'))
            {
            }
            column(lblSellToCustomerNo; Trl('SellToCustomerNo'))
            {
            }
            column(lblSerialNo; Trl('SerialNo'))
            {
            }
            column(lblServItemGroup; Trl('ServItemGroup'))
            {
            }
            column(lblServObjLocationName; Trl('ServObjLocationName'))
            {
            }
            column(lblServObjLocationNo; Trl('ServObjLocationNo'))
            {
            }
            column(lblShipment; Trl('Shipment'))
            {
            }
            column(lblShipmentDate; Trl('ShipmentDate'))
            {
            }
            column(lblShipmentMethod; Trl('ShipmentMethod'))
            {
            }
            column(lblShipToAddress; Trl('ShipToAddress'))
            {
            }
            column(lblSubtotal; Trl('Subtotal'))
            {
            }
            column(lblSWIFT; Trl('SWIFT'))
            {
            }
            column(lblTotal; Trl('Total'))
            {
            }
            column(lblTotalCosts; Trl('TotalCosts'))
            {
            }
            column(lblTotalItems; Trl('TotalItems'))
            {
            }
            column(lblTotalOther; Trl('TotalOther'))
            {
            }
            column(lblTotalResources; Trl('TotalResources'))
            {
            }
            column(lblTotalTransFooter; Trl('TotalTransFooter'))
            {
            }
            column(lblTotalTransHeader; Trl('TotalTransHeader'))
            {
            }
            column(lblType; Trl('Type'))
            {
            }
            column(lblUnitCost; Trl('UnitCost'))
            {
            }
            column(lblUnitCostLCY; Trl('UnitCostLCY'))
            {
            }
            column(lblUnitPrice; Trl('UnitPrice'))
            {
            }
            column(lblUnitsPerParcel; Trl('UnitsPerParcel'))
            {
            }
            column(lblUOM; Trl('UOM'))
            {
            }
            column(lblUOMCode; Trl('UOMCode'))
            {
            }
            column(lblVATAmount; Trl('VATAmount'))
            {
            }
            column(lblVATAmountSpecification; Trl('VATAmountSpecification'))
            {
            }
            column(lblVATBase; Trl('VATBase'))
            {
            }
            column(lblVATClause; Trl('VATClause'))
            {
            }
            column(lblVATIdentifier; Trl('VATIdentifier'))
            {
            }
            column(lblVATPerc; Trl('VATPerc'))
            {
            }
            column(lblVATRegistrationNo; Trl('VATRegistrationNo'))
            {
            }
            column(lblYourReference; Trl('YourReference'))
            {
            }
            column(LocationCode; "Location Code")
            {
            }
            column(OrderDate; "Order Date")
            {
            }
            column(OrderDateText; Format("Order Date", 0, wgDateFormatHdr))
            {
            }
            column(OrderNo; "Order No.")
            {
            }
            column(PaymentTermsDesc; wgCduwDCR_TranslationMgt.wgFncGetPaymTermsTrl("Payment Terms Code"))
            {
            }
            column(PostingDate; "Posting Date")
            {
            }
            column(PostingDateText; Format("Posting Date", 0, wgDateFormatHdr))
            {
            }
            column(PricesInclVAT; "Prices Including VAT")
            {
            }
            column(PricesInclVATYesNo; Format("Prices Including VAT"))
            {
            }
            column(SalesPurchPersonName; wgRecSalesPurchPerson.Name)
            {
            }
            column(ShipToAddr1; wgShipToAddr[1])
            {
            }
            column(ShipToAddr2; wgShipToAddr[2])
            {
            }
            column(ShipToAddr3; wgShipToAddr[3])
            {
            }
            column(ShipToAddr4; wgShipToAddr[4])
            {
            }
            column(ShipToAddr5; wgShipToAddr[5])
            {
            }
            column(ShipToAddr6; wgShipToAddr[6])
            {
            }
            column(ShipToAddr7; wgShipToAddr[7])
            {
            }
            column(ShipToAddr8; wgShipToAddr[8])
            {
            }
            column(ShipToAddrSet; wgShowShippingAddr)
            {
            }
            column(TodayText; Format(Today(), 0, wgDateFormatHdr))
            {
            }
            column(TotalExclVATText; wgTotalExclVATText)
            {
            }
            column(TotalInclVATText; wgTotalInclVATText)
            {
            }
            column(TotalText; wgTotalText)
            {
            }
            column(VALExchRate; wgVALExchRate)
            {
            }
            column(VALSpecLCYHeader; wgVALSpecLCYHeader)
            {
            }
            column(VATBaseDiscPerc; "VAT Base Discount %")
            {
                AutoFormatType = 1;
            }
            column(VATRegNo; "VAT Registration No.")
            {
            }
            column(YourReference; "Your Reference")
            {
            }
            dataitem(CopyLoop; "Integer")
            {
                DataItemTableView = sorting(Number);
                column(OutputNo; wgOutputNo)
                {
                }
                column(ServInvoiceTitle; StrSubstNo(Trl('ServiceInvoice%1'), wgCopyText))
                {
                }
                dataitem(HdrComment; "Service Comment Line")
                {
                    DataItemLink = "No." = field("No.");
                    DataItemLinkReference = InvHdr;
                    DataItemTableView = sorting("Table Name", "Table Subtype", "No.", Type, "Table Line No.", "Line No.") where("Table Name" = const("Service Invoice Header"), Type = const(General), "Table Line No." = const(0));
                    column(Comment_2; Comment)
                    {
                    }
                }
                dataitem(HeaderDim; "Dimension Set Entry")
                {
                    DataItemLink = "Dimension Set ID" = field("Dimension Set ID");
                    DataItemLinkReference = InvHdr;
                    DataItemTableView = sorting("Dimension Set ID", "Dimension Code");
                    column(DimText; wgDimText)
                    {
                    }

                    trigger OnPreDataItem()
                    begin
                        if not wgShowInternalInfo then
                            CurrReport.Break();
                    end;

                    trigger OnAfterGetRecord()
                    begin
                        wgCduwDCR_ReportFunctions.wgFncGetDimText(HeaderDim, wgDimText);
                    end;
                }
                dataitem(ServItemLine; "Service Shipment Item Line")
                {
                    DataItemLink = "No." = field("No.");
                    DataItemLinkReference = InvHdr;
                    DataItemTableView = sorting("No.", "Line No.");
                    UseTemporary = true;
                    column(ContractNo; "Contract No.")
                    {
                    }
                    column(CustomerNo; "Customer No.")
                    {
                    }
                    column(Description2_2; "Description 2")
                    {
                    }
                    column(Description_2; Description)
                    {
                    }
                    column(FaultAreaCode; "Fault Area Code")
                    {
                    }
                    column(FaultCode; "Fault Code")
                    {
                    }
                    column(FaultReasonCode; "Fault Reason Code")
                    {
                    }
                    column(ItemNo; "Item No.")
                    {
                    }
                    column(LocationofServItem; "Location of Service Item")
                    {
                    }
                    column(ResolutionCode; "Resolution Code")
                    {
                    }
                    column(SerialNo_2; "Serial No.")
                    {
                    }
                    column(ServItemGroupCode; "Service Item Group Code")
                    {
                    }
                    column(ServItemNo; "Service Item No.")
                    {
                    }
                    column(ServPriceGroupCode; "Service Price Group Code")
                    {
                    }
                    column(ServShelfNo; "Service Shelf No.")
                    {
                    }
                    column(ShiptoCode; "Ship-to Code")
                    {
                    }
                    column(SymptomCode; "Symptom Code")
                    {
                    }
                    column(VendorItemNo; "Vendor Item No.")
                    {
                    }
                    column(VendorNo; "Vendor No.")
                    {
                    }
                    column(Warranty; Warranty)
                    {
                    }
                    dataitem(FaultComment; "Service Comment Line")
                    {
                        DataItemLink = "No." = field("No."), "Table Line No." = field("Line No.");
                        DataItemTableView = sorting("Table Name", "Table Subtype", "No.", Type, "Table Line No.", "Line No.") where("Table Name" = const("Service Invoice Header"), Type = const(Fault));
                        column(Comment_Fault; Comment)
                        {
                        }
                    }
                    dataitem(ResolutionComment; "Service Comment Line")
                    {
                        DataItemLink = "No." = field("No."), "Table Line No." = field("Line No.");
                        DataItemTableView = sorting("Table Name", "Table Subtype", "No.", Type, "Table Line No.", "Line No.") where("Table Name" = const("Service Invoice Header"), Type = const(Resolution));
                        column(Comment_Resolution; Comment)
                        {
                        }
                    }
                    dataitem(InvLine; "Service Invoice Line")
                    {
                        DataItemLinkReference = InvHdr;
                        DataItemTableView = sorting("Document No.", "Line No.");
                        UseTemporary = true;
                        column(Amount; Amount)
                        {
                            AutoFormatExpression = InvHdr."Currency Code";
                            AutoFormatType = 1;
                        }
                        column(AmountInclVAT; "Amount Including VAT")
                        {
                            AutoFormatExpression = InvHdr."Currency Code";
                            AutoFormatType = 1;
                        }
                        column(AttachedToLineNo; "Attached to Line No.")
                        {
                        }
                        column(Description; Description)
                        {
                        }
                        column(Description2; "Description 2")
                        {
                        }
                        column(GrossWeight; "Gross Weight")
                        {
                        }
                        column(InvDiscAmount; -"Inv. Discount Amount")
                        {
                            AutoFormatExpression = InvHdr."Currency Code";
                            AutoFormatType = 1;
                        }
                        column(LineAmount; "Line Amount")
                        {
                            AutoFormatExpression = InvHdr."Currency Code";
                            AutoFormatType = 1;
                        }
                        column(LineDiscAmount; "Line Discount Amount")
                        {
                        }
                        column(LineDiscPerc; "Line Discount %")
                        {
                        }
                        column(LineNo; "Line No.")
                        {
                        }
                        column(NetWeight; "Net Weight")
                        {
                        }
                        column(No_2; "No.")
                        {
                        }
                        column(PostedShipmentDate; wgPostedShipmentDate)
                        {
                        }
                        column(QtyPerUOM; "Qty. per Unit of Measure")
                        {
                        }
                        column(Quantity; Quantity)
                        {
                        }
                        column(QuantityBase; "Quantity (Base)")
                        {
                        }
                        column(ResourceType; Format(wgRecResource.Type))
                        {
                        }
                        column(ResourceTypeNo; wgRecResource.Type.AsInteger())
                        {
                        }
                        column(ServCostDescription; wgRecServiceCost.Description)
                        {
                        }
                        column(ServItemNo_2; "Service Item No.")
                        {
                        }
                        column(Type; Format(Type))
                        {
                        }
                        column(TypeNo; Type.AsInteger())
                        {
                        }
                        column(UnitCostLCY; "Unit Cost (LCY)")
                        {
                        }
                        column(UnitPrice; "Unit Price")
                        {
                            AutoFormatExpression = InvHdr."Currency Code";
                            AutoFormatType = 2;
                        }
                        column(UnitsPerParcel; "Units per Parcel")
                        {
                        }
                        column(UOM; wgCduwDCR_TranslationMgt.wgFncGetUnitOfMeaseTrl("Unit of Measure Code"))
                        {
                        }
                        column(UOMCode; "Unit of Measure Code")
                        {
                        }
                        column(VATIdentifier; "VAT Identifier")
                        {
                        }
                        column(VATPerc_3; "VAT %")
                        {
                        }
                        column(WorkTypeCode; "Work Type Code")
                        {
                        }
                        column(WorkTypeDescription; wgRecWorkType.Description)
                        {
                        }
                        dataitem(LineComment; "Service Comment Line")
                        {
                            DataItemLink = "No." = field("Document No."), "Table Line No." = field("Line No.");
                            DataItemTableView = sorting("Table Name", "Table Subtype", "No.", Type, "Table Line No.", "Line No.") where("Table Name" = const("Service Invoice Header"), Type = const(General));
                            column(Comment; Comment)
                            {
                            }
                        }
                        dataitem(ShipmentBuf; "Service Shipment Buffer")
                        {
                            DataItemTableView = sorting("Document No.", "Line No.", "Entry No.");
                            UseTemporary = true;
                            column(PostingDate_2; "Posting Date")
                            {
                            }
                            column(Quantity_5; Quantity)
                            {
                                DecimalPlaces = 0 : 5;
                            }

                            trigger OnPreDataItem()
                            begin
                                Reset();
                                SetRange("Document No.", InvLine."Document No.");
                                SetRange("Line No.", InvLine."Line No.");
                            end;
                        }
                        dataitem(LineDim; "Dimension Set Entry")
                        {
                            DataItemLink = "Dimension Set ID" = field("Dimension Set ID");
                            DataItemTableView = sorting("Dimension Set ID", "Dimension Code");
                            column(DimText_2; wgDimText)
                            {
                            }

                            trigger OnPreDataItem()
                            begin
                                if not wgShowInternalInfo then
                                    CurrReport.Break();
                            end;

                            trigger OnAfterGetRecord()
                            begin
                                wgCduwDCR_ReportFunctions.wgFncGetDimText(LineDim, wgDimText);
                            end;
                        }
                        dataitem(TrackingSpec; "Tracking Specification")
                        {
                            DataItemTableView = sorting("Entry No.");
                            UseTemporary = true;
                            column(LotNo; "Lot No.")
                            {
                            }
                            column(Quantity_4; "Quantity (Base)")
                            {
                            }
                            column(SerialNo; "Serial No.")
                            {
                            }

                            trigger OnPreDataItem()
                            begin
                                if not wgShowLotSN then
                                    CurrReport.Break();
                                Reset();
                                SetRange("Source Ref. No.", InvLine."Line No.");
                            end;
                        }

                        trigger OnPreDataItem()
                        var
                            wlMoreLines: Boolean;
                        begin
                            Reset();
                            wlMoreLines := InvLine.Find('+');
                            while wlMoreLines and (InvLine.Description = '') and (InvLine."Description 2" = '') and
                                        (InvLine."No." = '') and (InvLine.Quantity = 0) and
                                        (InvLine.Amount = 0)
                            do
                                wlMoreLines := InvLine.Next(-1) <> 0;
                            if not wlMoreLines then
                                CurrReport.Break();
                            InvLine.SetRange("Line No.", 0, InvLine."Line No.");
                            InvLine.SetRange("Service Item Line No.", ServItemLine."Line No.");
                        end;

                        trigger OnAfterGetRecord()
                        begin
                            //Get Shipment Lines
                            wgPostedShipmentDate := 0D;
                            if InvLine.Quantity <> 0 then
                                wgPostedShipmentDate := wlFncFindPostedShipmentDate(InvLine);

                            if not InvHdr."Prices Including VAT" and
                                  (InvLine."VAT Calculation Type" = InvLine."VAT Calculation Type"::"Full VAT")
                            then
                                InvLine."Line Amount" := 0;

                            if (InvLine.Type = InvLine.Type::"G/L Account") and (not wgShowInternalInfo) then
                                InvLine."No." := '';

                            if (InvLine.Type <> InvLine.Type::Resource) or (not wgRecResource.Get("No.")) then
                                Clear(wgRecResource);

                            if not wgRecWorkType.Get("Work Type Code") then
                                Clear(wgRecWorkType);

                            if not wgRecServiceCost.Get("No.") then
                                Clear(wgRecServiceCost);
                        end;
                    }

                    trigger OnPreDataItem()
                    begin
                        Reset();
                    end;
                }
                dataitem(VATAmtLine; "VAT Amount Line")
                {
                    DataItemTableView = sorting("VAT Identifier", "VAT Calculation Type", "Tax Group Code", "Use Tax", Positive);
                    UseTemporary = true;
                    column(InvDiscAmount_2; "Invoice Discount Amount")
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(InvDiscBaseAmount; "Inv. Disc. Base Amount")
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(LineAmount_2; "Line Amount")
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(VATAmount; "VAT Amount")
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(VATBase; "VAT Base")
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(VATIdentifier_2; "VAT Identifier")
                    {
                    }
                    column(VATPerc; "VAT %")
                    {
                        DecimalPlaces = 0 : 5;
                    }

                    trigger OnPreDataItem()
                    begin
                        if wgTotVATAmount = 0 then
                            CurrReport.Break();

                        Reset();
                    end;
                }
                dataitem(VATClause; "VAT Amount Line")
                {
                    DataItemTableView = sorting("VAT Identifier", "VAT Calculation Type", "Tax Group Code", "Use Tax", Positive);
                    UseTemporary = true;
                    column(Description2_3; wgRecVATClause."Description 2")
                    {
                    }
                    column(Description_4; wgRecVATClause.Description)
                    {
                    }
                    column(VATAmount_4; "VAT Amount")
                    {
                    }
                    column(VATClauseCode; "VAT Clause Code")
                    {
                    }
                    column(VATIdentifier_4; "VAT Identifier")
                    {
                    }

                    trigger OnPreDataItem()
                    begin
                        Copy(VATAmtLine, true); //Set VATClause to VATAmtLine
                        Reset();
                    end;

                    trigger OnAfterGetRecord()
                    begin
                        if "VAT Clause Code" = '' then
                            CurrReport.Skip();
                        if wgRecVATClause.Code <> "VAT Clause Code" then
                            if not wgRecVATClause.Get("VAT Clause Code") then
                                CurrReport.Skip();

                        wgRecVATClause.TranslateDescription(InvHdr."Language Code");
                    end;
                }
                dataitem(VATAmtLineLCY; "VAT Amount Line")
                {
                    DataItemTableView = sorting("VAT Identifier", "VAT Calculation Type", "Tax Group Code", "Use Tax", Positive);
                    UseTemporary = true;
                    column(VALVATAmountLCY; wgVALVATAmountLCY)
                    {
                        AutoFormatType = 1;
                    }
                    column(VALVATBaseLCY; wgVALVATBaseLCY)
                    {
                        AutoFormatType = 1;
                    }
                    column(VATIdentifier_3; "VAT Identifier")
                    {
                    }
                    column(VATPerc_2; "VAT %")
                    {
                        DecimalPlaces = 0 : 5;
                    }

                    trigger OnPreDataItem()
                    begin
                        if not wgShowVATLCY then
                            CurrReport.Break();

                        Copy(VATAmtLine, true); //Set VATAmtLineLCY to VATAmtLine
                        Reset();
                    end;

                    trigger OnAfterGetRecord()
                    begin
                        wgVALVATBaseLCY :=
                            VATAmtLine.GetBaseLCY(
                                InvHdr."Posting Date", InvHdr."Currency Code", InvHdr."Currency Factor");
                        wgVALVATAmountLCY :=
                            VATAmtLine.GetAmountLCY(
                                InvHdr."Posting Date", InvHdr."Currency Code", InvHdr."Currency Factor");

                        wgTotVALVATBaseLCY += wgVALVATBaseLCY;
                        wgTotVALVATAmountLCY += wgVALVATAmountLCY;
                    end;
                }
                dataitem(Total; "Integer")
                {
                    DataItemTableView = sorting(Number) where(Number = const(1));
                    column(MonolithicVAT; wgMonolithicVAT)
                    {
                    }
                    column(NoOfVATAmtLines; wgNoOfVATAmountLines)
                    {
                    }
                    column(TotAmount; wgTotAmount)
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(TotInvDiscAmount; -wgTotInvDiscAmount)
                    {
                    }
                    column(TotInvDiscBaseAmount; wgTotInvDiscBaseAmount)
                    {
                    }
                    column(TotLineAmount; wgTotLineAmount)
                    {
                    }
                    column(TotPaymentDiscOnVAT; wgTotPaymentDiscOnVAT)
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(TotVALVATAmountLCY; wgTotVALVATAmountLCY)
                    {
                    }
                    column(TotVALVATBaseLCY; wgTotVALVATBaseLCY)
                    {
                    }
                    column(TotVATAmount; wgTotVATAmount)
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(VATAmtText; wgVATAmountText)
                    {
                    }

                    trigger OnAfterGetRecord()
                    begin
                        wgNoOfVATAmountLines := VATAmtLine.Count();
                        wgMonolithicVAT := wgCduwDCR_ReportFunctions.wgFncIsMonolithicVAT(VATAmtLine);
                        if wgMonolithicVAT then
                            wgVATAmountText := CopyStr(StrSubstNo(Trl('TotalVATAmount%1Perc'), VATAmtLine."VAT %"), 1, MaxStrLen(wgVATAmountText))
                        else
                            wgVATAmountText := CopyStr(Trl('TotalVATAmount'), 1, MaxStrLen(wgVATAmountText));
                    end;
                }

                trigger OnPreDataItem()
                var
                    wlRecCust: Record Customer;
                begin
                    if not wlRecCust.Get(InvHdr."Bill-to Customer No.") then
                        Clear(wlRecCust);
                    wgNoOfLoops := Abs(wgNoOfCopies) + wlRecCust."Invoice Copies" + 1;

                    wgCopyText := '';
                    SetRange(Number, 1, wgNoOfLoops);
                    wgOutputNo := 1;
                end;

                trigger OnAfterGetRecord()
                begin
                    if Number > 1 then begin
                        wgCopyText := CopyStr(Trl('Copy'), 1, MaxStrLen(wgCopyText));
                        ;
                        wgOutputNo += 1;
                    end;

                    wgTotVALVATBaseLCY := 0;
                    wgTotVALVATAmountLCY := 0;
                end;

                trigger OnPostDataItem()
                begin
                    if wgPrint then
                        wgCduServInvCountPrinted.Run(InvHdr);
                end;
            }

            trigger OnAfterGetRecord()
            var
                wlRecRespCenter: Record "Responsibility Center";
                wlCduLanguage: Codeunit Language;
                wlRecRef: RecordRef;
                wlCurrencyCode: Code[10];
                wlEmptyServItemLineNo: Integer;
            begin
                CurrReport.Language := wlCduLanguage.GetLanguageIdOrDefault("Language Code");
                wgCduwDCR_TranslationMgt.wgFncSetLanguageCode("Language Code");

                if wlRecRespCenter.Get("Responsibility Center") then begin
                    wgCduFormatAddr.RespCenter(wgCompanyAddr, wlRecRespCenter);
                    wgRecCompanyInfo."Phone No." := wlRecRespCenter."Phone No.";
                    wgRecCompanyInfo."Fax No." := wlRecRespCenter."Fax No.";
                end else begin
                    wgRecCompanyInfo."Phone No." := wgCompanyInfoPhoneNo;
                    wgRecCompanyInfo."Fax No." := wgCompanyInfoFaxNo;
                    wgCduFormatAddr.Company(wgCompanyAddr, wgRecCompanyInfo);
                end;

                if "Salesperson Code" = '' then
                    Clear(wgRecSalesPurchPerson)
                else
                    wgRecSalesPurchPerson.Get("Salesperson Code");

                wlCurrencyCode := "Currency Code";
                if wlCurrencyCode = '' then begin
                    wgRecGLSetup.TestField("LCY Code");
                    wlCurrencyCode := wgRecGLSetup."LCY Code";
                end;
                wgTotalText := StrSubstNo(Trl('Total%1'), wlCurrencyCode);
                wgTotalInclVATText := StrSubstNo(Trl('Total%1InclVAT'), wlCurrencyCode);
                wgTotalExclVATText := StrSubstNo(Trl('Total%1ExclVAT'), wlCurrencyCode);

                wgCduFormatAddr.ServiceInvBillTo(wgCustAddr, InvHdr);
                wgShowShippingAddr := wgCduFormatAddr.ServiceInvShipTo(wgShipToAddr, wgCustAddr, InvHdr);

                //Get Invoice Lines
                InvLine.Reset();
                InvLine.DeleteAll();
                ServItemLine.Reset();
                ServItemLine.DeleteAll();
                VATAmtLine.Reset();
                VATAmtLine.DeleteAll();
                wlFncGetInvoiceLines(InvHdr, InvLine); // and shipped service item lines

                //Create empty dummy line
                InvLine.Reset();
                InvLine.SetRange("Document No.", "No.");
                InvLine.SetRange("Service Item Line No.", 0);
                if InvLine.FindSet(true, false) then begin
                    wlEmptyServItemLineNo := wlFncEmptyServiceItemLine();
                    repeat
                        InvLine."Service Item Line No." := wlEmptyServItemLineNo;
                        InvLine.Modify();
                    until InvLine.Next() = 0;
                end;
                InvLine.Reset();

                //Get VAT Amount Lines
                InvLine.CalcVATAmountLines(InvHdr, VATAmtLine);
                wgTotInvDiscAmount := VATAmtLine.GetTotalInvDiscAmount();
                wgTotInvDiscBaseAmount := VATAmtLine.GetTotalInvDiscBaseAmount(InvHdr."Prices Including VAT", InvHdr."Currency Code");
                wgTotLineAmount := VATAmtLine.GetTotalLineAmount(InvHdr."Prices Including VAT", InvHdr."Currency Code");
                wgTotVATAmount := VATAmtLine.GetTotalVATAmount();
                wgTotPaymentDiscOnVAT := -(wgTotLineAmount - wgTotInvDiscAmount - VATAmtLine.GetTotalAmountInclVAT());
                wgTotAmount := VATAmtLine.GetTotalVATBase();

                //Prepare VAT Amount Lines LCY
                if (not wgRecGLSetup."Print VAT specification in LCY") or
                      (InvHdr."Currency Code" = '') or
                      (VATAmtLine.GetTotalVATAmount() = 0)
                then begin
                    wgShowVATLCY := false;
                    wgVALSpecLCYHeader := '';
                    wgVALExchRate := '';
                end
                else begin
                    wgShowVATLCY := true;
                    if wgRecGLSetup."LCY Code" = '' then
                        wgVALSpecLCYHeader := Trl('VATAmtSpecIn') + ' ' + Trl('LocalCurrency')
                    else
                        wgVALSpecLCYHeader := Trl('VATAmtSpecIn') + ' ' + Format(wgRecGLSetup."LCY Code");
                    wgRecCurrExchRate.FindCurrency(InvHdr."Posting Date", InvHdr."Currency Code", 1);
                    wgVALExchRate := StrSubstNo(Trl('ExchangeRate%1/%2'), wgRecCurrExchRate."Relational Exch. Rate Amount", wgRecCurrExchRate."Exchange Rate Amount");
                end;

                //Get Item Tracking
                TrackingSpec.Reset();
                TrackingSpec.DeleteAll();
                if wgShowLotSN then
                    wgCduItemTrackingDocMgt.RetrieveDocumentItemTracking(TrackingSpec, InvHdr."No.",
                            Database::"Service Invoice Header", 0);

                //Set HideLineDiscount
                wlRecRef.GetTable(InvHdr);
                wgHideLineDiscount := wgCduwDCR_ReportFunctions.wgFncHideLineDiscount(wlRecRef);
            end;
        }
    }

    requestpage
    {

        SaveValues = true;

        layout
        {
            area(Content)
            {
                group(Options)
                {
                    Caption = 'Options';
                    field(NoOfCopies; wgNoOfCopies)
                    {
                        ApplicationArea = All;
                        Caption = 'No. of Copies';
                    }
                    field(ShowInternalInfo; wgShowInternalInfo)
                    {
                        ApplicationArea = All;
                        Caption = 'Show Internal Information';
                    }
                    field(ShowLotSN; wgShowLotSN)
                    {
                        ApplicationArea = All;
                        Caption = 'Show Serial/Lot Number';
                    }
                }
            }
        }

        trigger OnOpenPage()
        begin
            wgNoOfCopies := 0;
            wgRequestPage := true;
        end;
    }

    trigger OnInitReport()
    begin
        wgRecGLSetup.Get();

        wgRecServSetup.Get();

        wgRecCompanyInfo.Get();
        wgCompanyInfoPhoneNo := wgRecCompanyInfo."Phone No.";
        wgCompanyInfoFaxNo := wgRecCompanyInfo."Fax No.";

        if wgRecServSetup."Logo Position on Documents" <> wgRecServSetup."Logo Position on Documents"::"No Logo" then
            wgRecCompanyInfo.CalcFields(Picture);
    end;

    trigger OnPreReport()
    begin
        wlFncInitReportSettings();
        wgPrint := wgPrint or not CurrReport.Preview;

        if not wgRequestPage then
            wgNoOfCopies := 0;
    end;

    var
        wgRecCompanyInfo: Record "Company Information";
        wgRecCurrExchRate: Record "Currency Exchange Rate";
        wgRecGLSetup: Record "General Ledger Setup";
        wgRecResource: Record Resource;
        wgRecSalesPurchPerson: Record "Salesperson/Purchaser";
        wgRecServiceCost: Record "Service Cost";
        wgRecServSetup: Record "Service Mgt. Setup";
        wgRecVATClause: Record "VAT Clause";
        wgRecWorkType: Record "Work Type";
        wgCduFormatAddr: Codeunit "Format Address";
        wgCduItemTrackingDocMgt: Codeunit "Item Tracking Doc. Management";
        wgCduServInvCountPrinted: Codeunit "Service Inv.-Printed";
        wgCduwDCR_ReportFunctions: Codeunit wDCR_ReportFunctions;
        wgCduwDCR_TranslationMgt: Codeunit wDCR_TranslationMgt;
        wgHideLineDiscount: Boolean;
        wgMonolithicVAT: Boolean;
        wgPrint: Boolean;
        wgRequestPage: Boolean;
        wgShowInternalInfo: Boolean;
        wgShowLotSN: Boolean;
        wgShowShippingAddr: Boolean;
        wgShowVATLCY: Boolean;
        wgPostedShipmentDate: Date;
        wgTotAmount: Decimal;
        wgTotInvDiscAmount: Decimal;
        wgTotInvDiscBaseAmount: Decimal;
        wgTotLineAmount: Decimal;
        wgTotPaymentDiscOnVAT: Decimal;
        wgTotVALVATAmountLCY: Decimal;
        wgTotVALVATBaseLCY: Decimal;
        wgTotVATAmount: Decimal;
        wgVALVATAmountLCY: Decimal;
        wgVALVATBaseLCY: Decimal;
        wgDateFormatHdr: Integer;
        wgFirstValueEntryNo: Integer;
        wgNoOfCopies: Integer;
        wgNoOfLoops: Integer;
        wgNoOfVATAmountLines: Integer;
        wgOutputNo: Integer;
        wgReportId: Integer;
        wgShipmentLineNextEntryNo: Integer;
        wgCompanyInfoFaxNo: Text[30];
        wgCompanyInfoPhoneNo: Text[30];
        wgCopyText: Text[30];
        wgVATAmountText: Text[30];
        wgTotalExclVATText: Text[50];
        wgTotalInclVATText: Text[50];
        wgTotalText: Text[50];
        wgVALExchRate: Text[50];
        wgVALSpecLCYHeader: Text[80];
        wgCompanyAddr: array[8] of Text[100];
        wgCustAddr: array[8] of Text[100];
        wgShipToAddr: array[8] of Text[100];
        wgDimText: Text[120];

    procedure InitializeRequest(pNoOfCopiesFrom: Integer; pShowInternalInfoFrom: Boolean; pPrintFrom: Boolean)
    begin
        wgNoOfCopies := pNoOfCopiesFrom;
        wgShowInternalInfo := pShowInternalInfoFrom;
        wgPrint := pPrintFrom;
    end;

    local procedure Trl(pLblName: Text[50]): Text
    begin
        exit(wgCduwDCR_TranslationMgt.wgFncTranslate(pLblName));
    end;

    local procedure wlFncAddBufferEntry(var vRecServInvLine: Record "Service Invoice Line"; pQtyOnShipment: Decimal; pPostingDate: Date)
    begin
        //According AddBufferEntry Report 206
        ShipmentBuf.SetRange("Document No.", vRecServInvLine."Document No.");
        ShipmentBuf.SetRange("Line No.", vRecServInvLine."Line No.");
        ShipmentBuf.SetRange("Posting Date", pPostingDate);
        if ShipmentBuf.Find('-') then begin
            ShipmentBuf.Quantity := ShipmentBuf.Quantity + pQtyOnShipment;
            ShipmentBuf.Modify();
            exit;
        end;

        ShipmentBuf."Document No." := vRecServInvLine."Document No.";
        ShipmentBuf."Line No." := vRecServInvLine."Line No.";
        ShipmentBuf."Entry No." := wgShipmentLineNextEntryNo;
        ShipmentBuf.Type := vRecServInvLine.Type;
        ShipmentBuf."No." := vRecServInvLine."No.";
        ShipmentBuf.Quantity := pQtyOnShipment;
        ShipmentBuf."Posting Date" := pPostingDate;
        ShipmentBuf.Insert();
        wgShipmentLineNextEntryNo += 1;
    end;

    local procedure wlFncAddServItemBufferEntry(var vRecServInvHeader: Record "Service Invoice Header"; var vRecServInvLine: Record "Service Invoice Line")
    var
        wlRecItemLedgEntry: Record "Item Ledger Entry";
        wlRecServShptItemLine: Record "Service Shipment Item Line";
        wlRecServShptLine: Record "Service Shipment Line";
        wlRecTmpServShptLine: Record "Service Shipment Line" temporary;
        wlRecValueEntry: Record "Value Entry";
        wlLastServItemLineNo: Integer;
    begin
        //collect all service shipment lines and determine service shipment item lines
        wlRecTmpServShptLine.DeleteAll();
        case vRecServInvLine.Type of
            Enum::"Service Line Type"::Item:
                begin
                    wlRecValueEntry.Reset();
                    wlRecValueEntry.SetCurrentKey("Document No.");
                    wlRecValueEntry.SetRange("Document No.", vRecServInvLine."Document No.");
                    wlRecValueEntry.SetRange("Document Type", wlRecValueEntry."Document Type"::"Service Invoice");
                    wlRecValueEntry.SetRange("Document Line No.", vRecServInvLine."Line No.");
                    if wlRecValueEntry.FindSet() then
                        repeat
                            wlRecItemLedgEntry.Get(wlRecValueEntry."Item Ledger Entry No.");
                            if wlRecItemLedgEntry."Document Type" = wlRecItemLedgEntry."Document Type"::"Service Shipment" then
                                if wlRecServShptLine.Get(wlRecItemLedgEntry."Document No.", wlRecItemLedgEntry."Document Line No.") then begin
                                    wlRecTmpServShptLine.Init();
                                    wlRecTmpServShptLine := wlRecServShptLine;
                                    if wlRecTmpServShptLine.Insert() then;
                                end;
                        until wlRecValueEntry.Next() = 0;
                end;
            Enum::"Service Line Type"::"G/L Account",
            Enum::"Service Line Type"::Resource,
            Enum::"Service Line Type"::Cost:
                begin
                    wlRecServShptLine.SetCurrentKey("Order No.", "Order Line No.");
                    wlRecServShptLine.SetRange("Order No.", vRecServInvHeader."Order No.");
                    wlRecServShptLine.SetRange("Order Line No.", vRecServInvLine."Line No.");
                    wlRecServShptLine.SetRange("Line No.", vRecServInvLine."Line No.");
                    wlRecServShptLine.SetRange(Type, vRecServInvLine.Type);
                    wlRecServShptLine.SetRange("No.", vRecServInvLine."No.");
                    wlRecServShptLine.SetRange("Unit of Measure Code", vRecServInvLine."Unit of Measure Code");
                    wlRecServShptLine.SetFilter(Quantity, '<>%1', 0);
                    if wlRecServShptLine.FindSet() then
                        repeat
                            wlRecTmpServShptLine.Init();
                            wlRecTmpServShptLine := wlRecServShptLine;
                            if wlRecTmpServShptLine.Insert() then;
                        until (wlRecServShptLine.Next() = 0);
                end;
        end;

        wlRecTmpServShptLine.Reset();
        if wlRecTmpServShptLine.FindSet() then
            repeat
                if wlRecTmpServShptLine."Service Item Line No." <> 0 then
                    if wlRecServShptItemLine.Get(wlRecTmpServShptLine."Document No.", wlRecTmpServShptLine."Service Item Line No.") then begin
                        ServItemLine.Init();
                        ServItemLine := wlRecServShptItemLine;
                        ServItemLine."No." := vRecServInvHeader."No.";
                        if ServItemLine.Insert() then;
                        wlLastServItemLineNo := wlRecTmpServShptLine."Service Item Line No.";
                    end;
            until wlRecTmpServShptLine.Next() = 0;

        if wlLastServItemLineNo <> 0 then begin
            vRecServInvLine."Service Item Line No." := wlLastServItemLineNo;
            vRecServInvLine.Modify();
        end else begin
            vRecServInvLine."Service Item Line No." := 0;
            vRecServInvLine.Modify();
        end;
    end;

    local procedure wlFncEmptyServiceItemLine(): Integer
    begin
        ServItemLine.Reset();
        ServItemLine.Init();
        ServItemLine."No." := InvHdr."No.";
        ServItemLine."Line No." := wlFncGetEmptyServiceItemLineNo();
        ServItemLine.Description := CopyStr(Trl('DescriptionEmptyLine'), 1, MaxStrLen(ServItemLine.Description));
        ServItemLine.Insert(false);
        exit(ServItemLine."Line No.");
    end;

    local procedure wlFncFindPostedShipmentDate(var vRecServInvLine: Record "Service Invoice Line"): Date
    var
        wlRecServShipmentBuffer2: Record "Service Shipment Buffer" temporary;
        wlRecServShipmentHeader: Record "Service Shipment Header";
    begin
        wgShipmentLineNextEntryNo := 1;
        if vRecServInvLine."Shipment No." <> '' then
            if wlRecServShipmentHeader.Get(vRecServInvLine."Shipment No.") then
                exit(wlRecServShipmentHeader."Posting Date");

        if InvHdr."Order No." = '' then
            exit(InvHdr."Posting Date");

        case vRecServInvLine.Type of
            vRecServInvLine.Type::Item:
                wlFncGenerateBufferFromValueEntry(vRecServInvLine);
            vRecServInvLine.Type::"G/L Account", vRecServInvLine.Type::Resource,
            vRecServInvLine.Type::Cost:
                wlFncGenerateBufferFromShipment(vRecServInvLine);
            vRecServInvLine.Type::" ":
                exit(0D);
        end;

        ShipmentBuf.Reset();
        ShipmentBuf.SetRange("Document No.", vRecServInvLine."Document No.");
        ShipmentBuf.SetRange("Line No.", vRecServInvLine."Line No.");
        if ShipmentBuf.Find('-') then begin
            wlRecServShipmentBuffer2 := ShipmentBuf;
            if ShipmentBuf.Next() = 0 then begin
                ShipmentBuf.Get(
                    wlRecServShipmentBuffer2."Document No.", wlRecServShipmentBuffer2."Line No.", wlRecServShipmentBuffer2."Entry No.");
                ShipmentBuf.Delete();
                exit(wlRecServShipmentBuffer2."Posting Date");
            end;
            ShipmentBuf.CalcSums(Quantity);
            if ShipmentBuf.Quantity <> vRecServInvLine.Quantity then begin
                ShipmentBuf.DeleteAll();
                exit(InvHdr."Posting Date");
            end;
        end else
            exit(InvHdr."Posting Date");
    end;

    local procedure wlFncGenerateBufferFromShipment(pRecServInvLine: Record "Service Invoice Line")
    var
        wlRecServInvHeader: Record "Service Invoice Header";
        wlRecServInvLine2: Record "Service Invoice Line";
        wlRecServShipmentHeader: Record "Service Shipment Header";
        wlRecServShipmentLine: Record "Service Shipment Line";
        wlQuantity: Decimal;
        wlTotalQuantity: Decimal;
    begin
        //According GenerateBufferFromShipment Report 206
        wlTotalQuantity := 0;
        wlRecServInvHeader.SetCurrentKey("Order No.");
        wlRecServInvHeader.SetFilter("No.", '..%1', InvHdr."No.");
        wlRecServInvHeader.SetRange("Order No.", InvHdr."Order No.");
        if wlRecServInvHeader.Find('-') then
            repeat
                wlRecServInvLine2.SetRange("Document No.", wlRecServInvHeader."No.");
                wlRecServInvLine2.SetRange("Line No.", pRecServInvLine."Line No.");
                wlRecServInvLine2.SetRange(Type, pRecServInvLine.Type);
                wlRecServInvLine2.SetRange("No.", pRecServInvLine."No.");
                wlRecServInvLine2.SetRange("Unit of Measure Code", pRecServInvLine."Unit of Measure Code");
                if wlRecServInvLine2.Find('-') then
                    repeat
                        wlTotalQuantity := wlTotalQuantity + wlRecServInvLine2.Quantity;
                    until wlRecServInvLine2.Next() = 0;
            until wlRecServInvHeader.Next() = 0;

        wlRecServShipmentLine.SetCurrentKey("Order No.", "Order Line No.");
        wlRecServShipmentLine.SetRange("Order No.", InvHdr."Order No.");
        wlRecServShipmentLine.SetRange("Order Line No.", pRecServInvLine."Line No.");
        wlRecServShipmentLine.SetRange("Line No.", pRecServInvLine."Line No.");
        wlRecServShipmentLine.SetRange(Type, pRecServInvLine.Type);
        wlRecServShipmentLine.SetRange("No.", pRecServInvLine."No.");
        wlRecServShipmentLine.SetRange("Unit of Measure Code", pRecServInvLine."Unit of Measure Code");
        wlRecServShipmentLine.SetFilter(Quantity, '<>%1', 0);

        if wlRecServShipmentLine.Find('-') then
            repeat
                if Abs(wlRecServShipmentLine.Quantity) <= Abs(wlTotalQuantity - pRecServInvLine.Quantity) then
                    wlTotalQuantity := wlTotalQuantity - wlRecServShipmentLine.Quantity
                else begin
                    if Abs(wlRecServShipmentLine.Quantity) > Abs(wlTotalQuantity) then
                        wlRecServShipmentLine.Quantity := wlTotalQuantity;
                    wlQuantity :=
                        wlRecServShipmentLine.Quantity - (wlTotalQuantity - pRecServInvLine.Quantity);

                    wlTotalQuantity := wlTotalQuantity - wlRecServShipmentLine.Quantity;
                    pRecServInvLine.Quantity := pRecServInvLine.Quantity - wlQuantity;

                    if wlRecServShipmentHeader.Get(wlRecServShipmentLine."Document No.") then
                        wlFncAddBufferEntry(
                            pRecServInvLine,
                            wlQuantity,
                            wlRecServShipmentHeader."Posting Date");
                end;
            until (wlRecServShipmentLine.Next() = 0) or (wlTotalQuantity = 0);
    end;

    local procedure wlFncGenerateBufferFromValueEntry(var vRecServInvLine: Record "Service Invoice Line")
    var
        wlRecItemLedgerEntry: Record "Item Ledger Entry";
        wlRecValueEntry: Record "Value Entry";
        wlQuantity: Decimal;
        wlTotalQuantity: Decimal;
    begin
        //According GenerateBufferFromValueEntry Report 206
        wlTotalQuantity := vRecServInvLine."Quantity (Base)";
        wlRecValueEntry.SetCurrentKey("Document No.");
        wlRecValueEntry.SetRange("Document No.", vRecServInvLine."Document No.");
        wlRecValueEntry.SetRange("Posting Date", InvHdr."Posting Date");
        wlRecValueEntry.SetRange("Item Charge No.", '');
        wlRecValueEntry.SetFilter("Entry No.", '%1..', wgFirstValueEntryNo);
        if wlRecValueEntry.Find('-') then
            repeat
                if wlRecItemLedgerEntry.Get(wlRecValueEntry."Item Ledger Entry No.") then begin
                    if vRecServInvLine."Qty. per Unit of Measure" <> 0 then
                        wlQuantity := wlRecValueEntry."Invoiced Quantity" / vRecServInvLine."Qty. per Unit of Measure"
                    else
                        wlQuantity := wlRecValueEntry."Invoiced Quantity";
                    wlFncAddBufferEntry(
                        vRecServInvLine,
                        -wlQuantity,
                        wlRecItemLedgerEntry."Posting Date");
                    wlTotalQuantity += wlRecValueEntry."Invoiced Quantity";
                end;
                wgFirstValueEntryNo := wlRecValueEntry."Entry No." + 1;
            until (wlRecValueEntry.Next() = 0) or (wlTotalQuantity = 0);
    end;

    local procedure wlFncGetEmptyServiceItemLineNo(): Integer
    begin
        ServItemLine.SetRange("No.", InvHdr."No.");
        if ServItemLine.FindLast() then
            exit(ServItemLine."Line No." + 10000)
        else
            exit(10000);
    end;

    local procedure wlFncGetInvoiceLines(var vRecServInvHeader: Record "Service Invoice Header"; var vRecServInvLine: Record "Service Invoice Line")
    var
        wlRecServInvLine: Record "Service Invoice Line";
    begin
        wlRecServInvLine.SetRange("Document No.", vRecServInvHeader."No.");
        if wlRecServInvLine.FindSet() then
            repeat
                vRecServInvLine := wlRecServInvLine;
                vRecServInvLine.Insert();
                wlFncAddServItemBufferEntry(vRecServInvHeader, vRecServInvLine); //Collect shipped item lines
            until wlRecServInvLine.Next() = 0;
    end;

    local procedure wlFncInitReportSettings()
    var
        wlCduTemplateReportHelperDCR: Codeunit TemplateReportHelperDCR;
    begin
        if wgReportId = 0 then
            Evaluate(wgReportId, (DelChr(CurrReport.ObjectId(false), '=', DelChr(CurrReport.ObjectId(false), '=', '1234567890'))));
        wgCduwDCR_TranslationMgt.wgFncSetReportId(wgReportId);
        wgDateFormatHdr := wlCduTemplateReportHelperDCR.wgFncGetHeaderDateFormat(wgReportId);
    end;
}
