report 72179 ServicePicklistDCR
{
    Caption = 'Service - Picklist';
    PreviewMode = PrintLayout;
    UsageCategory = None;

    dataset
    {
        dataitem(ServItemLine; "Service Item Line")
        {
            DataItemTableView = sorting("Document Type", "Document No.", "Line No.") where("Document Type" = const(Order));
            RequestFilterFields = "Document Type", "Document No.";
            column(Description2_2; "Description 2")
            {
            }
            column(Description_2; Description)
            {
            }
            column(ItemNo; "Item No.")
            {
            }
            column(SerialNo_2; "Serial No.")
            {
            }
            column(ServiceItemGroupCode; "Service Item Group Code")
            {
            }
            column(ServiceItemNo; "Service Item No.")
            {
            }
            column(ServiceShelfNo; "Service Shelf No.")
            {
            }
            dataitem(ServHdr; "Service Header")
            {
                DataItemLink = "Document Type" = field("Document Type"), "No." = field("Document No.");
                DataItemTableView = sorting("Document Type", "No.") where("Document Type" = const(Order));
                column(BilltoCustNo; "Bill-to Customer No.")
                {
                }
                column(CompanyAddr1; wgCompanyAddr[1])
                {
                }
                column(CompanyAddr2; wgCompanyAddr[2])
                {
                }
                column(CompanyAddr3; wgCompanyAddr[3])
                {
                }
                column(CompanyAddr4; wgCompanyAddr[4])
                {
                }
                column(CompanyAddr5; wgCompanyAddr[5])
                {
                }
                column(CompanyAddr6; wgCompanyAddr[6])
                {
                }
                column(CompanyBankAccNo; wgRecCompanyInfo."Bank Account No.")
                {
                }
                column(CompanyBankName; wgRecCompanyInfo."Bank Name")
                {
                }
                column(CompanyEMail; wgRecCompanyInfo."E-Mail")
                {
                }
                column(CompanyFaxNo; wgRecCompanyInfo."Fax No.")
                {
                }
                column(CompanyGiroNo; wgRecCompanyInfo."Giro No.")
                {
                }
                column(CompanyHomePage; wgRecCompanyInfo."Home Page")
                {
                }
                column(CompanyIBAN; wgRecCompanyInfo.IBAN)
                {
                }
                column(CompanyPhoneNo; wgRecCompanyInfo."Phone No.")
                {
                }
                column(CompanyPicture; wgRecCompanyInfo.Picture)
                {
                }
                column(CompanyRegistrationNo; wgRecCompanyInfo."Registration No.")
                {
                }
                column(CompanySWIFT; wgRecCompanyInfo."SWIFT Code")
                {
                }
                column(CompanyVATRegNo; wgRecCompanyInfo."VAT Registration No.")
                {
                }
                column(CustAddr1; wgCustAddr[1])
                {
                }
                column(CustAddr2; wgCustAddr[2])
                {
                }
                column(CustAddr3; wgCustAddr[3])
                {
                }
                column(CustAddr4; wgCustAddr[4])
                {
                }
                column(CustAddr5; wgCustAddr[5])
                {
                }
                column(CustAddr6; wgCustAddr[6])
                {
                }
                column(CustAddr7; wgCustAddr[7])
                {
                }
                column(CustAddr8; wgCustAddr[8])
                {
                }
                column(CustNo; "Customer No.")
                {
                }
                column(DocumentDate; "Document Date")
                {
                }
                column(DocumentDateText; Format("Document Date", 0, wgDateFormatHdr))
                {
                }
                column(DocumentDate_2; "Document Date")
                {
                }
                column(DocumentNo; "No.")
                {
                }
                column(DueDate; "Due Date")
                {
                }
                column(DueDateText; Format("Due Date", 0, wgDateFormatHdr))
                {
                }
                column(DueDate_2; "Due Date")
                {
                }
                column(HideLineDiscount; wgHideLineDiscount)
                {
                }
                column(LanguageCode; "Language Code")
                {
                }
                column(lblBankAccNo; Trl('BankAccNo'))
                {
                }
                column(lblBankName; Trl('BankName'))
                {
                }
                column(lblBillToAddress; Trl('BillToAddress'))
                {
                }
                column(lblBillToCustomerNo; Trl('BillToCustomerNo'))
                {
                }
                column(lblCompanyRegistrationNo; Trl('CompanyRegistrationNo'))
                {
                }
                column(lblDescription; Trl('Description'))
                {
                }
                column(lblDescription2; Trl('Description2'))
                {
                }
                column(lblDocumentDate; Trl('DocumentDate'))
                {
                }
                column(lblDueDate; Trl('DueDate'))
                {
                }
                column(lblEmail; Trl('Email'))
                {
                }
                column(lblFaxNo; Trl('FaxNo'))
                {
                }
                column(lblGiroNo; Trl('GiroNo'))
                {
                }
                column(lblGLAccountNo; Trl('GLAccountNo'))
                {
                }
                column(lblHeaderDimensions; Trl('HeaderDimensions'))
                {
                }
                column(lblHomePage; Trl('HomePage'))
                {
                }
                column(lblIBAN; Trl('IBAN'))
                {
                }
                column(lblLineDimensions; Trl('LineDimensions'))
                {
                }
                column(lblLineDiscountPerc; Trl('LineDiscountPerc'))
                {
                }
                column(lblLineNo; Trl('LineNo'))
                {
                }
                column(lblLotNo; Trl('LotNo'))
                {
                }
                column(lblNo; Trl('No'))
                {
                }
                column(lblOrderNo; Trl('OrderNo'))
                {
                }
                column(lblOutstandingQuantity; Trl('OutstandingQuantity'))
                {
                }
                column(lblPageOf; Trl('Page{0}of{1}'))
                {
                }
                column(lblPaymentTerms; Trl('PaymentTerms'))
                {
                }
                column(lblPhoneNo; Trl('PhoneNo'))
                {
                }
                column(lblQuantity; Trl('Quantity'))
                {
                }
                column(lblQuantityReservedOnInventory; Trl('QuantityReservedOnInventory'))
                {
                }
                column(lblQuantityToShip; Trl('QuantityToShip'))
                {
                }
                column(lblSalesPerson; Trl('SalesPerson'))
                {
                }
                column(lblSellToCustomerNo; Trl('SellToCustomerNo'))
                {
                }
                column(lblSerialNo; Trl('SerialNo'))
                {
                }
                column(lblShelfNo; Trl('ShelfNo'))
                {
                }
                column(lblShipment; Trl('Shipment'))
                {
                }
                column(lblShipmentDate; Trl('ShipmentDate'))
                {
                }
                column(lblShipmentMethod; Trl('ShipmentMethod'))
                {
                }
                column(lblShipToAddress; Trl('ShipToAddress'))
                {
                }
                column(lblSubtotal; Trl('Subtotal'))
                {
                }
                column(lblSWIFT; Trl('SWIFT'))
                {
                }
                column(lblTotal; Trl('Total'))
                {
                }
                column(lblTotalTransFooter; Trl('TotalTransFooter'))
                {
                }
                column(lblTotalTransHeader; Trl('TotalTransHeader'))
                {
                }
                column(lblUnitPrice; Trl('UnitPrice'))
                {
                }
                column(lblUOM; Trl('UOM'))
                {
                }
                column(lblVATRegistrationNo; Trl('VATRegistrationNo'))
                {
                }
                column(lblYourReference; Trl('YourReference'))
                {
                }
                column(PaymentTermsDesc; wgCduwDCR_TranslationMgt.wgFncGetPaymTermsTrl("Payment Terms Code"))
                {
                }
                column(PostingDate; "Posting Date")
                {
                }
                column(PostingDateText; Format("Posting Date", 0, wgDateFormatHdr))
                {
                }
                column(SalesPurchPersonName; wgRecSalesPurchPerson.Name)
                {
                }
                column(ShipmentMethodDesc; wgCduwDCR_TranslationMgt.wgFncGetShipmMethodTrl("Shipment Method Code"))
                {
                }
                column(ShipToAddr1; wgShipToAddr[1])
                {
                }
                column(ShipToAddr2; wgShipToAddr[2])
                {
                }
                column(ShipToAddr3; wgShipToAddr[3])
                {
                }
                column(ShipToAddr4; wgShipToAddr[4])
                {
                }
                column(ShipToAddr5; wgShipToAddr[5])
                {
                }
                column(ShipToAddr6; wgShipToAddr[6])
                {
                }
                column(ShipToAddr7; wgShipToAddr[7])
                {
                }
                column(ShipToAddr8; wgShipToAddr[8])
                {
                }
                column(ShipToAddrSet; wgShowShippingAddr)
                {
                }
                column(TodayText; Format(Today(), 0, wgDateFormatHdr))
                {
                }
                column(VATRegNo; "VAT Registration No.")
                {
                }
                column(YourReference; "Your Reference")
                {
                }
                dataitem(CopyLoop; "Integer")
                {
                    DataItemTableView = sorting(Number);
                    column(OutputNo; wgOutputNo)
                    {
                    }
                    column(ServPicklistTitle; StrSubstNo(Trl('ServicePicklist%1'), wgCopyText))
                    {
                    }
                    dataitem(HdrComment; "Service Comment Line")
                    {
                        DataItemLink = "Table Subtype" = field("Document Type"), "No." = field("No.");
                        DataItemLinkReference = ServHdr;
                        DataItemTableView = sorting("Table Name", "Table Subtype", "No.", Type, "Table Line No.", "Line No.") where("Table Name" = const("Service Header"), Type = const(General), "Table Line No." = const(0));
                        column(Comment_2; Comment)
                        {
                        }
                    }
                    dataitem(HeaderDim; "Dimension Set Entry")
                    {
                        DataItemLink = "Dimension Set ID" = field("Dimension Set ID");
                        DataItemLinkReference = ServHdr;
                        DataItemTableView = sorting("Dimension Set ID", "Dimension Code");
                        column(DimText; wgDimText)
                        {
                        }

                        trigger OnPreDataItem()
                        begin
                            if not wgShowInternalInfo then
                                CurrReport.Break();
                        end;

                        trigger OnAfterGetRecord()
                        begin
                            wgCduwDCR_ReportFunctions.wgFncGetDimText(HeaderDim, wgDimText);
                        end;
                    }
                    dataitem(ServLine; "Service Line")
                    {
                        DataItemTableView = sorting("Document Type", "Document No.", "Line No.");
                        UseTemporary = true;
                        column(Description; Description)
                        {
                        }
                        column(Description2; "Description 2")
                        {
                        }
                        column(LineNo; "Line No.")
                        {
                        }
                        column(No_2; "No.")
                        {
                        }
                        column(OutstandingQuantity; "Outstanding Quantity")
                        {
                        }
                        column(Quantity; Quantity)
                        {
                        }
                        column(QuantityReservedOnInventory; wgQtyReservedOnInventory)
                        {
                            DecimalPlaces = 0 : 5;
                        }
                        column(QuantityToShip; "Qty. to Ship")
                        {
                        }
                        column(ShelfNo; wgShelfNo)
                        {
                        }
                        column(Type; Format(Type))
                        {
                        }
                        column(TypeNo; Type.AsInteger())
                        {
                        }
                        column(UOM; wgCduwDCR_TranslationMgt.wgFncGetUnitOfMeaseTrl("Unit of Measure Code"))
                        {
                        }
                        dataitem(LineComment; "Service Comment Line")
                        {
                            DataItemLink = "Table Subtype" = field("Document Type"), "No." = field("Document No."), "Table Line No." = field("Line No.");
                            DataItemLinkReference = ServLine;
                            DataItemTableView = sorting("Table Name", "Table Subtype", "No.", Type, "Table Line No.", "Line No.");
                            column(Comment; Comment)
                            {
                            }
                        }
                        dataitem(LineDim; "Dimension Set Entry")
                        {
                            DataItemLink = "Dimension Set ID" = field("Dimension Set ID");
                            DataItemTableView = sorting("Dimension Set ID", "Dimension Code");
                            column(DimText_2; wgDimText)
                            {
                            }

                            trigger OnPreDataItem()
                            begin
                                if not wgShowInternalInfo then
                                    CurrReport.Break();
                            end;

                            trigger OnAfterGetRecord()
                            begin
                                wgCduwDCR_ReportFunctions.wgFncGetDimText(LineDim, wgDimText);
                            end;
                        }
                        dataitem(TrackingSpec; "Tracking Specification")
                        {
                            DataItemTableView = sorting("Entry No.");
                            UseTemporary = true;
                            column(LotNo; "Lot No.")
                            {
                            }
                            column(Quantity_4; "Quantity (Base)")
                            {
                            }
                            column(SerialNo; "Serial No.")
                            {
                            }

                            trigger OnPreDataItem()
                            begin
                                if not wgShowLotSN then
                                    CurrReport.Break();
                                Reset();
                                SetRange("Source Ref. No.", ServLine."Line No.");
                            end;
                        }

                        trigger OnPreDataItem()
                        var
                            wlMoreLines: Boolean;
                        begin
                            Reset();
                            wlMoreLines := ServLine.Find('+');
                            while wlMoreLines and (ServLine.Description = '') and (ServLine."Description 2" = '') and
                                        (ServLine."No." = '') and (ServLine.Quantity = 0) and
                                        (ServLine.Amount = 0)
                            do
                                wlMoreLines := ServLine.Next(-1) <> 0;
                            if not wlMoreLines then
                                CurrReport.Break();
                            ServLine.SetRange("Line No.", 0, ServLine."Line No.");
                        end;

                        trigger OnAfterGetRecord()
                        var
                            wlRecItem: Record Item;
                            wlRecSKU: Record "Stockkeeping Unit";
                        begin
                            if (Type = Type::Item) and ("No." <> '') then begin
                                if wlRecSKU.Get("Location Code", "No.", "Variant Code") then
                                    wgShelfNo := wlRecSKU."Shelf No."
                                else
                                    if wlRecItem.Get("No.") then
                                        wgShelfNo := wlRecItem."Shelf No."
                                    else
                                        wgShelfNo := '';

                                wgQtyReservedOnInventory := wlFncGetQuantityBaseReservedOnInventoryForServiceLine(ServLine);
                            end;

                            if (ServLine.Type = ServLine.Type::"G/L Account") and (not wgShowInternalInfo) then
                                ServLine."No." := '';
                        end;
                    }

                    trigger OnPreDataItem()
                    begin
                        wgNoOfLoops := Abs(wgNoOfCopies) + 1;
                        wgCopyText := '';
                        SetRange(Number, 1, wgNoOfLoops);
                        wgOutputNo := 1;
                    end;

                    trigger OnAfterGetRecord()
                    begin
                        if Number > 1 then begin
                            wgCopyText := CopyStr(Trl('Copy'), 1, MaxStrLen(wgCopyText));
                            ;
                            wgOutputNo += 1;
                        end;
                    end;

                    trigger OnPostDataItem()
                    begin
                        if wgPrint then
                            wgCduServCountPrinted.Run(ServHdr);
                    end;
                }

                trigger OnAfterGetRecord()
                var
                    wlRecRespCenter: Record "Responsibility Center";
                    wlCduLanguage: Codeunit Language;
                    wlCduServAmtMgt: Codeunit "Serv-Amounts Mgt.";
                    i: Integer;
                begin
                    CurrReport.Language := wlCduLanguage.GetLanguageId("Language Code");
                    wgCduwDCR_TranslationMgt.wgFncSetLanguageCode("Language Code");

                    if wlRecRespCenter.Get("Responsibility Center") then begin
                        wgCduFormatAddr.RespCenter(wgCompanyAddr, wlRecRespCenter);
                        wgRecCompanyInfo."Phone No." := wlRecRespCenter."Phone No.";
                        wgRecCompanyInfo."Fax No." := wlRecRespCenter."Fax No.";
                    end else begin
                        wgRecCompanyInfo."Phone No." := wgCompanyInfoPhoneNo;
                        wgRecCompanyInfo."Fax No." := wgCompanyInfoFaxNo;
                        wgCduFormatAddr.Company(wgCompanyAddr, wgRecCompanyInfo);
                    end;

                    if "Salesperson Code" = '' then
                        Clear(wgRecSalesPurchPerson)
                    else
                        wgRecSalesPurchPerson.Get("Salesperson Code");

                    wgCduFormatAddr.ServiceHeaderBillTo(wgCustAddr, ServHdr);

                    wgCduFormatAddr.ServiceHeaderShipTo(wgShipToAddr, ServHdr);
                    wgShowShippingAddr := "Customer No." <> "Bill-to Customer No.";
                    for i := 1 to ArrayLen(wgShipToAddr) do
                        if wgShipToAddr[i] <> wgCustAddr[i] then
                            wgShowShippingAddr := true;
                    if not wgShowShippingAddr then
                        Clear(wgShipToAddr);

                    //Get Service Lines
                    Clear(wlCduServAmtMgt);
                    ServLine.Reset();
                    ServLine.DeleteAll();
                    wlCduServAmtMgt.GetServiceLines(ServHdr, ServLine, 0);  //0 = General
                    ServLine.SetFilter("Service Item Line No.", '<>%1', ServItemLine."Line No.");
                    ServLine.DeleteAll();
                    ServLine.Reset();

                    //Get Item Tracking
                    TrackingSpec.Reset();
                    TrackingSpec.DeleteAll();
                    if wgShowLotSN then
                        wgCduItemTrackingDocMgt.RetrieveDocumentItemTracking(TrackingSpec, ServHdr."No.",
                                Database::"Service Header", ServHdr."Document Type");
                end;
            }
        }
    }

    requestpage
    {

        SaveValues = true;

        layout
        {
            area(Content)
            {
                group(Options)
                {
                    Caption = 'Options';
                    field(NoOfCopies; wgNoOfCopies)
                    {
                        ApplicationArea = All;
                        Caption = 'No. of Copies';
                    }
                    field(ShowInternalInfo; wgShowInternalInfo)
                    {
                        ApplicationArea = All;
                        Caption = 'Show Internal Information';
                    }
                    field(ShowLotSN; wgShowLotSN)
                    {
                        ApplicationArea = All;
                        Caption = 'Show Serial/Lot Number';
                    }
                }
            }
        }

        trigger OnOpenPage()
        begin
            wgNoOfCopies := 0;
            wgRequestPage := true;
        end;
    }

    trigger OnInitReport()
    begin
        wgRecGLSetup.Get();

        wgRecServSetup.Get();

        wgRecCompanyInfo.Get();
        wgCompanyInfoPhoneNo := wgRecCompanyInfo."Phone No.";
        wgCompanyInfoFaxNo := wgRecCompanyInfo."Fax No.";

        if wgRecServSetup."Logo Position on Documents" <> wgRecServSetup."Logo Position on Documents"::"No Logo" then
            wgRecCompanyInfo.CalcFields(Picture);
    end;

    trigger OnPreReport()
    begin
        wlFncInitReportSettings();
        wgPrint := wgPrint or not CurrReport.Preview;

        if not wgRequestPage then
            wgNoOfCopies := 0;
    end;

    var
        wgRecCompanyInfo: Record "Company Information";
        wgRecGLSetup: Record "General Ledger Setup";
        wgRecSalesPurchPerson: Record "Salesperson/Purchaser";
        wgRecServSetup: Record "Service Mgt. Setup";
        wgCduFormatAddr: Codeunit "Format Address";
        wgCduItemTrackingDocMgt: Codeunit "Item Tracking Doc. Management";
        wgCduServCountPrinted: Codeunit "Service-Printed";
        wgCduwDCR_ReportFunctions: Codeunit wDCR_ReportFunctions;
        wgCduwDCR_TranslationMgt: Codeunit wDCR_TranslationMgt;
        wgHideLineDiscount: Boolean;
        wgPrint: Boolean;
        wgRequestPage: Boolean;
        wgShowInternalInfo: Boolean;
        wgShowLotSN: Boolean;
        wgShowShippingAddr: Boolean;
        wgShelfNo: Code[10];
        wgQtyReservedOnInventory: Decimal;
        wgDateFormatHdr: Integer;
        wgNoOfCopies: Integer;
        wgNoOfLoops: Integer;
        wgOutputNo: Integer;
        wgReportId: Integer;
        wgCompanyInfoFaxNo: Text[30];
        wgCompanyInfoPhoneNo: Text[30];
        wgCopyText: Text[30];
        wgCompanyAddr: array[8] of Text[100];
        wgCustAddr: array[8] of Text[100];
        wgShipToAddr: array[8] of Text[100];
        wgDimText: Text[120];

    procedure InitializeRequest(pNoOfCopiesFrom: Integer; pShowInternalInfoFrom: Boolean; pPrintFrom: Boolean)
    begin
        wgNoOfCopies := pNoOfCopiesFrom;
        wgShowInternalInfo := pShowInternalInfoFrom;
        wgPrint := pPrintFrom;
    end;

    local procedure Trl(pLblName: Text[50]): Text
    begin
        exit(wgCduwDCR_TranslationMgt.wgFncTranslate(pLblName));
    end;

    local procedure wlFncGetQuantityBaseReservedOnInventoryForServiceLine(var vRecServiceLine: Record "Service Line"): Decimal
    var
        wlRecReservEntry: Record "Reservation Entry";
        wlRecReservEntry2: Record "Reservation Entry";
        wlRetQty: Decimal;
    begin
        wlRetQty := 0;
        wlRecReservEntry.SetCurrentKey(
            "Source ID", "Source Ref. No.", "Source Type", "Source Subtype",
            "Source Batch Name", "Source Prod. Order Line", "Reservation Status");
        wlRecReservEntry.SetRange("Source ID", vRecServiceLine."Document No.");
        wlRecReservEntry.SetRange("Source Ref. No.", vRecServiceLine."Line No.");
        wlRecReservEntry.SetRange("Source Type", Database::"Service Line");
        wlRecReservEntry.SetRange("Source Subtype", vRecServiceLine."Document Type");
        wlRecReservEntry.SetRange("Reservation Status", wlRecReservEntry."Reservation Status"::Reservation);
        if wlRecReservEntry.Find('-') then
            repeat
                if wlRecReservEntry2.Get(wlRecReservEntry."Entry No.", not wlRecReservEntry.Positive) and
                      (wlRecReservEntry2."Source Type" = Database::"Item Ledger Entry")
                then
                    wlRetQty += wlRecReservEntry2."Quantity (Base)";
            until wlRecReservEntry.Next() = 0;
        exit(wlRetQty);
    end;

    local procedure wlFncInitReportSettings()
    var
        wlCduTemplateReportHelperDCR: Codeunit TemplateReportHelperDCR;
    begin
        if wgReportId = 0 then
            Evaluate(wgReportId, (DelChr(CurrReport.ObjectId(false), '=', DelChr(CurrReport.ObjectId(false), '=', '1234567890'))));
        wgCduwDCR_TranslationMgt.wgFncSetReportId(wgReportId);
        wgDateFormatHdr := wlCduTemplateReportHelperDCR.wgFncGetHeaderDateFormat(wgReportId);
    end;
}
