report 72174 ServiceShipmentDCR
{
    Caption = 'Service - Shipment';
    PreviewMode = PrintLayout;
    UsageCategory = None;

    dataset
    {
        dataitem(ShptHdr; "Service Shipment Header")
        {
            DataItemTableView = sorting("No.");
            RequestFilterFields = "No.";
            RequestFilterHeading = 'Posted Service Shipment';
            column(BilltoCustNo; "Bill-to Customer No.")
            {
            }
            column(CompanyAddr1; wgCompanyAddr[1])
            {
            }
            column(CompanyAddr2; wgCompanyAddr[2])
            {
            }
            column(CompanyAddr3; wgCompanyAddr[3])
            {
            }
            column(CompanyAddr4; wgCompanyAddr[4])
            {
            }
            column(CompanyAddr5; wgCompanyAddr[5])
            {
            }
            column(CompanyAddr6; wgCompanyAddr[6])
            {
            }
            column(CompanyBankAccNo; wgRecCompanyInfo."Bank Account No.")
            {
            }
            column(CompanyBankName; wgRecCompanyInfo."Bank Name")
            {
            }
            column(CompanyEMail; wgRecCompanyInfo."E-Mail")
            {
            }
            column(CompanyFaxNo; wgRecCompanyInfo."Fax No.")
            {
            }
            column(CompanyGiroNo; wgRecCompanyInfo."Giro No.")
            {
            }
            column(CompanyHomePage; wgRecCompanyInfo."Home Page")
            {
            }
            column(CompanyIBAN; wgRecCompanyInfo.IBAN)
            {
            }
            column(CompanyPhoneNo; wgRecCompanyInfo."Phone No.")
            {
            }
            column(CompanyPicture; wgRecCompanyInfo.Picture)
            {
            }
            column(CompanyRegistrationNo; wgRecCompanyInfo."Registration No.")
            {
            }
            column(CompanySWIFT; wgRecCompanyInfo."SWIFT Code")
            {
            }
            column(CompanyVATRegNo; wgRecCompanyInfo."VAT Registration No.")
            {
            }
            column(CustAddr1; wgCustAddr[1])
            {
            }
            column(CustAddr2; wgCustAddr[2])
            {
            }
            column(CustAddr3; wgCustAddr[3])
            {
            }
            column(CustAddr4; wgCustAddr[4])
            {
            }
            column(CustAddr5; wgCustAddr[5])
            {
            }
            column(CustAddr6; wgCustAddr[6])
            {
            }
            column(CustAddr7; wgCustAddr[7])
            {
            }
            column(CustAddr8; wgCustAddr[8])
            {
            }
            column(CustAddrSet; wgShowCustAddr)
            {
            }
            column(CustNo; "Customer No.")
            {
            }
            column(DocumentDate; Format("Document Date", 0, wgDateFormatHdr))
            {
            }
            column(DocumentNo; "No.")
            {
            }
            column(FromAddr1; wgFromAddr[1])
            {
            }
            column(FromAddr2; wgFromAddr[2])
            {
            }
            column(FromAddr3; wgFromAddr[3])
            {
            }
            column(FromAddr4; wgFromAddr[4])
            {
            }
            column(FromAddr5; wgFromAddr[5])
            {
            }
            column(FromAddr6; wgFromAddr[6])
            {
            }
            column(FromAddr7; wgFromAddr[7])
            {
            }
            column(FromAddr8; wgFromAddr[8])
            {
            }
            column(LanguageCode; "Language Code")
            {
            }
            column(lblAttachedToLineNo; Trl('AttachedToLineNo'))
            {
            }
            column(lblBankAccNo; Trl('BankAccNo'))
            {
            }
            column(lblBankName; Trl('BankName'))
            {
            }
            column(lblBillToAddress; Trl('BillToAddress'))
            {
            }
            column(lblBillToCustomerNo; Trl('BillToCustomerNo'))
            {
            }
            column(lblCompanyRegistrationNo; Trl('CompanyRegistrationNo'))
            {
            }
            column(lblCrossReferenceNo; Trl('CrossReferenceNo'))
            {
            }
            column(lblDescription; Trl('Description'))
            {
            }
            column(lblDocumentDate; Trl('DocumentDate'))
            {
            }
            column(lblDocumentNo; Trl('DocumentNo'))
            {
            }
            column(lblEmail; Trl('Email'))
            {
            }
            column(lblFaultComment; Trl('FaultComment'))
            {
            }
            column(lblFaxNo; Trl('FaxNo'))
            {
            }
            column(lblFooterLine1; Trl('FooterLine1'))
            {
            }
            column(lblFooterLine2; Trl('FooterLine2'))
            {
            }
            column(lblFooterLine3; Trl('FooterLine3'))
            {
            }
            column(lblFooterLine4; Trl('FooterLine4'))
            {
            }
            column(lblGiroNo; Trl('GiroNo'))
            {
            }
            column(lblGLAccountNo; Trl('GLAccountNo'))
            {
            }
            column(lblGrossWeight; Trl('GrossWeight'))
            {
            }
            column(lblHeaderDimensions; Trl('HeaderDimensions'))
            {
            }
            column(lblHomePage; Trl('HomePage'))
            {
            }
            column(lblIBAN; Trl('IBAN'))
            {
            }
            column(lblLineDimensions; Trl('LineDimensions'))
            {
            }
            column(lblLineNo; Trl('LineNo'))
            {
            }
            column(lblLocationCode; Trl('LocationCode'))
            {
            }
            column(lblLotNo; Trl('LotNo'))
            {
            }
            column(lblMobilePhoneNo; Trl('MobilePhoneNo'))
            {
            }
            column(lblNeededByDate; Trl('NeededByDate'))
            {
            }
            column(lblNetWeight; Trl('NetWeight'))
            {
            }
            column(lblNo; Trl('No'))
            {
            }
            column(lblOrderDate; Trl('OrderDate'))
            {
            }
            column(lblOrderNo; Trl('OrderNo'))
            {
            }
            column(lblPageOf; Trl('Page{0}of{1}'))
            {
            }
            column(lblPhoneNo; Trl('PhoneNo'))
            {
            }
            column(lblPickList; Trl('PickList'))
            {
            }
            column(lblPostingDate; Trl('PostingDate'))
            {
            }
            column(lblPostPaidDelivery; Trl('PostPaidDelivery'))
            {
            }
            column(lblQtyInvoicedBase; Trl('QtyInvoicedBase'))
            {
            }
            column(lblQtyPerUOM; Trl('QtyPerUOM'))
            {
            }
            column(lblQuantity; Trl('Quantity'))
            {
            }
            column(lblQuantityBase; Trl('QuantityBase'))
            {
            }
            column(lblQuantityInvoiced; Trl('QuantityInvoiced'))
            {
            }
            column(lblQuantityStillToShip; Trl('QuantityStillToShip'))
            {
            }
            column(lblResolutionComment; Trl('ResolutionComment'))
            {
            }
            column(lblSalesPerson; Trl('SalesPerson'))
            {
            }
            column(lblSellToCustomerNo; Trl('SellToCustomerNo'))
            {
            }
            column(lblSerialNo; Trl('SerialNo'))
            {
            }
            column(lblServItemGroup; Trl('ServItemGroup'))
            {
            }
            column(lblShipment; Trl('Shipment'))
            {
            }
            column(lblShipmentDate; Trl('ShipmentDate'))
            {
            }
            column(lblShipmentMethod; Trl('ShipmentMethod'))
            {
            }
            column(lblShipmentNo; Trl('ShipmentNo'))
            {
            }
            column(lblShipToAddress; Trl('ShipToAddress'))
            {
            }
            column(lblSubtotal; Trl('Subtotal'))
            {
            }
            column(lblSWIFT; Trl('SWIFT'))
            {
            }
            column(lblTotal; Trl('Total'))
            {
            }
            column(lblTotalTransFooter; Trl('TotalTransFooter'))
            {
            }
            column(lblTotalTransHeader; Trl('TotalTransHeader'))
            {
            }
            column(lblType; Trl('Type'))
            {
            }
            column(lblUnitCost; Trl('UnitCost'))
            {
            }
            column(lblUnitCostLCY; Trl('UnitCostLCY'))
            {
            }
            column(lblUnitsPerParcel; Trl('UnitsPerParcel'))
            {
            }
            column(lblUOM; Trl('UOM'))
            {
            }
            column(lblUOMCode; Trl('UOMCode'))
            {
            }
            column(lblVATPerc; Trl('VATPerc'))
            {
            }
            column(lblVATRegistrationNo; Trl('VATRegistrationNo'))
            {
            }
            column(lblYourReference; Trl('YourReference'))
            {
            }
            column(LocationCode; "Location Code")
            {
            }
            column(OrderContactMobilePhoneNo; wgRecOrderContact."Mobile Phone No.")
            {
            }
            column(OrderContactPhoneNo; wgRecOrderContact."Phone No.")
            {
            }
            column(OrderDate; Format("Order Date", 0, wgDateFormatHdr))
            {
            }
            column(OrderNo; "Order No.")
            {
            }
            column(PostingDate; Format("Posting Date", 0, wgDateFormatHdr))
            {
            }
            column(SalesPurchPersonName; wgRecSalesPurchPerson.Name)
            {
            }
            column(ShippingAgent; wgRecShippingAgent.Name)
            {
            }
            column(ShipToAddr1; wgShipToAddr[1])
            {
            }
            column(ShipToAddr2; wgShipToAddr[2])
            {
            }
            column(ShipToAddr3; wgShipToAddr[3])
            {
            }
            column(ShipToAddr4; wgShipToAddr[4])
            {
            }
            column(ShipToAddr5; wgShipToAddr[5])
            {
            }
            column(ShipToAddr6; wgShipToAddr[6])
            {
            }
            column(ShipToAddr7; wgShipToAddr[7])
            {
            }
            column(ShipToAddr8; wgShipToAddr[8])
            {
            }
            column(ShowCorrectionLines; wgShowCorrectionLines)
            {
            }
            column(ShowLotSN; wgShowLotSN)
            {
            }
            column(TodayText; Format(Today(), 0, wgDateFormatHdr))
            {
            }
            column(VATRegNo; "VAT Registration No.")
            {
            }
            column(WarehouseCity; wgRecLocation.City)
            {
            }
            column(YourReference; "Your Reference")
            {
            }
            dataitem(CopyLoop; "Integer")
            {
                DataItemTableView = sorting(Number);
                column(OutputNo; wgOutputNo)
                {
                }
                column(ServShipmentTitle; StrSubstNo(Trl('ServiceShipment%1'), wgCopyText))
                {
                }
                dataitem(HdrComment; "Service Comment Line")
                {
                    DataItemLink = "No." = field("No.");
                    DataItemLinkReference = ShptHdr;
                    DataItemTableView = sorting("Table Name", "Table Subtype", "No.", Type, "Table Line No.", "Line No.") where("Table Name" = const("Service Shipment Header"), Type = const(General), "Table Line No." = const(0));
                    column(Comment_2; Comment)
                    {
                    }
                }
                dataitem(HeaderDim; "Dimension Set Entry")
                {
                    DataItemLink = "Dimension Set ID" = field("Dimension Set ID");
                    DataItemLinkReference = ShptHdr;
                    DataItemTableView = sorting("Dimension Set ID", "Dimension Code");
                    column(DimText; wgDimText)
                    {
                    }

                    trigger OnPreDataItem()
                    begin
                        if not wgShowInternalInfo then
                            CurrReport.Break();
                    end;

                    trigger OnAfterGetRecord()
                    begin
                        wgCduwDCR_ReportFunctions.wgFncGetDimText(HeaderDim, wgDimText);
                    end;
                }
                dataitem(ShptItemLine; "Service Shipment Item Line")
                {
                    DataItemLink = "No." = field("No.");
                    DataItemLinkReference = ShptHdr;
                    DataItemTableView = sorting("No.", "Line No.");
                    column(ContractNo; "Contract No.")
                    {
                    }
                    column(CustomerNo; "Customer No.")
                    {
                    }
                    column(Description2_2; "Description 2")
                    {
                    }
                    column(Description_2; Description)
                    {
                    }
                    column(FaultCode; "Fault Code")
                    {
                    }
                    column(FaultReasonCode; "Fault Reason Code")
                    {
                    }
                    column(FinishingDate; "Finishing Date")
                    {
                    }
                    column(FinishingTime; "Finishing Time")
                    {
                    }
                    column(ItemNo; "Item No.")
                    {
                    }
                    column(LocationofServiceItem; "Location of Service Item")
                    {
                    }
                    column(Priority; Priority)
                    {
                    }
                    column(ResolutionCode; "Resolution Code")
                    {
                    }
                    column(ResponseDate; "Response Date")
                    {
                    }
                    column(ResponseTime; "Response Time")
                    {
                    }
                    column(SerialNo_2; "Serial No.")
                    {
                    }
                    column(ServiceItemGroupCode; "Service Item Group Code")
                    {
                    }
                    column(ServiceItemNo; "Service Item No.")
                    {
                    }
                    column(ServicePriceGroupCode; "Service Price Group Code")
                    {
                    }
                    column(ServiceShelfNo; "Service Shelf No.")
                    {
                    }
                    column(ShiptoCode; "Ship-to Code")
                    {
                    }
                    column(StartingDate; "Starting Date")
                    {
                    }
                    column(StartingTime; "Starting Time")
                    {
                    }
                    column(SymptomCode; "Symptom Code")
                    {
                    }
                    column(VendorItemNo; "Vendor Item No.")
                    {
                    }
                    column(VendorNo; "Vendor No.")
                    {
                    }
                    column(Warranty; Warranty)
                    {
                    }
                    dataitem(FaultComment; "Service Comment Line")
                    {
                        DataItemLink = "No." = field("No."), "Table Line No." = field("Line No.");
                        DataItemTableView = sorting("Table Name", "Table Subtype", "No.", Type, "Table Line No.", "Line No.") where("Table Name" = const("Service Shipment Header"), Type = const(Fault));
                        column(Comment_Fault; Comment)
                        {
                        }
                    }
                    dataitem(ResolutionComment; "Service Comment Line")
                    {
                        DataItemLink = "No." = field("No."), "Table Line No." = field("Line No.");
                        DataItemTableView = sorting("Table Name", "Table Subtype", "No.", Type, "Table Line No.", "Line No.") where("Table Name" = const("Service Shipment Header"), Type = const(Resolution));
                        column(Comment_Resolution; Comment)
                        {
                        }
                    }
                    dataitem(ShptLine; "Service Shipment Line")
                    {
                        DataItemLink = "Document No." = field("No."), "Service Item Line No." = field("Line No.");
                        DataItemTableView = sorting("Document No.", "Line No.");
                        column(AttachedToLineNo; "Attached to Line No.")
                        {
                        }
                        column(Description; Description)
                        {
                        }
                        column(Description2; "Description 2")
                        {
                        }
                        column(GrossWeight; Quantity * "Gross Weight")
                        {
                        }
                        column(LineNo; "Line No.")
                        {
                        }
                        column(NetWeight; Quantity * "Net Weight")
                        {
                        }
                        column(No_2; "No.")
                        {
                        }
                        column(QtyInvoicedBase; "Qty. Invoiced (Base)")
                        {
                        }
                        column(QtyPerUOM; "Qty. per Unit of Measure")
                        {
                        }
                        column(Quantity; Quantity)
                        {
                        }
                        column(QuantityBase; "Quantity (Base)")
                        {
                        }
                        column(QuantityInvoiced; "Quantity Invoiced")
                        {
                        }
                        column(ServItemNo_2; "Service Item No.")
                        {
                        }
                        column(Type; Format(Type))
                        {
                        }
                        column(TypeNo; Type.AsInteger())
                        {
                        }
                        column(UnitCost; "Unit Cost")
                        {
                        }
                        column(UnitCostLCY; "Unit Cost (LCY)")
                        {
                        }
                        column(UnitPrice; "Unit Price")
                        {
                            AutoFormatExpression = "Currency Code";
                            AutoFormatType = 2;
                        }
                        column(UnitsPerParcel; "Units per Parcel")
                        {
                        }
                        column(UOM; wgCduwDCR_TranslationMgt.wgFncGetUnitOfMeaseTrl("Unit of Measure Code"))
                        {
                        }
                        column(UOMCode; "Unit of Measure Code")
                        {
                        }
                        column(VATPerc_3; "VAT %")
                        {
                        }
                        dataitem(LineComment; "Service Comment Line")
                        {
                            DataItemLink = "No." = field("Document No."), "Table Line No." = field("Line No.");
                            DataItemLinkReference = ShptLine;
                            DataItemTableView = sorting("Table Name", "Table Subtype", "No.", Type, "Table Line No.", "Line No.") where("Table Name" = const("Service Shipment Header"), Type = const(General));
                            column(Comment_3; Comment)
                            {
                            }
                        }
                        dataitem(LineDim; "Dimension Set Entry")
                        {
                            DataItemLink = "Dimension Set ID" = field("Dimension Set ID");
                            DataItemTableView = sorting("Dimension Set ID", "Dimension Code");
                            column(DimText_2; wgDimText)
                            {
                            }

                            trigger OnPreDataItem()
                            begin
                                if not wgShowInternalInfo then
                                    CurrReport.Break();
                            end;

                            trigger OnAfterGetRecord()
                            begin
                                wgCduwDCR_ReportFunctions.wgFncGetDimText(LineDim, wgDimText);
                            end;
                        }
                        dataitem(TrackingSpec; "Tracking Specification")
                        {
                            DataItemTableView = sorting("Entry No.");
                            UseTemporary = true;
                            column(LotNo; "Lot No.")
                            {
                            }
                            column(Quantity_4; "Quantity (Base)")
                            {
                            }
                            column(SerialNo; "Serial No.")
                            {
                            }

                            trigger OnPreDataItem()
                            begin
                                if not wgShowLotSN then
                                    CurrReport.Break();

                                Reset();
                                SetRange("Source Ref. No.", ShptLine."Line No.");
                                wgTotalTrackingQty := 0;
                            end;

                            trigger OnAfterGetRecord()
                            begin
                                wgTotalTrackingQty += TrackingSpec."Quantity (Base)";
                            end;
                        }

                        trigger OnPreDataItem()
                        var
                            wlMoreLines: Boolean;
                        begin
                            wlMoreLines := ShptLine.Find('+');
                            while wlMoreLines and (Description = '') and ("No." = '') and (Quantity = 0) do
                                wlMoreLines := Next(-1) <> 0;
                            if not wlMoreLines then
                                CurrReport.Break();
                            SetRange("Line No.", 0, "Line No.");
                            wgTotalGrossWeight := 0;
                            wgTotalNetWeight := 0;
                        end;

                        trigger OnAfterGetRecord()
                        begin
                            if not wgShowCorrectionLines and Correction then
                                CurrReport.Skip();

                            wgTotalGrossWeight += (Quantity * "Gross Weight");
                            wgTotalNetWeight += (Quantity * "Net Weight");
                        end;
                    }
                }
                dataitem(Total; "Integer")
                {
                    DataItemTableView = sorting(Number) where(Number = const(1));
                    column(TotalGrossWeight; wgTotalGrossWeight)
                    {
                    }
                    column(TotalNetWeight; wgTotalNetWeight)
                    {
                    }
                    column(TotalTrackingQty; wgTotalTrackingQty)
                    {
                    }
                }

                trigger OnPreDataItem()
                begin
                    wgNoOfLoops := Abs(wgNoOfCopies) + 1;
                    wgCopyText := '';
                    SetRange(Number, 1, wgNoOfLoops);
                    wgOutputNo := 1;
                end;

                trigger OnAfterGetRecord()
                begin
                    if Number > 1 then begin
                        wgCopyText := CopyStr(Trl('Copy'), 1, MaxStrLen(wgCopyText));
                        ;
                        wgOutputNo += 1;
                    end;
                end;

                trigger OnPostDataItem()
                begin
                    if wgPrint then
                        wgCduServCountPrinted.Run(ShptHdr);
                end;
            }

            trigger OnAfterGetRecord()
            var
                wlRecRespCenter: Record "Responsibility Center";
                wlCduLanguage: Codeunit Language;
                i: Integer;
            begin
                CurrReport.Language := wlCduLanguage.GetLanguageIdOrDefault("Language Code");
                wgCduwDCR_TranslationMgt.wgFncSetLanguageCode("Language Code");

                if wlRecRespCenter.Get("Responsibility Center") then begin
                    wgCduFormatAddr.RespCenter(wgCompanyAddr, wlRecRespCenter);
                    wgRecCompanyInfo."Phone No." := wlRecRespCenter."Phone No.";
                    wgRecCompanyInfo."Fax No." := wlRecRespCenter."Fax No.";
                end else begin
                    wgRecCompanyInfo."Phone No." := wgCompanyInfoPhoneNo;
                    wgRecCompanyInfo."Fax No." := wgCompanyInfoFaxNo;
                    wgCduFormatAddr.Company(wgCompanyAddr, wgRecCompanyInfo);
                end;

                if "Salesperson Code" = '' then
                    Clear(wgRecSalesPurchPerson)
                else
                    wgRecSalesPurchPerson.Get("Salesperson Code");

                wgCduFormatAddr.ServiceShptSellTo(wgCustAddr, ShptHdr);
                wgCduFormatAddr.ServiceShptShipTo(wgShipToAddr, ShptHdr);
                wgShowCustAddr := "Customer No." <> "Bill-to Customer No.";
                for i := 1 to ArrayLen(wgCustAddr) do
                    if wgCustAddr[i] <> wgShipToAddr[i] then
                        wgShowCustAddr := true;
                if not wgShowCustAddr then
                    Clear(wgCustAddr);

                //Get Item Tracking
                TrackingSpec.Reset();
                TrackingSpec.DeleteAll();
                if wgShowLotSN then begin
                    wgCduItemTrackingDocMgt.SetRetrieveAsmItemTracking(true);
                    wgCduItemTrackingDocMgt.RetrieveDocumentItemTracking(TrackingSpec, ShptHdr."No.",
                            Database::"Service Shipment Header", 0);
                end;

                // Retrieve order contact info
                if not wgRecOrderContact.Get("Contact No.") then
                    Clear(wgRecOrderContact);

                if not wgRecLocation.Get("Location Code") then
                    Clear(wgRecLocation);

                wgCduFormatAddr.FormatAddr(wgFromAddr, "Ship-to Name", "Ship-to Name 2", "Ship-to Contact", "Ship-to Address",
                "Ship-to Address 2", "Ship-to City", "Ship-to Post Code", "Ship-to County", "Ship-to Country/Region Code");
            end;
        }
    }

    requestpage
    {

        SaveValues = true;

        layout
        {
            area(Content)
            {
                group(Options)
                {
                    Caption = 'Options';
                    field(NoOfCopies; wgNoOfCopies)
                    {
                        ApplicationArea = All;
                        Caption = 'No. of Copies';
                    }
                    field(ShowInternalInfo; wgShowInternalInfo)
                    {
                        ApplicationArea = All;
                        Caption = 'Show Internal Information';
                    }
                    field(ShowLotSN; wgShowLotSN)
                    {
                        ApplicationArea = All;
                        Caption = 'Show Serial/Lot Number';
                    }
                    field("Show Correction Lines"; wgShowCorrectionLines)
                    {
                        ApplicationArea = All;
                        Caption = 'Show Correction Lines';
                    }
                }
            }
        }

        trigger OnOpenPage()
        begin
            wgNoOfCopies := 0;
            wgRequestPage := true;
        end;
    }

    trigger OnInitReport()
    begin
        wgRecServSetup.Get();

        wgRecCompanyInfo.Get();
        wgCompanyInfoPhoneNo := wgRecCompanyInfo."Phone No.";
        wgCompanyInfoFaxNo := wgRecCompanyInfo."Fax No.";

        if wgRecServSetup."Logo Position on Documents" <> wgRecServSetup."Logo Position on Documents"::"No Logo" then
            wgRecCompanyInfo.CalcFields(Picture);
    end;

    trigger OnPreReport()
    begin
        wlFncInitReportSettings();
        wgPrint := wgPrint or not CurrReport.Preview;

        if not wgRequestPage then
            wgNoOfCopies := 0;
    end;

    var
        wgRecCompanyInfo: Record "Company Information";
        wgRecOrderContact: Record Contact;
        wgRecLocation: Record Location;
        wgRecSalesPurchPerson: Record "Salesperson/Purchaser";
        wgRecServSetup: Record "Service Mgt. Setup";
        wgRecShippingAgent: Record "Shipping Agent";
        wgCduFormatAddr: Codeunit "Format Address";
        wgCduItemTrackingDocMgt: Codeunit "Item Tracking Doc. Management";
        wgCduServCountPrinted: Codeunit "Service Shpt.-Printed";
        wgCduwDCR_ReportFunctions: Codeunit wDCR_ReportFunctions;
        wgCduwDCR_TranslationMgt: Codeunit wDCR_TranslationMgt;
        wgPrint: Boolean;
        wgRequestPage: Boolean;
        wgShowCorrectionLines: Boolean;
        wgShowCustAddr: Boolean;
        wgShowInternalInfo: Boolean;
        wgShowLotSN: Boolean;
        wgTotalGrossWeight: Decimal;
        wgTotalNetWeight: Decimal;
        wgTotalTrackingQty: Decimal;
        wgDateFormatHdr: Integer;
        wgNoOfCopies: Integer;
        wgNoOfLoops: Integer;
        wgOutputNo: Integer;
        wgReportId: Integer;
        wgCompanyInfoFaxNo: Text[30];
        wgCompanyInfoPhoneNo: Text[30];
        wgCopyText: Text[30];
        wgCompanyAddr: array[8] of Text[100];
        wgCustAddr: array[8] of Text[100];
        wgFromAddr: array[8] of Text[100];
        wgShipToAddr: array[8] of Text[100];
        wgDimText: Text[120];

    procedure wgFncInitializeRequest(pNoOfCopiesFrom: Integer; pShowInternalInfoFrom: Boolean; pPrintFrom: Boolean; pNewShowCorrectionLines: Boolean; pNewShowLotSN: Boolean)
    begin
        wgNoOfCopies := pNoOfCopiesFrom;
        wgShowInternalInfo := pShowInternalInfoFrom;
        wgPrint := pPrintFrom;
        wgShowCorrectionLines := pNewShowCorrectionLines;
        wgShowLotSN := pNewShowLotSN;
    end;

    local procedure Trl(pLblName: Text[50]): Text
    begin
        exit(wgCduwDCR_TranslationMgt.wgFncTranslate(pLblName));
    end;

    local procedure wlFncInitReportSettings()
    var
        wlCduTemplateReportHelperDCR: Codeunit TemplateReportHelperDCR;
    begin
        if wgReportId = 0 then
            Evaluate(wgReportId, (DelChr(CurrReport.ObjectId(false), '=', DelChr(CurrReport.ObjectId(false), '=', '1234567890'))));
        wgCduwDCR_TranslationMgt.wgFncSetReportId(wgReportId);
        wgDateFormatHdr := wlCduTemplateReportHelperDCR.wgFncGetHeaderDateFormat(wgReportId);
    end;
}
